/*
 * N.Meine 1999
 * meine@tnt.uni-hannover.de
 *
 * au_eof(a)		becomes true when there are no more samples to read
 * au_samcount(a)	returns the number of samples that have already been read/written
 * au_name(a)		returns the pointer to the name used to open the stream
 * au_channels(a)	returns the number of channels
 * au_samplerate(a)	returns the sample rate in Hz
 *
 */

#define	AUBUFSIZE	2048

typedef struct {
	const char	*name;
	FILE		*fd;
	long		sbcount;
	int		bp;
	int		channels;
	int		samrate;
	int		status;
	long		minuf,maxof;
	unsigned char	buffer[AUBUFSIZE];
} Taufi;

#define au_eof(af)		(af->bp<0)
#define au_samplerate(af)	(af->samrate)
#define au_channels(af)		(af->channels)
#define au_name(af)		(af->name)
#define au_samcount(af)		((af->sbcount+af->bp)/2)

void au_putdbl(double xd,Taufi *af);
double au_getdbl(Taufi *af);
Taufi *au_open_read(char *name);
Taufi *au_open_write(char *name,long samrate,long channels);
void au_close(Taufi *af);

