//---------------------------------------------------------------------------\ 
//
//               (C) copyright Fraunhofer - IIS (2000)
//                        All Rights Reserved
//
//   filename: PnsConformanceMain.cpp
//             
//   author  : Martin Weishart martin.weishart@iis.fhg.de
//   date    : 2000-07-05
//   contents/description: provides functions to calculate
//                         PNS conformance criteria
//
//--------------------------------------------------------------------------/


#ifdef __cplusplus
  extern "C" {
#endif 
 
#include <stdio.h>

#ifdef __cplusplus
  }
#endif

#include "CPnsConformance.h"

static int LoadPCMFile(char * refPcmfile, unsigned char * buffer, unsigned int pos, unsigned int numBytes);
static int getFileSize(char * ofile);

int main(int argc , char * argv[]){

  CPnsConformance pnsConf;

  char * Pcmfile, * refPcmfile;
  
  unsigned int frameSize, sfbSize;
    
  if ( argc != 4 ){
    /*
    fprintf(stderr,"\nSupply name of testbitstream, conformancebitstream and  1 or 2 for PNS conformance test P1 or P2\n\n ");
    */

    fprintf(stderr,"usage: pnsConformance <testbitstream> <conformancebitstream>  [option] \n");
    fprintf(stderr,"   1: spectral PNS conformance test for long blocks\n");    
    fprintf(stderr,"   2: spectral PNS conformance test for short blocks\n");    
    fprintf(stderr,"   else: temporal PNS conformance test\n"); 

    exit(1);
  }

  if ( argv[3][0] == '1' ){
    frameSize = FRAME_SIZE_LONG ;
    sfbSize = SFB_1 ;
  }
  else {
    frameSize = FRAME_SIZE_SHORT ;
    sfbSize = SFB_2 ;
  }

  Pcmfile = argv[1];
  refPcmfile = argv[2]; 
  
  fprintf(stderr,"\n\n*************************************************\n");
  fprintf(stderr,"*                                               *\n");
  fprintf(stderr,"*             PNS conformance check             *\n");
  fprintf(stderr,"*                                               *\n");
  fprintf(stderr,"******* copyright 2000 by Fraunhofer IIS ********\n\n");

  if ( argv[3][0] == '1' || argv[3][0] == '2'){

    pnsConf.CalulateSpectralConformance(Pcmfile, refPcmfile,sfbSize,frameSize);
  }
  else {

    pnsConf.CalculateTemporalConformance(Pcmfile, refPcmfile,sfbSize,frameSize);
  }
  
  return 0;
}

