/*
This software module was originally developed by AT&T
in the course of development of MPEG-4. 
This software module is an implementation of a part of one or 
more MPEG-4 tools as specified by MPEG-4. 
ISO/IEC gives users of MPEG-4 free license to this
software module or modifications thereof for use in hardware 
or software products claiming conformance to MPEG-4.
Those intending to use this software module in hardware or software
products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company,
the subsequent editors and their companies, and ISO/IEC have no
liability for use of this software module or modifications thereof
in an implementation.
Copyright is not released for non MPEG-4 conforming
products. AT&T. retains full right to use the code for its own
purpose, assign or donate the code to a third party and to
inhibit third parties from using the code for non 
MPEG-4 conforming products.
This copyright notice must be included in all copies or
derivative works. Copyright (c) 1999.
*/

#include "all.h"
#include "MP4Movies.h"

extern MC_Info mc_info_cmdline;
extern int calculatedBitrate;
extern int del_fill;

MP4Err	closeFile();
MP4Err	openInputFile( char *filename );
MP4Err	openMP4InputFile( char *filename );
int	adif_id_present();
MP4Err	getRAWinfo( MP4Handle decoderSpecificInfoH, u32 *timeScale, u8 *profile, u32 *maxBitrate, u32 *avgBitrate, u32 *bufferFullness );
MP4Err	getADIFinfo( int prog, MP4Handle decoderSpecificInfoH, u32 *timeScale, u8 *profile, u32 *maxBitrate, u32 *avgBitrate, u32 *bufferFullness );
MP4Err	getMP4info( MP4Handle decoderSpecificInfoH, u32 *timeScale, u8 *profile, u32 *maxBitrate, u32 *avgBitrate, u32 *bufferFullness );
MP4Err	getDecoderBufferSize( u32 *decoderBufferSize );
MP4Err	getSampleDuration( u32 *sampleDuration );
MP4Err	getRawDataBlock( u8 *rdb, u32 *frameLength );
long	put_adif_header( ADIF_Header source, ProgConfig my_prog_config, char *dest );
long	put_adts_header( ADTS_Header source, char *dest );
int	move_end(int count);

void init_output_CRC(int expect_header);
u16 calculate_output_CRC();
void reset_output_CRC();
