/************************* MPEG-2 NBC Audio Decoder **************************
 *                                                                           *
"This software module was originally developed by 
AT&T, Dolby Laboratories, Fraunhofer Gesellschaft IIS 
and edited by
Yoshiaki Oikawa (Sony Corporation),
Mitsuyuki Hatanaka (Sony Corporation)
in the course of development of the MPEG-2 NBC/MPEG-4 Audio standard ISO/IEC 13818-7, 
14496-1,2 and 3. This software module is an implementation of a part of one or more 
MPEG-2 NBC/MPEG-4 Audio tools as specified by the MPEG-2 NBC/MPEG-4 
Audio standard. ISO/IEC  gives users of the MPEG-2 NBC/MPEG-4 Audio 
standards free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-2 NBC/MPEG-4
Audio  standards. Those intending to use this software module in hardware or 
software products are advised that this use may infringe existing patents. 
The original developer of this software module and his/her company, the subsequent 
editors and their companies, and ISO/IEC have no liability for use of this software 
module or modifications thereof in an implementation. Copyright is not released for 
non MPEG-2 NBC/MPEG-4 Audio conforming products.The original developer
retains full right to use the code for his/her  own purpose, assign or donate the 
code to a third party and to inhibit third party from using the code for non 
MPEG-2 NBC/MPEG-4 Audio conforming products. This copyright notice must
be included in all copies or derivative works." 
Copyright(c)1996.
 *                                                                           *
 ****************************************************************************/

#include "all.h"
#include "port.h"

#ifdef MPEG4V1
#ifdef USELIB_ISOMP4
#include "MP4Movies.h"
void            init_mp4file(MP4Track* trak, MP4Handle* decoderSpecificInfoH, u32* avgBitrate);
#endif
#endif

int
main(int argc, char *argv[])
{

#ifdef MPEG4V1
#ifdef USELIB_ISOMP4
  MP4Err err;
  MP4Handle sampleH;
  MP4Handle decoderSpecificInfoH;
  MP4Track trak;
  MP4TrackReader reader;

  u32 unitSize, sampleFlags, cts, dts, avgBitrate;
#endif
#endif
  int remainingArgs, ready_bitBuffer_sim = 0;

  init_dec();

  remainingArgs = initio(argc, argv);	    /* parse command line */

#ifdef MPEG4V1
#ifdef USELIB_ISOMP4
  if ( mpeg4_header_present == 1 ) {
    init_mp4file(&trak, &decoderSpecificInfoH, &avgBitrate);
    if ((err = MP4GetHandleSize( decoderSpecificInfoH, &unitSize ))) myexit("mp4lib");
    restartio(*decoderSpecificInfoH, unitSize);
  } else {
    decoderSpecificInfoH = NULL;
    restartio(NULL,0);
  }

  if ( mpeg4_header_present == 1 ) {
    init_config((remainingArgs == 1));  /* read (and possibly print) decoderSpecificInfo */

    if ((err = MP4CreateTrackReader( trak, &reader ))) myexit("mp4lib-trackReader");
    if ((err = MP4NewHandle( 0, &sampleH ))) myexit("mp4lib");

  }
#endif
#else

  restartio();	    /* reset io counters */

#endif

  if (adif_header_present == 1) {
    if (!get_adif_header((remainingArgs == 1)))     /* read (and possibly print) adif header */
      myexit(0);
    byte_count = (nbits>>3);    /* reset bytecounter */
  }

  if (remainingArgs == 1) {
    if (adts_header_present == 1) {
      /* include show_adif for adts here */
    }

    myexit(0);
  }

  if(adts_header_present != 1){
    init();        /* initialize data structures */
  }

  /* main loop */
  for(bno = 0;; bno++) {

#ifdef MPEG4V1
#ifdef USELIB_ISOMP4
    if ( mpeg4_header_present == 1 ) {
      if (( err = MP4TrackReaderGetNextAccessUnit( reader, sampleH, &unitSize, &sampleFlags, &cts, &dts ))) {
        if (err == MP4EOF) myexit("finished");
        else myexit("mp4lib-GetTrackUnit");
      }
      restartio(*sampleH,unitSize);
    }
#endif
#endif

    dec();

    if (!ready_bitBuffer_sim) {
      if (adif_header_present) {
        ready_bitBuffer_sim=init_bitBuffer_sim(BITRATE2FRAMELEN(adif_header.bitrate),
                                               adif_header.buffer_fullness);
      }
      else if (adts_header_present) {
        ready_bitBuffer_sim=init_bitBuffer_sim(0,(adts_header.adts_buffer_fullness<<5)*channel_num);
      }
#ifdef MPEG4V1
#ifdef USELIB_ISOMP4
      else if (mpeg4_header_present) {
        ready_bitBuffer_sim=init_bitBuffer_sim(BITRATE2FRAMELEN(avgBitrate),0);
      }
#endif
#endif
      else ready_bitBuffer_sim=1;
    } else do_bitBuffer_sim();
    check_bitBuffer_sim();
  }
}
