/**********************************************************************
MPEG-4 Audio VM
LATM structs

This software module was originally developed by

Toshiyuki Nomura (NEC Corporation)

and edited by

in the course of development of the MPEG-2 AAC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 AAC/MPEG-4 Audio tools
as specified by the MPEG-2 AAC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 AAC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 AAC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
AAC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 AAC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1999.
**********************************************************************/

#ifndef _LATM_H_INCLUDED
#define _LATM_H_INCLUDED

#include "obj_descr.h"           /* typedef structs */

typedef struct {
  unsigned long allStreamSameTimeFraming;       /* 1 bit */
  unsigned long numSubFrames;                   /* 3 bit */
  unsigned long numProgram;                     /* 4 bit */
  unsigned long numLayer[16];                   /* 3 bit */
  unsigned long useSameConfig[512];             /* 1 bit */
  unsigned long frameLengthType[512];           /* 3 bit */
  unsigned long blockDelay[512];                /* 5 bit */
  unsigned long fractionalDelayPresent[512];    /* 1 bit */
  unsigned long fractionalDelay[512];           /* 8 bit */
  unsigned long frameLength[512];               /* 9 bit */
  unsigned long CELPframeLengthTableIndex[512]; /* 6 bit */
  unsigned long HVXCframeLengthTableIndex[512]; /* 1 bit */
  unsigned long otherDataPresent;               /* 1 bit */
  unsigned long otherDataLenBits;               /* 8 bit */
  unsigned long crcCheckPresent;                /* 1 bit */
  unsigned long crcCheckSum;                    /* 8 bit */
  AUDIO_SPECIFIC_CONFIG *audioSpecificConfig[512];
} STREAM_MUX_CONFIG ;

typedef struct {
  unsigned long MuxSlotLengthBits[512];
  unsigned long MuxSlotLengthCoded[512];        /* 2 bit */
  unsigned long numChunk;                       /* 4 bit */
  unsigned long chunkID[16];                    /* 4 bit */
} PAYLOAD_LENGTH_INFO ;

typedef struct {
  HANDLE_BSBITBUFFER bitBuf[512];
} PAYLOAD_MUX ;

typedef struct {
  unsigned long       useSameStreamMux;
  STREAM_MUX_CONFIG   streamMuxConfig;
  PAYLOAD_LENGTH_INFO payloadLengthInfo[8];
  PAYLOAD_MUX         payloadMux[8];
} AUDIO_MUX_ELEMENT ;

#endif
