///////////////////////////////////////////////////////////////////////////////////
//                                                                               //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                                //
//                                                                               //
// This software module was developed by                                         //
//                                                                               //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A) (ESPRIT MPEG-4 PC)  //
//                                                                               //
// in the course of development of the MPEG-4 standard. This software module is  //
// an implementation of a part of one or more MPEG-4 tools as specified by the   //
// MPEG-4 standard.                                                              //
//                                                                               //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use of the   //
// MPEG-4 standard free license to use this  software module or modifications    //
// thereof for hardware or software products claiming conformance to the         //
// MPEG-4 standard.                                                              //
//                                                                               //
// Those intending to use this software module in hardware or software           //
// products are advised that use may infringe existing  patents. The             //
// original developers of this software module and their companies, the          //
// subsequent editors and their companies, and ISO/IEC have no liability         //
// and ISO/IEC have no liability for use of this software module or              //
// modification thereof in an implementation.                                    //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////
#include "defs.h"
#include "Nodes-CSELT.h"
#include "Inline2DProxy.h"

#include "inline.h"
#include "Group2DProxy.h"

Inline2DProxy* Presenter::InitInline2D(Inline2D* pObj)
{
	return new Inline2DProxy(pObj); 
}

void Inline2DProxy ::PreRender(Effects & effects )
{
	GroupNode* pGroupNode = ((Inline2DImp*) GetObject ()) -> m_pSubScene;
	if (pGroupNode)
		((Traversable*)pGroupNode ->GetRenderingObject()) -> PreRender (effects);
} 

BOOL Inline2DProxy :: Render  (NodeField *, void *pContext)
{
	if ( ((Inline2DImp*)GetInline2D())->m_pSubScene == NULL_OBJECT)
		return TRUE;
	return ((Inline2DImp*)GetInline2D())->m_pSubScene -> Render  (GetContainer(), pContext);
}


void Inline2DProxy::UpdateTimeSensor()
{
	GroupNode* pGroupNode = ((Inline2DImp*) GetObject ()) -> m_pSubScene;

   if (pGroupNode == NULL)
			return;

   MFGenericNode *pChildren   = &pGroupNode->GetChildren();
   int            nNbChildren = pChildren->GetLength();

	for (int i = 0; i < nNbChildren; i++)
	{
		MediaObject* p= (*pChildren)[i];
		Traversable* trav = (Traversable*) p->GetRenderingObject();
		trav->UpdateTimeSensor();
	}
}/* Inline2DProxy::UpdateTimeSensor */




