// MPEG4PlayerView.cpp : implementation of the CMPEG4PlayerView class
//

#include "defs.h"
#include "Im1defs.h"
#include "trace.h"
#include "Presenter.h"
#include "MPEG4Player.h"
#include "MPEG4PlayerDoc.h"
#include "MPEG4PlayerView.h"
#include <webbrowser2.h>  

//SISF-Merge - PA
// For MPEG-2
//#include "..\..\M2DecoderPlus\M2DecoderPlus.h"
//End SISF Merge
/*-------------------------------------------------------------------------
MPEGJ 
AUTHORS:    Viswanathan Swaminathan - vishy@eng.sun.com 
			Robert Schmidt(RLS)
			Praveen Alavilli(PA) 
			YUNTAI KYONG(YT) - yuntaikyong@ieee.org
-------------------------------------------------------------------------*/


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView

IMPLEMENT_DYNCREATE(CMPEG4PlayerView, CView)

BEGIN_MESSAGE_MAP(CMPEG4PlayerView, CView)
	//{{AFX_MSG_MAP(CMPEG4PlayerView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_MESSAGE(WM_SCENE_FINISHED,  OnSceneFinished)
	ON_MESSAGE(WM_NON_FATAL_ERROR, OnNonFatalError)
	ON_MESSAGE(WM_DDRAW_PROBLEM, OnDDrawProblem)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_MESSAGE(WM_WEB_NAVIGATE, OnWebNavigate)
	ON_MESSAGE(WM_NAVIGATE, OnNavigate)
	ON_MESSAGE(	WM_WEB_HIDE, OnWebHide)
	ON_COMMAND(ID_GO_FORWARD, OnGoForward)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BEGIN_EVENTSINK_MAP(CMPEG4PlayerView, CView)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 102 /* StatusTextChange */, OnStatusTextChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 108 /* ProgressChange */, OnProgressChange, VTS_I4 VTS_I4)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 105 /* CommandStateChange */, OnCommandStateChange, VTS_I4 VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 106 /* DownloadBegin */, OnDownloadBegin, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 104 /* DownloadComplete */, OnDownloadComplete, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 113 /* TitleChange */, OnTitleChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 252 /* NavigateComplete2 */, NavigateComplete2, VTS_DISPATCH VTS_PVARIANT)
	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 250 /* BeforeNavigate2 */, BeforeNavigate2, VTS_DISPATCH VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PBOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 112 /* PropertyChange */, OnPropertyChange, VTS_BSTR)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 251 /* NewWindow2 */, OnNewWindow2, VTS_PDISPATCH VTS_PBOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 253 /* OnQuit */, OnQuit, VTS_NONE)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 254 /* OnVisible */, OnVisible, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 255 /* OnToolBar */, OnToolBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 256 /* OnMenuBar */, OnMenuBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 257 /* OnStatusBar */, OnStatusBar, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 258 /* OnFullScreen */, OnFullScreen, VTS_BOOL)
//	ON_EVENT(CMPEG4PlayerView, AFX_IDW_PANE_FIRST, 260 /* OnTheaterMode */, OnTheaterMode, VTS_BOOL)
END_EVENTSINK_MAP()



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView construction/destruction

CMPEG4PlayerView::CMPEG4PlayerView()
{
	// TODO: add construction code here

}

CMPEG4PlayerView::~CMPEG4PlayerView()
{
 delete GetApp()->m_pBrowser;
}

BOOL CMPEG4PlayerView::PreCreateWindow(CREATESTRUCT& cs)
{

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView drawing

void CMPEG4PlayerView::OnDraw(CDC* /*pDC*/)
{
	CMPEG4PlayerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	TRACE_PRINT("In CMPEG4PlayerView::OnDraw():\n");

	//Don't redraw the mpeg-4 client area if html 
	//browser is active
	if(!GetApp()->m_pBrowser->IsWindowVisible( ))

		// At this stage I'll redraw the entire window, rather than just
		// that part which has changed
		GetApp()->GetExecutive()->Paint(NULL);
	


} /* CMPEG4PlayerView::OnDraw */



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView diagnostics

#ifdef _DEBUG
void CMPEG4PlayerView::AssertValid() const
{
	CView::AssertValid();
}

void CMPEG4PlayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMPEG4PlayerDoc* CMPEG4PlayerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMPEG4PlayerDoc)));
	return (CMPEG4PlayerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView message handlers

void CMPEG4PlayerView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	// The first time that this is called, the Executive needs to
	// be created
	if (GetApp()->GetExecutive() == NULL)
		GetApp()->CreateExecutive(m_hWnd);
}

/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_MOVE,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnMouseMove */

/////////////////////////////////////////////////////////////////////////////


void CMPEG4PlayerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_DOWN,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnLButtonDown */


/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_UP,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnLButtonUp */


/////////////////////////////////////////////////////////////////////////////

//
// CMPEG4PlayerView::OnSceneFinished
//
// Call the OnSceneFinished() member in the application.
//

LONG CMPEG4PlayerView::OnSceneFinished(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	GetApp()->OnSceneFinished();
	return 0;
} /* CMPEG4PlayerView::OnSceneFinished */


/////////////////////////////////////////////////////////////////////////////

LONG CMPEG4PlayerView::OnNonFatalError(WPARAM wParam, LPARAM /*lParam*/)
{
	static LPCSTR szError [] =
	{
		"INVALID STREAm_TYPE",
		"STREAM_TYPE COLLISION",
		"NO BIFS STREAM",
		"SCENE PARSING ERROR",
		"OD PARSING ERROR",
		"OD UPDATE NOT SUPPORTED",
		"ODID COLLISION",
		"UNKNOWN ODID",
		"UPDATE ESD NOT SUPPORTED",
		"REMOVE ESD NOT SUPPORTED",
		"UNKNOWN DECODER TYPE",
		"INCOMPATIBLE DECODER TYPE",
		"NO STREAM",
		"NO STREAM_TYPE",
		"REMOTE OD REQUIRES URL",
		"UNKNOWN URL PROTOCOL",
		"BUFFER TOO SMALL",
		"DECODER SETUP FAILURE",
		"REMOTE OD REQUIRES NEW SESSION",
		"REMOTE OD FLAG REQUIRED",
		"OPEN STREAM FAILED",
		"DELETE CHANNEL FAILED",
		"DATA TRANSMISSION ERROR",
		"INVALID URL",
		"IPMP NOT AVAILABLE",
		"NO ACCESS TO PROTECTED STREAM",
		"MISSING DESCRIPTOR",
		"TOO MANY DESCRIPTORS",
		"INITIAL OBJECT DESCRIPTOR NOT FOUND",
		"NO SLCONFIG INFO",
		"ERROR IN PARSING INITIAL OBJECT DESCRIPTOR",
		"BIFS UPDATE REQUEST DOES NOT MATCH SCENE",
		"MULTIPLE ACCESS OF A SINGLE STREAM NOT PERMITTED",
		"IPMP STREAM ALREADY IN USE",
		"INVALID BIFS CONFIG",
		"CANNOT_ALTER_REMOTE_OD",
		"TRYING_TO_UPDATE_UNKNOWN_OD",
		"TRYING_TO_REMOVE_UNKNOWN_ESD",
		"OCI_PARSING_ERROR",
		"SERVICE_DETACH_FAILED",
		"SEND_COMMAND_FAILED",
		"UNEXPECTED_SERVICE_DETACH",
		"UNEXPECTED_CHANNEL_DELETE",
		"DMIF_FILTER_NOT_FOUND"
   };

	MessageBox(szError[wParam-1],"Problem",MB_OK);



 return 0L;
}
LONG CMPEG4PlayerView::OnDDrawProblem(WPARAM /*wParam*/, LPARAM lParam)
{
	
	
	GetApp()->GetExecutive()->Stop();
	

	MessageBox((char *)(lParam),"Fatal Error, press ok to close the player",MB_OK);
	
	delete [] (char *) (lParam) ;

	::PostQuitMessage(1);
	return 0L;
}


/////////////////////////////////////////////////////////////////////////////
// SISF Merge - PA
// For MPEG-2
extern class CMPEG4PlayerApp theApp;
extern RECT			   ImgDestRect ;
extern M2DECDISPLAYINFO  displayDescr;
extern  M2DecoderPlus     M2DecObj; //PA
void displayError(HRESULT) ;
extern bool bDecoderIsPlaying, startedMPEG4inMPEG2;
//ENd SISF - Merge

/////////////////////////////////////////////////////////////////////////////


void CMPEG4PlayerView::OnPaint() 
{
	((Presenter*)GetApp()->GetExecutive()->GetPresenter())->AskScreenAccess();
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	OnPrepareDC(&dc);
	OnDraw(&dc);
	if (bDecoderIsPlaying)
	{
		// For MPEG-2 application
		//PAINTSTRUCT   ps ;
		//HDC			 hdc ;	
		//CBrush cb;
		POINT         point ;												// Posizione left top corner finestra di visualizzazione		
		HRESULT		 M2Dval	;
		
		//cb.CreateSolidBrush(0x00ff00ff);
		//theApp.m_pMainWnd->BeginPaint(&ps);
		theApp.m_pMainWnd->GetClientRect(&ImgDestRect);
		//dc.FillRect(&ImgDestRect, &cb);
		//theApp.m_pMainWnd->EndPaint(&ps);

		point.x = point.y = 0 ;												// Centra l'immagine nell'area visualizzabile
		theApp.m_pMainWnd->ClientToScreen(&point) ;

		displayDescr.dx     = ImgDestRect.left + point.x ;
		displayDescr.dy     = ImgDestRect.top + point.y ;
		displayDescr.hSize  = ImgDestRect.right - ImgDestRect.left ;
		displayDescr.vSize  = ImgDestRect.bottom - ImgDestRect.top ;

		if (startedMPEG4inMPEG2)
		{

		}
		else
		{
			M2Dval = M2DecObj.M2DecSetDisplay(&displayDescr) ;
			if (M2Dval != M2D_OK)
				displayError(M2Dval) ;

			M2Dval = M2DecObj.M2DecRepaint() ;
		}

		//ValidateRect(NULL) ; //???
	}
	
	ValidateRect(NULL) ; //???

	// Do not call CView::OnPaint() for painting messages
	((Presenter*)GetApp()->GetExecutive()->GetPresenter())->ReleaseScreenAccess();
}

//html browser creation

int CMPEG4PlayerView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	//html browser control init default size
	
	CRect rect(0,0,640,480);
	


	GetApp()->m_pBrowser = new CWebBrowser2;
	
	ASSERT (GetApp()->m_pBrowser);
	
	//the webBrowser control must be created as VISIBLE
	//see BUG: WebBrowser Control Destroyed When Hidden
	//		Last reviewed: March 10, 1998
	//		Article ID: Q182111 
	// in the MICROSOFT DEVELOPER NETWORK INFO. 
	
	if (!(GetApp()->m_pBrowser->Create(NULL,NULL,WS_VISIBLE,rect,this,AFX_IDW_PANE_FIRST)))
	{
		TRACE("failed to create browser\n");
		delete GetApp()->m_pBrowser;
		GetApp()->m_pBrowser = NULL;
	}
	
	::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_HIDE );

	return 0;
}
/////////////////////////////////////////////////////////////////////////////
//general navigate request (it can be MPEG-4 or HTML) 

LONG CMPEG4PlayerView::OnNavigate(WPARAM /*wParam*/, LPARAM lParam)
{
	GetDocument()->m_fileName= (LPCSTR)lParam; 
	GetDocument()->OpenDocument();
	 return 0L;
}
////////////////////////////////////////////////////////////////////////////
//html navigate request

LONG CMPEG4PlayerView::OnWebNavigate(WPARAM /*wParam*/, LPARAM lParam)
{

  ::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_SHOWNORMAL );
   GetApp()->m_pBrowser -> Navigate((LPCSTR)lParam,NULL,NULL,NULL,NULL);

   return 0L;
}
////////////////////////////////////////////////////////////////////////////
//hide the html control
LONG CMPEG4PlayerView::OnWebHide(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	::ShowWindow( GetApp()->m_pBrowser->GetSafeHwnd(), SW_HIDE );
	 return 0L;
}

//hide html browser control 
		

//Events fired by the webbrowser control



/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView web browser control message handlers
// The events are fired from the control up to the parent window
// This is useful to catch urls before the browser processes them. 
void CMPEG4PlayerView::BeforeNavigate2(LPDISPATCH /* pDisp */, VARIANT* URL,
		VARIANT* /*Flags*/, VARIANT* /*TargetFrameName*/,
		VARIANT* /*PostData*/, VARIANT* /*Headers*/, BOOL* Cancel)
{
  	
	CString szURL((URL->bstrVal));
	
	//Find out the type of the url

	BROWSER eKind=GetDocument()->AnalyzeUrl(szURL);
	
	if(eKind==MPEG)
	{
		//pass it to the MPEG-4 Player 
		GetApp()->GetExecutive()->Start(szURL);
		
		//abort html navigation
		*Cancel=TRUE;   
		//hide web browser control
		PostMessage(WM_WEB_HIDE, NULL,NULL);
	
	}
	
}


void CMPEG4PlayerView::OnGoForward() 
{
	// TODO: Add your command handler code here
	GetApp()->OnGoForward();	
}
