///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: TransMuxChannel.h
//
// Authors: Nuno Delgado, CSELT
//
// Description:
//
///////////////////////////////////////////////////////////////////////////


#ifndef _TRANSMUX_CHANNEL_H
#define _TRANSMUX_CHANNEL_H

// Prevent inclusion of winsock.h in windows.h
#ifndef _WINSOCKAPI_
#define _WINSOCKAPI_
#endif
#include "winsock2.h"

#include "DmifPeer.h"
#include "fmt.h"

class Dai;
class DaiSession;
class CDmifPeer;

class TransMuxChannel
{
	
	private:
		Dai* m_pDai;
		DaiSession* m_pSession;
		CDmifPeer* m_pPeer;
		char* m_pBuffer;
		int m_BufferSize;
		unsigned int m_TransMuxAssocTag;
		WSAEVENT m_hEvent;		// The event is set when the socket recv or close
		int mTypeOfChannel;		// Indicates if its a TCP or UDP channel
		unsigned short m_PortNumber;
		char* pAuxx; 
		BOOL PacketHeaderAlreadyRead;
		unsigned short SpaceRemainingForPacket;   // Bytes missing for a complete packet
		unsigned short PacketSize;
		BOOL FirstByteAlreadyAvailable;


		void SendUdpPortToServer(CDmifPeer*,unsigned int,SOCKET);

	public:
		BOOL TransTagAlreadySentToClient;
		SMT mSmt;
		SOCKET m_hSocket;
		SOCKET m_hListenSocket;

		TransMuxChannel();
		TransMuxChannel(Dai*, DaiSession*, CDmifPeer*,int, unsigned int, int);
		~TransMuxChannel();

		void ReceiveData();
		BOOL operator==(const unsigned int);
		BOOL operator==(const WSAEVENT);
		void GetChannelProperties(char*);
		void UpdatePortNumber(unsigned short);
		WSAEVENT GetTransMuxEvent();

		BOOL ConnectTransChannelToServer(struct sockaddr*, int, LPWSAPROTOCOL_INFO);
		BOOL VerifySessionAndPeer(DaiSession*,CDmifPeer*);
		BOOL AcceptConnection(int(*)[6], int);
};
#endif