/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      Nodes2.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  BIFS macros for v2 node objects.
 * 
 * Comment:   Automatically generated on Thu Oct 07 04:47:50 GMT+10:00 1999
 *            at Melbourne, Australia
 *            by parsing the MPEG-4 templates.txt file.
 *            Contact: mikeseven@hotmail.com
 *
 **************************************************************************/
#include "defs.h"
#include "Im1defs.h"
#include "NodeCode.h"
#include "Nodes.h"
#include "Nodes2.h"
#include "CrNodes.h"

BIFS_IMPLEMENT_NODE_START(AcousticMaterial)
    BIFS_FIELD1(AcousticMaterial, ambientIntensity, 0, 0, 0, 0, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, diffuseColor, 1, 1, 1, 1, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, emissiveColor, 2, 2, 2, 2, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, shininess, 3, 3, 3, 3, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, specularColor, 4, 4, 4, 4, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, transparency, 5, 5, 5, 5, 4, 8, 0, 1)
    BIFS_FIELD1(AcousticMaterial, reffunc, 6, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticMaterial, transfunc, 7, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(AcousticMaterial)

BIFS_IMPLEMENT_NODE_START(AcousticScene)
    BIFS_FIELD1(AcousticScene, reverbLevel, 0, 0, 0, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbDelay, 1, 1, 1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, center, 2, -1, -1, 1, 11, 11, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, Size, 3, -1, -1, 2, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbTime, 4, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(AcousticScene, reverbFreq, 5, -1, -1, -1, 0, 0, 0, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(AcousticScene)

BIFS_IMPLEMENT_NODE_START(BAP)
    BIFS_FIELD1(BAP, sacroiliac_tilt, 0, 0, 0, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, sacroiliac_torsion, 1, 1, 1, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, sacroiliac_roll, 2, 2, 2, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_flexion, 3, 3, 3, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_flexion, 4, 4, 4, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_abduct, 5, 5, 5, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_abduct, 6, 6, 6, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_hip_twisting, 7, 7, 7, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_hip_twisting, 8, 8, 8, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_knee_flexion, 9, 9, 9, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_knee_flexion, 10, 10, 10, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_knee_twisting, 11, 11, 11, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_knee_twisting, 12, 12, 12, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ankle_flexion, 13, 13, 13, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ankle_flexion, 14, 14, 14, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ankle_twisting, 15, 15, 15, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ankle_twisting, 16, 16, 16, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_subtalar_flexion, 17, 17, 17, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_subtalar_flexion, 18, 18, 18, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_midtarsal_flexion, 19, 19, 19, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_midtarsal_flexion, 20, 20, 20, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_metatarsal_flexion, 21, 21, 21, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_metatarsal_flexion, 22, 22, 22, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_sternoclavicular_abduct, 23, 23, 23, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_sternoclavicular_abduct, 24, 24, 24, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_sternoclavicular_rotate, 25, 25, 25, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_sternoclavicular_rotate, 26, 26, 26, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_acromioclavicular_abduct, 27, 27, 27, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_acromioclavicular_abduct, 28, 28, 28, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_acromioclavicular_rotate, 29, 29, 29, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_acromioclavicular_rotate, 30, 30, 30, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_flexion, 31, 31, 31, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_flexion, 32, 32, 32, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_abduct, 33, 33, 33, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_abduct, 34, 34, 34, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_shoulder_twisting, 35, 35, 35, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_shoulder_twisting, 36, 36, 36, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_elbow_flexion, 37, 37, 37, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_elbow_flexion, 38, 38, 38, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_elbow_twisting, 39, 39, 39, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_elbow_twisting, 40, 40, 40, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_flexion, 41, 41, 41, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_flexion, 42, 42, 42, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_pivot, 43, 43, 43, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_pivot, 44, 44, 44, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_wrist_twisting, 45, 45, 45, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_wrist_twisting, 46, 46, 46, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_roll, 47, 47, 47, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_torsion, 48, 48, 48, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, skullbase_tilt, 49, 49, 49, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1roll, 50, 50, 50, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1torsion, 51, 51, 51, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc1tilt, 52, 52, 52, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2roll, 53, 53, 53, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2torsion, 54, 54, 54, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc2tilt, 55, 55, 55, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3roll, 56, 56, 56, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3torsion, 57, 57, 57, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc3tilt, 58, 58, 58, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4roll, 59, 59, 59, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4torsion, 60, 60, 60, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc4tilt, 61, 61, 61, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5roll, 62, 62, 62, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5torsion, 63, 63, 63, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc5tilt, 64, 64, 64, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6roll, 65, 65, 65, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6torsion, 66, 66, 66, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc6tilt, 67, 67, 67, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7roll, 68, 68, 68, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7torsion, 69, 69, 69, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vc7tilt, 70, 70, 70, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1roll, 71, 71, 71, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1torsion, 72, 72, 72, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt1tilt, 73, 73, 73, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2roll, 74, 74, 74, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2torsion, 75, 75, 75, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt2tilt, 76, 76, 76, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3roll, 77, 77, 77, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3torsion, 78, 78, 78, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt3tilt, 79, 79, 79, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4roll, 80, 80, 80, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4torsion, 81, 81, 81, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt4tilt, 82, 82, 82, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5roll, 83, 83, 83, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5torsion, 84, 84, 84, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt5tilt, 85, 85, 85, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6roll, 86, 86, 86, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6torsion, 87, 87, 87, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt6tilt, 88, 88, 88, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7roll, 89, 89, 89, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7torsion, 90, 90, 90, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt7tilt, 91, 91, 91, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8roll, 92, 92, 92, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8torsion, 93, 93, 93, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt8tilt, 94, 94, 94, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9roll, 95, 95, 95, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9torsion, 96, 96, 96, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt9tilt, 97, 97, 97, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10roll, 98, 98, 98, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10torsion, 99, 99, 99, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt10tilt, 100, 100, 100, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11roll, 101, 101, 101, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11torsion, 102, 102, 102, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt11tilt, 103, 103, 103, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12roll, 104, 104, 104, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12torsion, 105, 105, 105, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vt12tilt, 106, 106, 106, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1roll, 107, 107, 107, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1torsion, 108, 108, 108, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl1tilt, 109, 109, 109, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2roll, 110, 110, 110, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2torsion, 111, 111, 111, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl2tilt, 112, 112, 112, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3roll, 113, 113, 113, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3torsion, 114, 114, 114, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl3tilt, 115, 115, 115, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4roll, 116, 116, 116, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4torsion, 117, 117, 117, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl4tilt, 118, 118, 118, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5roll, 119, 119, 119, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5torsion, 120, 120, 120, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, vl5tilt, 121, 121, 121, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky0_flexion, 122, 122, 122, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky0_flexion, 123, 123, 123, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_flexion, 124, 124, 124, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_flexion, 125, 125, 125, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_pivot, 126, 126, 126, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_pivot, 127, 127, 127, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky1_twisting, 128, 128, 128, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky1_twisting, 129, 129, 129, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky2_flexion, 130, 130, 130, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky2_flexion, 131, 131, 131, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_pinky3_flexion, 132, 132, 132, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_pinky3_flexion, 133, 133, 133, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring0_flexion, 134, 134, 134, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring0_flexion, 135, 135, 135, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_flexion, 136, 136, 136, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_flexion, 137, 137, 137, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_pivot, 138, 138, 138, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_pivot, 139, 139, 139, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring1_twisting, 140, 140, 140, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring1_twisting, 141, 141, 141, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring2_flexion, 142, 142, 142, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring2_flexion, 143, 143, 143, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_ring3_flexion, 144, 144, 144, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_ring3_flexion, 145, 145, 145, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle0_flexion, 146, 146, 146, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle0_flexion, 147, 147, 147, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_flexion, 148, 148, 148, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_flexion, 149, 149, 149, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_pivot, 150, 150, 150, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_pivot, 151, 151, 151, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle1_twisting, 152, 152, 152, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle1_twisting, 153, 153, 153, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle2_flexion, 154, 154, 154, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle2_flexion, 155, 155, 155, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_middle3_flexion, 156, 156, 156, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_middle3_flexion, 157, 157, 157, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index0_flexion, 158, 158, 158, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index0_flexion, 159, 159, 159, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_flexion, 160, 160, 160, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_flexion, 161, 161, 161, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_pivot, 162, 162, 162, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_pivot, 163, 163, 163, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index1_twisting, 164, 164, 164, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index1_twisting, 165, 165, 165, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index2_flexion, 166, 166, 166, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index2_flexion, 167, 167, 167, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_index3_flexion, 168, 168, 168, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_index3_flexion, 169, 169, 169, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_flexion, 170, 170, 170, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_flexion, 171, 171, 171, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_pivot, 172, 172, 172, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_pivot, 173, 173, 173, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb1_twisting, 174, 174, 174, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb1_twisting, 175, 175, 175, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb2_flexion, 176, 176, 176, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb2_flexion, 177, 177, 177, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, l_thumb3_flexion, 178, 178, 178, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, r_thumb3_flexion, 179, 179, 179, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_vertical, 180, 180, 180, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_lateral, 181, 181, 181, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_tr_frontal, 182, 182, 182, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_turn, 183, 183, 183, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_roll, 184, 184, 184, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, HumanoidRoot_rt_body_tilt, 185, 185, 185, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap187, 186, 186, 186, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap188, 187, 187, 187, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap189, 188, 188, 188, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap190, 189, 189, 189, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap191, 190, 190, 190, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap192, 191, 191, 191, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap193, 192, 192, 192, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap194, 193, 193, 193, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap195, 194, 194, 194, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap196, 195, 195, 195, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap197, 196, 196, 196, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap198, 197, 197, 197, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap199, 198, 198, 198, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap200, 199, 199, 199, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap201, 200, 200, 200, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap202, 201, 201, 201, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap203, 202, 202, 202, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap204, 203, 203, 203, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap205, 204, 204, 204, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap206, 205, 205, 205, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap207, 206, 206, 206, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap208, 207, 207, 207, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap209, 208, 208, 208, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap210, 209, 209, 209, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap211, 210, 210, 210, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap212, 211, 211, 211, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap213, 212, 212, 212, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap214, 213, 213, 213, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap215, 214, 214, 214, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap216, 215, 215, 215, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap217, 216, 216, 216, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap218, 217, 217, 217, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap219, 218, 218, 218, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap220, 219, 219, 219, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap221, 220, 220, 220, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap222, 221, 221, 221, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap223, 222, 222, 222, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap224, 223, 223, 223, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap225, 224, 224, 224, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap226, 225, 225, 225, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap227, 226, 226, 226, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap228, 227, 227, 227, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap229, 228, 228, 228, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap230, 229, 229, 229, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap231, 230, 230, 230, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap232, 231, 231, 231, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap233, 232, 232, 232, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap234, 233, 233, 233, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap235, 234, 234, 234, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap236, 235, 235, 235, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap237, 236, 236, 236, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap238, 237, 237, 237, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap239, 238, 238, 238, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap240, 239, 239, 239, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap241, 240, 240, 240, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap242, 241, 241, 241, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap243, 242, 242, 242, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap244, 243, 243, 243, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap245, 244, 244, 244, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap246, 245, 245, 245, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap247, 246, 246, 246, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap248, 247, 247, 247, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap249, 248, 248, 248, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap250, 249, 249, 249, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap251, 250, 250, 250, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap252, 251, 251, 251, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap253, 252, 252, 252, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap254, 253, 253, 253, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap255, 254, 254, 254, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap256, 255, 255, 255, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap257, 256, 256, 256, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap258, 257, 257, 257, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap259, 258, 258, 258, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap260, 259, 259, 259, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap261, 260, 260, 260, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap262, 261, 261, 261, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap263, 262, 262, 262, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap264, 263, 263, 263, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap265, 264, 264, 264, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap266, 265, 265, 265, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap267, 266, 266, 266, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap268, 267, 267, 267, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap269, 268, 268, 268, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap270, 269, 269, 269, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap271, 270, 270, 270, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap272, 271, 271, 271, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap273, 272, 272, 272, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap274, 273, 273, 273, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap275, 274, 274, 274, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap276, 275, 275, 275, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap277, 276, 276, 276, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap278, 277, 277, 277, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap279, 278, 278, 278, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap280, 279, 279, 279, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap281, 280, 280, 280, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap282, 281, 281, 281, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap283, 282, 282, 282, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap284, 283, 283, 283, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap285, 284, 284, 284, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap286, 285, 285, 285, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap287, 286, 286, 286, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap288, 287, 287, 287, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap289, 288, 288, 288, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap290, 289, 289, 289, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap291, 290, 290, 290, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap292, 291, 291, 291, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap293, 292, 292, 292, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap294, 293, 293, 293, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap295, 294, 294, 294, -1, 0, 0, INT_MIN, INT_MAX)
    BIFS_FIELD1(BAP, extensionBap296, 295, 295, 295, -1, 0, 0, INT_MIN, INT_MAX)
BIFS_IMPLEMENT_NODE_END(BAP)

BIFS_IMPLEMENT_NODE_START(BDP)
    BIFS_FIELD(BDP, bodyDefTables, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(BDP, bodySceneGraph, 1, 1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(BDP)

BIFS_IMPLEMENT_NODE_START(Body)
    BIFS_FIELD(Body, bdp, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(Body, bap, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(Body, renderedBody, 2, 2, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Body)

BIFS_IMPLEMENT_NODE_START(BodyDefTable)
    BIFS_FIELD(BodyDefTable, bodySceneGraphNodeName, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD1_SQ(BodyDefTable, bapIDs, 1, 1, 1, -1, 13, 9, 0, 1, 296)
    BIFS_FIELD1(BodyDefTable, vertexIds, 2, 2, 2, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(BodyDefTable, bapCombinations, 3, 3, 3, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(BodyDefTable, displacements, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD1(BodyDefTable, numInterpolateKeys, 5, 5, 5, -1, 0, 0, 2, INT_MAX)
BIFS_IMPLEMENT_NODE_END(BodyDefTable)

BIFS_IMPLEMENT_NODE_START(BodySegmentConnectionHint)
    BIFS_FIELD(BodySegmentConnectionHint, firstSegmentNodeName, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(BodySegmentConnectionHint, secondSegmentNodeName, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(BodySegmentConnectionHint, firstVertexIdList, 2, 2, 2, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD1(BodySegmentConnectionHint, secondVertexIdList, 3, 3, 3, -1, 0, 0, -1, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(BodySegmentConnectionHint)

BIFS_IMPLEMENT_NODE_START(DirectiveSound)
    BIFS_FIELD1(DirectiveSound, direction, 0, 0, 0, 0, 9, 9, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, intensity, 1, 1, 1, 1, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, location, 2, 2, 2, 2, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(DirectiveSound, source, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, perceptualParameters, 4, 4, 4, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, roomEffect, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(DirectiveSound, spatialize, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD1(DirectiveSound, angles, 7, -1, -1, 3, 6, 8, 0, 3.14159265)
    BIFS_FIELD1(DirectiveSound, directivity, 8, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, speedOfSound, 9, -1, -1, 4, 1, 1, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(DirectiveSound, distance, 10, -1, -1, -1, 0, 0, -FLT_MAX, FLT_MAX)
    BIFS_FIELD(DirectiveSound, useAirabs, 11, -1, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(DirectiveSound)

BIFS_IMPLEMENT_NODE_START(Hierarchical3DMesh)
    BIFS_EVENT(Hierarchical3DMesh, triangleBudget, 0, -1, 0, 0)
    BIFS_FIELD1(Hierarchical3DMesh, level, 0, 1, 0, -1, 0, 0, -1, FLT_MAX)
    BIFS_FIELD(Hierarchical3DMesh, url, 1, -1, -1, -1, 0, 0)
    BIFS_FIELD(Hierarchical3DMesh, doneLoading, -1, -1, 1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(Hierarchical3DMesh)

BIFS_IMPLEMENT_NODE_START(MaterialKey)
    BIFS_FIELD(MaterialKey, isKeyed, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(MaterialKey, isRGB, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD1(MaterialKey, keyColor, 2, 2, 2, 0, 4, 4, 0, 1)
    BIFS_FIELD1(MaterialKey, lowThreshold, 3, 3, 3, 1, 4, 8, 0, 1)
    BIFS_FIELD1(MaterialKey, highThreshold, 4, 4, 4, 2, 4, 8, 0, 1)
    BIFS_FIELD1(MaterialKey, transparency, 5, 5, 5, 3, 4, 8, 0, 1)
BIFS_IMPLEMENT_NODE_END(MaterialKey)

BIFS_IMPLEMENT_NODE_START(PerceptualParameters)
    BIFS_FIELD1(PerceptualParameters, sourcePresence, 0, 0, 0, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, sourceWarmth, 1, 1, 1, 1, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, sourceBrilliance, 2, 2, 2, 2, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, roomPresence, 3, 3, 3, 3, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, runningReverberance, 4, 4, 4, 4, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, envelopment, 5, 5, 5, 5, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, lateReverberance, 6, 6, 6, 6, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, heavyness, 7, 7, 7, 7, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, liveness, 8, 8, 8, 8, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, omniDirectivity, 9, 9, 9, 9, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, directFilterGains, 10, 10, 10, 10, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, inputFilterGains, 11, 11, 11, 11, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, refDistance, 12, 12, 12, 12, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, freqLow, 13, 13, 13, 13, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, freqHigh, 14, 14, 14, 14, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit1, 15, 15, 15, 15, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit2, 16, 16, 16, 16, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, timeLimit3, 17, 17, 17, 17, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(PerceptualParameters, modalDensity, 18, 18, 18, 18, 0, 7, -FLT_MAX, FLT_MAX)
BIFS_IMPLEMENT_NODE_END(PerceptualParameters)

BIFS_IMPLEMENT_NODE_START(ServerCommand)
    BIFS_EVENT(ServerCommand, trigger, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, enable, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, url, 1, 2, 1, -1, 0, 0)
    BIFS_EVENT(ServerCommand, command, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ServerCommand)

/* End of automatically generated file */
