/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      Nodes2.h
 * AUTHOR:    Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  Declaration of nodes and fields.
 * 
 * Comment:   Automatically generated on Thu Oct 07 04:48:00 GMT+10:00 1999
 *            at Melbourne, Australia
 *            by parsing the MPEG-4 templates.txt file.
 *            Contact: mikeseven@hotmail.com
 *
 **************************************************************************/
#include "float.h"
#include "StreamCo.h"
#include "NodeFld.h"
#include "bifs.h"
#include "Root.h"
#include "Conditional.h"

#if !defined(_Nodes2_h)  // Sentry, use file only if it's not already included.
#define _Nodes2_h

#pragma warning(disable: 4305)  // truncation from 'const double' to 'const float'

class AcousticMaterial : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<float> ambientIntensity;
         exposedField SF<Color3f> diffuseColor;
         exposedField SF<Color3f> emissiveColor;
         exposedField SF<float> shininess;
         exposedField SF<Color3f> specularColor;
         exposedField SF<float> transparency;
         field SF<float> reffunc;
         field SF<float> transfunc;

         public:
              AcousticMaterial() {
                   ambientIntensity = 0.2;
                   diffuseColor = Color3f(0.8, 0.8, 0.8);
                   emissiveColor = Color3f(0, 0, 0);
                   shininess = 0.2;
                   specularColor = Color3f(0, 0, 0);
                   transparency = 0;
                   reffunc = 0;
                   transfunc = 1;
              }
};

class AcousticScene : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<float> reverbLevel;
         exposedField SF<Time> reverbDelay;
         field SF<Vec3f> center;
         field SF<Vec3f> Size;
         field MF<Time> reverbTime;
         field MF<float> reverbFreq;

         public:
              AcousticScene() {
                   reverbLevel = 0.4;
                   reverbDelay = 0.5;
                   center = Vec3f(0, 0, 0);
                   Size = Vec3f(-1, -1, -1);
                   reverbTime += 0;
                   reverbFreq += 1000;
              }
};

class BAP : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<int> sacroiliac_tilt;
         exposedField SF<int> sacroiliac_torsion;
         exposedField SF<int> sacroiliac_roll;
         exposedField SF<int> l_hip_flexion;
         exposedField SF<int> r_hip_flexion;
         exposedField SF<int> l_hip_abduct;
         exposedField SF<int> r_hip_abduct;
         exposedField SF<int> l_hip_twisting;
         exposedField SF<int> r_hip_twisting;
         exposedField SF<int> l_knee_flexion;
         exposedField SF<int> r_knee_flexion;
         exposedField SF<int> l_knee_twisting;
         exposedField SF<int> r_knee_twisting;
         exposedField SF<int> l_ankle_flexion;
         exposedField SF<int> r_ankle_flexion;
         exposedField SF<int> l_ankle_twisting;
         exposedField SF<int> r_ankle_twisting;
         exposedField SF<int> l_subtalar_flexion;
         exposedField SF<int> r_subtalar_flexion;
         exposedField SF<int> l_midtarsal_flexion;
         exposedField SF<int> r_midtarsal_flexion;
         exposedField SF<int> l_metatarsal_flexion;
         exposedField SF<int> r_metatarsal_flexion;
         exposedField SF<int> l_sternoclavicular_abduct;
         exposedField SF<int> r_sternoclavicular_abduct;
         exposedField SF<int> l_sternoclavicular_rotate;
         exposedField SF<int> r_sternoclavicular_rotate;
         exposedField SF<int> l_acromioclavicular_abduct;
         exposedField SF<int> r_acromioclavicular_abduct;
         exposedField SF<int> l_acromioclavicular_rotate;
         exposedField SF<int> r_acromioclavicular_rotate;
         exposedField SF<int> l_shoulder_flexion;
         exposedField SF<int> r_shoulder_flexion;
         exposedField SF<int> l_shoulder_abduct;
         exposedField SF<int> r_shoulder_abduct;
         exposedField SF<int> l_shoulder_twisting;
         exposedField SF<int> r_shoulder_twisting;
         exposedField SF<int> l_elbow_flexion;
         exposedField SF<int> r_elbow_flexion;
         exposedField SF<int> l_elbow_twisting;
         exposedField SF<int> r_elbow_twisting;
         exposedField SF<int> l_wrist_flexion;
         exposedField SF<int> r_wrist_flexion;
         exposedField SF<int> l_wrist_pivot;
         exposedField SF<int> r_wrist_pivot;
         exposedField SF<int> l_wrist_twisting;
         exposedField SF<int> r_wrist_twisting;
         exposedField SF<int> skullbase_roll;
         exposedField SF<int> skullbase_torsion;
         exposedField SF<int> skullbase_tilt;
         exposedField SF<int> vc1roll;
         exposedField SF<int> vc1torsion;
         exposedField SF<int> vc1tilt;
         exposedField SF<int> vc2roll;
         exposedField SF<int> vc2torsion;
         exposedField SF<int> vc2tilt;
         exposedField SF<int> vc3roll;
         exposedField SF<int> vc3torsion;
         exposedField SF<int> vc3tilt;
         exposedField SF<int> vc4roll;
         exposedField SF<int> vc4torsion;
         exposedField SF<int> vc4tilt;
         exposedField SF<int> vc5roll;
         exposedField SF<int> vc5torsion;
         exposedField SF<int> vc5tilt;
         exposedField SF<int> vc6roll;
         exposedField SF<int> vc6torsion;
         exposedField SF<int> vc6tilt;
         exposedField SF<int> vc7roll;
         exposedField SF<int> vc7torsion;
         exposedField SF<int> vc7tilt;
         exposedField SF<int> vt1roll;
         exposedField SF<int> vt1torsion;
         exposedField SF<int> vt1tilt;
         exposedField SF<int> vt2roll;
         exposedField SF<int> vt2torsion;
         exposedField SF<int> vt2tilt;
         exposedField SF<int> vt3roll;
         exposedField SF<int> vt3torsion;
         exposedField SF<int> vt3tilt;
         exposedField SF<int> vt4roll;
         exposedField SF<int> vt4torsion;
         exposedField SF<int> vt4tilt;
         exposedField SF<int> vt5roll;
         exposedField SF<int> vt5torsion;
         exposedField SF<int> vt5tilt;
         exposedField SF<int> vt6roll;
         exposedField SF<int> vt6torsion;
         exposedField SF<int> vt6tilt;
         exposedField SF<int> vt7roll;
         exposedField SF<int> vt7torsion;
         exposedField SF<int> vt7tilt;
         exposedField SF<int> vt8roll;
         exposedField SF<int> vt8torsion;
         exposedField SF<int> vt8tilt;
         exposedField SF<int> vt9roll;
         exposedField SF<int> vt9torsion;
         exposedField SF<int> vt9tilt;
         exposedField SF<int> vt10roll;
         exposedField SF<int> vt10torsion;
         exposedField SF<int> vt10tilt;
         exposedField SF<int> vt11roll;
         exposedField SF<int> vt11torsion;
         exposedField SF<int> vt11tilt;
         exposedField SF<int> vt12roll;
         exposedField SF<int> vt12torsion;
         exposedField SF<int> vt12tilt;
         exposedField SF<int> vl1roll;
         exposedField SF<int> vl1torsion;
         exposedField SF<int> vl1tilt;
         exposedField SF<int> vl2roll;
         exposedField SF<int> vl2torsion;
         exposedField SF<int> vl2tilt;
         exposedField SF<int> vl3roll;
         exposedField SF<int> vl3torsion;
         exposedField SF<int> vl3tilt;
         exposedField SF<int> vl4roll;
         exposedField SF<int> vl4torsion;
         exposedField SF<int> vl4tilt;
         exposedField SF<int> vl5roll;
         exposedField SF<int> vl5torsion;
         exposedField SF<int> vl5tilt;
         exposedField SF<int> l_pinky0_flexion;
         exposedField SF<int> r_pinky0_flexion;
         exposedField SF<int> l_pinky1_flexion;
         exposedField SF<int> r_pinky1_flexion;
         exposedField SF<int> l_pinky1_pivot;
         exposedField SF<int> r_pinky1_pivot;
         exposedField SF<int> l_pinky1_twisting;
         exposedField SF<int> r_pinky1_twisting;
         exposedField SF<int> l_pinky2_flexion;
         exposedField SF<int> r_pinky2_flexion;
         exposedField SF<int> l_pinky3_flexion;
         exposedField SF<int> r_pinky3_flexion;
         exposedField SF<int> l_ring0_flexion;
         exposedField SF<int> r_ring0_flexion;
         exposedField SF<int> l_ring1_flexion;
         exposedField SF<int> r_ring1_flexion;
         exposedField SF<int> l_ring1_pivot;
         exposedField SF<int> r_ring1_pivot;
         exposedField SF<int> l_ring1_twisting;
         exposedField SF<int> r_ring1_twisting;
         exposedField SF<int> l_ring2_flexion;
         exposedField SF<int> r_ring2_flexion;
         exposedField SF<int> l_ring3_flexion;
         exposedField SF<int> r_ring3_flexion;
         exposedField SF<int> l_middle0_flexion;
         exposedField SF<int> r_middle0_flexion;
         exposedField SF<int> l_middle1_flexion;
         exposedField SF<int> r_middle1_flexion;
         exposedField SF<int> l_middle1_pivot;
         exposedField SF<int> r_middle1_pivot;
         exposedField SF<int> l_middle1_twisting;
         exposedField SF<int> r_middle1_twisting;
         exposedField SF<int> l_middle2_flexion;
         exposedField SF<int> r_middle2_flexion;
         exposedField SF<int> l_middle3_flexion;
         exposedField SF<int> r_middle3_flexion;
         exposedField SF<int> l_index0_flexion;
         exposedField SF<int> r_index0_flexion;
         exposedField SF<int> l_index1_flexion;
         exposedField SF<int> r_index1_flexion;
         exposedField SF<int> l_index1_pivot;
         exposedField SF<int> r_index1_pivot;
         exposedField SF<int> l_index1_twisting;
         exposedField SF<int> r_index1_twisting;
         exposedField SF<int> l_index2_flexion;
         exposedField SF<int> r_index2_flexion;
         exposedField SF<int> l_index3_flexion;
         exposedField SF<int> r_index3_flexion;
         exposedField SF<int> l_thumb1_flexion;
         exposedField SF<int> r_thumb1_flexion;
         exposedField SF<int> l_thumb1_pivot;
         exposedField SF<int> r_thumb1_pivot;
         exposedField SF<int> l_thumb1_twisting;
         exposedField SF<int> r_thumb1_twisting;
         exposedField SF<int> l_thumb2_flexion;
         exposedField SF<int> r_thumb2_flexion;
         exposedField SF<int> l_thumb3_flexion;
         exposedField SF<int> r_thumb3_flexion;
         exposedField SF<int> HumanoidRoot_tr_vertical;
         exposedField SF<int> HumanoidRoot_tr_lateral;
         exposedField SF<int> HumanoidRoot_tr_frontal;
         exposedField SF<int> HumanoidRoot_rt_body_turn;
         exposedField SF<int> HumanoidRoot_rt_body_roll;
         exposedField SF<int> HumanoidRoot_rt_body_tilt;
         exposedField SF<int> extensionBap187;
         exposedField SF<int> extensionBap188;
         exposedField SF<int> extensionBap189;
         exposedField SF<int> extensionBap190;
         exposedField SF<int> extensionBap191;
         exposedField SF<int> extensionBap192;
         exposedField SF<int> extensionBap193;
         exposedField SF<int> extensionBap194;
         exposedField SF<int> extensionBap195;
         exposedField SF<int> extensionBap196;
         exposedField SF<int> extensionBap197;
         exposedField SF<int> extensionBap198;
         exposedField SF<int> extensionBap199;
         exposedField SF<int> extensionBap200;
         exposedField SF<int> extensionBap201;
         exposedField SF<int> extensionBap202;
         exposedField SF<int> extensionBap203;
         exposedField SF<int> extensionBap204;
         exposedField SF<int> extensionBap205;
         exposedField SF<int> extensionBap206;
         exposedField SF<int> extensionBap207;
         exposedField SF<int> extensionBap208;
         exposedField SF<int> extensionBap209;
         exposedField SF<int> extensionBap210;
         exposedField SF<int> extensionBap211;
         exposedField SF<int> extensionBap212;
         exposedField SF<int> extensionBap213;
         exposedField SF<int> extensionBap214;
         exposedField SF<int> extensionBap215;
         exposedField SF<int> extensionBap216;
         exposedField SF<int> extensionBap217;
         exposedField SF<int> extensionBap218;
         exposedField SF<int> extensionBap219;
         exposedField SF<int> extensionBap220;
         exposedField SF<int> extensionBap221;
         exposedField SF<int> extensionBap222;
         exposedField SF<int> extensionBap223;
         exposedField SF<int> extensionBap224;
         exposedField SF<int> extensionBap225;
         exposedField SF<int> extensionBap226;
         exposedField SF<int> extensionBap227;
         exposedField SF<int> extensionBap228;
         exposedField SF<int> extensionBap229;
         exposedField SF<int> extensionBap230;
         exposedField SF<int> extensionBap231;
         exposedField SF<int> extensionBap232;
         exposedField SF<int> extensionBap233;
         exposedField SF<int> extensionBap234;
         exposedField SF<int> extensionBap235;
         exposedField SF<int> extensionBap236;
         exposedField SF<int> extensionBap237;
         exposedField SF<int> extensionBap238;
         exposedField SF<int> extensionBap239;
         exposedField SF<int> extensionBap240;
         exposedField SF<int> extensionBap241;
         exposedField SF<int> extensionBap242;
         exposedField SF<int> extensionBap243;
         exposedField SF<int> extensionBap244;
         exposedField SF<int> extensionBap245;
         exposedField SF<int> extensionBap246;
         exposedField SF<int> extensionBap247;
         exposedField SF<int> extensionBap248;
         exposedField SF<int> extensionBap249;
         exposedField SF<int> extensionBap250;
         exposedField SF<int> extensionBap251;
         exposedField SF<int> extensionBap252;
         exposedField SF<int> extensionBap253;
         exposedField SF<int> extensionBap254;
         exposedField SF<int> extensionBap255;
         exposedField SF<int> extensionBap256;
         exposedField SF<int> extensionBap257;
         exposedField SF<int> extensionBap258;
         exposedField SF<int> extensionBap259;
         exposedField SF<int> extensionBap260;
         exposedField SF<int> extensionBap261;
         exposedField SF<int> extensionBap262;
         exposedField SF<int> extensionBap263;
         exposedField SF<int> extensionBap264;
         exposedField SF<int> extensionBap265;
         exposedField SF<int> extensionBap266;
         exposedField SF<int> extensionBap267;
         exposedField SF<int> extensionBap268;
         exposedField SF<int> extensionBap269;
         exposedField SF<int> extensionBap270;
         exposedField SF<int> extensionBap271;
         exposedField SF<int> extensionBap272;
         exposedField SF<int> extensionBap273;
         exposedField SF<int> extensionBap274;
         exposedField SF<int> extensionBap275;
         exposedField SF<int> extensionBap276;
         exposedField SF<int> extensionBap277;
         exposedField SF<int> extensionBap278;
         exposedField SF<int> extensionBap279;
         exposedField SF<int> extensionBap280;
         exposedField SF<int> extensionBap281;
         exposedField SF<int> extensionBap282;
         exposedField SF<int> extensionBap283;
         exposedField SF<int> extensionBap284;
         exposedField SF<int> extensionBap285;
         exposedField SF<int> extensionBap286;
         exposedField SF<int> extensionBap287;
         exposedField SF<int> extensionBap288;
         exposedField SF<int> extensionBap289;
         exposedField SF<int> extensionBap290;
         exposedField SF<int> extensionBap291;
         exposedField SF<int> extensionBap292;
         exposedField SF<int> extensionBap293;
         exposedField SF<int> extensionBap294;
         exposedField SF<int> extensionBap295;
         exposedField SF<int> extensionBap296;

         public:
              BAP() {
                   sacroiliac_tilt = 0;
                   sacroiliac_torsion = 0;
                   sacroiliac_roll = 0;
                   l_hip_flexion = 0;
                   r_hip_flexion = 0;
                   l_hip_abduct = 0;
                   r_hip_abduct = 0;
                   l_hip_twisting = 0;
                   r_hip_twisting = 0;
                   l_knee_flexion = 0;
                   r_knee_flexion = 0;
                   l_knee_twisting = 0;
                   r_knee_twisting = 0;
                   l_ankle_flexion = 0;
                   r_ankle_flexion = 0;
                   l_ankle_twisting = 0;
                   r_ankle_twisting = 0;
                   l_subtalar_flexion = 0;
                   r_subtalar_flexion = 0;
                   l_midtarsal_flexion = 0;
                   r_midtarsal_flexion = 0;
                   l_metatarsal_flexion = 0;
                   r_metatarsal_flexion = 0;
                   l_sternoclavicular_abduct = 0;
                   r_sternoclavicular_abduct = 0;
                   l_sternoclavicular_rotate = 0;
                   r_sternoclavicular_rotate = 0;
                   l_acromioclavicular_abduct = 0;
                   r_acromioclavicular_abduct = 0;
                   l_acromioclavicular_rotate = 0;
                   r_acromioclavicular_rotate = 0;
                   l_shoulder_flexion = 0;
                   r_shoulder_flexion = 0;
                   l_shoulder_abduct = 0;
                   r_shoulder_abduct = 0;
                   l_shoulder_twisting = 0;
                   r_shoulder_twisting = 0;
                   l_elbow_flexion = 0;
                   r_elbow_flexion = 0;
                   l_elbow_twisting = 0;
                   r_elbow_twisting = 0;
                   l_wrist_flexion = 0;
                   r_wrist_flexion = 0;
                   l_wrist_pivot = 0;
                   r_wrist_pivot = 0;
                   l_wrist_twisting = 0;
                   r_wrist_twisting = 0;
                   skullbase_roll = 0;
                   skullbase_torsion = 0;
                   skullbase_tilt = 0;
                   vc1roll = 0;
                   vc1torsion = 0;
                   vc1tilt = 0;
                   vc2roll = 0;
                   vc2torsion = 0;
                   vc2tilt = 0;
                   vc3roll = 0;
                   vc3torsion = 0;
                   vc3tilt = 0;
                   vc4roll = 0;
                   vc4torsion = 0;
                   vc4tilt = 0;
                   vc5roll = 0;
                   vc5torsion = 0;
                   vc5tilt = 0;
                   vc6roll = 0;
                   vc6torsion = 0;
                   vc6tilt = 0;
                   vc7roll = 0;
                   vc7torsion = 0;
                   vc7tilt = 0;
                   vt1roll = 0;
                   vt1torsion = 0;
                   vt1tilt = 0;
                   vt2roll = 0;
                   vt2torsion = 0;
                   vt2tilt = 0;
                   vt3roll = 0;
                   vt3torsion = 0;
                   vt3tilt = 0;
                   vt4roll = 0;
                   vt4torsion = 0;
                   vt4tilt = 0;
                   vt5roll = 0;
                   vt5torsion = 0;
                   vt5tilt = 0;
                   vt6roll = 0;
                   vt6torsion = 0;
                   vt6tilt = 0;
                   vt7roll = 0;
                   vt7torsion = 0;
                   vt7tilt = 0;
                   vt8roll = 0;
                   vt8torsion = 0;
                   vt8tilt = 0;
                   vt9roll = 0;
                   vt9torsion = 0;
                   vt9tilt = 0;
                   vt10roll = 0;
                   vt10torsion = 0;
                   vt10tilt = 0;
                   vt11roll = 0;
                   vt11torsion = 0;
                   vt11tilt = 0;
                   vt12roll = 0;
                   vt12torsion = 0;
                   vt12tilt = 0;
                   vl1roll = 0;
                   vl1torsion = 0;
                   vl1tilt = 0;
                   vl2roll = 0;
                   vl2torsion = 0;
                   vl2tilt = 0;
                   vl3roll = 0;
                   vl3torsion = 0;
                   vl3tilt = 0;
                   vl4roll = 0;
                   vl4torsion = 0;
                   vl4tilt = 0;
                   vl5roll = 0;
                   vl5torsion = 0;
                   vl5tilt = 0;
                   l_pinky0_flexion = 0;
                   r_pinky0_flexion = 0;
                   l_pinky1_flexion = 0;
                   r_pinky1_flexion = 0;
                   l_pinky1_pivot = 0;
                   r_pinky1_pivot = 0;
                   l_pinky1_twisting = 0;
                   r_pinky1_twisting = 0;
                   l_pinky2_flexion = 0;
                   r_pinky2_flexion = 0;
                   l_pinky3_flexion = 0;
                   r_pinky3_flexion = 0;
                   l_ring0_flexion = 0;
                   r_ring0_flexion = 0;
                   l_ring1_flexion = 0;
                   r_ring1_flexion = 0;
                   l_ring1_pivot = 0;
                   r_ring1_pivot = 0;
                   l_ring1_twisting = 0;
                   r_ring1_twisting = 0;
                   l_ring2_flexion = 0;
                   r_ring2_flexion = 0;
                   l_ring3_flexion = 0;
                   r_ring3_flexion = 0;
                   l_middle0_flexion = 0;
                   r_middle0_flexion = 0;
                   l_middle1_flexion = 0;
                   r_middle1_flexion = 0;
                   l_middle1_pivot = 0;
                   r_middle1_pivot = 0;
                   l_middle1_twisting = 0;
                   r_middle1_twisting = 0;
                   l_middle2_flexion = 0;
                   r_middle2_flexion = 0;
                   l_middle3_flexion = 0;
                   r_middle3_flexion = 0;
                   l_index0_flexion = 0;
                   r_index0_flexion = 0;
                   l_index1_flexion = 0;
                   r_index1_flexion = 0;
                   l_index1_pivot = 0;
                   r_index1_pivot = 0;
                   l_index1_twisting = 0;
                   r_index1_twisting = 0;
                   l_index2_flexion = 0;
                   r_index2_flexion = 0;
                   l_index3_flexion = 0;
                   r_index3_flexion = 0;
                   l_thumb1_flexion = 0;
                   r_thumb1_flexion = 0;
                   l_thumb1_pivot = 0;
                   r_thumb1_pivot = 0;
                   l_thumb1_twisting = 0;
                   r_thumb1_twisting = 0;
                   l_thumb2_flexion = 0;
                   r_thumb2_flexion = 0;
                   l_thumb3_flexion = 0;
                   r_thumb3_flexion = 0;
                   HumanoidRoot_tr_vertical = 0;
                   HumanoidRoot_tr_lateral = 0;
                   HumanoidRoot_tr_frontal = 0;
                   HumanoidRoot_rt_body_turn = 0;
                   HumanoidRoot_rt_body_roll = 0;
                   HumanoidRoot_rt_body_tilt = 0;
                   extensionBap187 = 0;
                   extensionBap188 = 0;
                   extensionBap189 = 0;
                   extensionBap190 = 0;
                   extensionBap191 = 0;
                   extensionBap192 = 0;
                   extensionBap193 = 0;
                   extensionBap194 = 0;
                   extensionBap195 = 0;
                   extensionBap196 = 0;
                   extensionBap197 = 0;
                   extensionBap198 = 0;
                   extensionBap199 = 0;
                   extensionBap200 = 0;
                   extensionBap201 = 0;
                   extensionBap202 = 0;
                   extensionBap203 = 0;
                   extensionBap204 = 0;
                   extensionBap205 = 0;
                   extensionBap206 = 0;
                   extensionBap207 = 0;
                   extensionBap208 = 0;
                   extensionBap209 = 0;
                   extensionBap210 = 0;
                   extensionBap211 = 0;
                   extensionBap212 = 0;
                   extensionBap213 = 0;
                   extensionBap214 = 0;
                   extensionBap215 = 0;
                   extensionBap216 = 0;
                   extensionBap217 = 0;
                   extensionBap218 = 0;
                   extensionBap219 = 0;
                   extensionBap220 = 0;
                   extensionBap221 = 0;
                   extensionBap222 = 0;
                   extensionBap223 = 0;
                   extensionBap224 = 0;
                   extensionBap225 = 0;
                   extensionBap226 = 0;
                   extensionBap227 = 0;
                   extensionBap228 = 0;
                   extensionBap229 = 0;
                   extensionBap230 = 0;
                   extensionBap231 = 0;
                   extensionBap232 = 0;
                   extensionBap233 = 0;
                   extensionBap234 = 0;
                   extensionBap235 = 0;
                   extensionBap236 = 0;
                   extensionBap237 = 0;
                   extensionBap238 = 0;
                   extensionBap239 = 0;
                   extensionBap240 = 0;
                   extensionBap241 = 0;
                   extensionBap242 = 0;
                   extensionBap243 = 0;
                   extensionBap244 = 0;
                   extensionBap245 = 0;
                   extensionBap246 = 0;
                   extensionBap247 = 0;
                   extensionBap248 = 0;
                   extensionBap249 = 0;
                   extensionBap250 = 0;
                   extensionBap251 = 0;
                   extensionBap252 = 0;
                   extensionBap253 = 0;
                   extensionBap254 = 0;
                   extensionBap255 = 0;
                   extensionBap256 = 0;
                   extensionBap257 = 0;
                   extensionBap258 = 0;
                   extensionBap259 = 0;
                   extensionBap260 = 0;
                   extensionBap261 = 0;
                   extensionBap262 = 0;
                   extensionBap263 = 0;
                   extensionBap264 = 0;
                   extensionBap265 = 0;
                   extensionBap266 = 0;
                   extensionBap267 = 0;
                   extensionBap268 = 0;
                   extensionBap269 = 0;
                   extensionBap270 = 0;
                   extensionBap271 = 0;
                   extensionBap272 = 0;
                   extensionBap273 = 0;
                   extensionBap274 = 0;
                   extensionBap275 = 0;
                   extensionBap276 = 0;
                   extensionBap277 = 0;
                   extensionBap278 = 0;
                   extensionBap279 = 0;
                   extensionBap280 = 0;
                   extensionBap281 = 0;
                   extensionBap282 = 0;
                   extensionBap283 = 0;
                   extensionBap284 = 0;
                   extensionBap285 = 0;
                   extensionBap286 = 0;
                   extensionBap287 = 0;
                   extensionBap288 = 0;
                   extensionBap289 = 0;
                   extensionBap290 = 0;
                   extensionBap291 = 0;
                   extensionBap292 = 0;
                   extensionBap293 = 0;
                   extensionBap294 = 0;
                   extensionBap295 = 0;
                   extensionBap296 = 0;
              }
};

class BDP : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField MFNode<class BodyDefTable> bodyDefTables;
         exposedField MFNodeType<SF3DNode> bodySceneGraph;

         public:
              BDP() {
              }
};

class Body : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SFNode<class BDP> bdp;
         exposedField SFNode<class BAP> bap;
         exposedField MFNodeType<SF3DNode> renderedBody;

         public:
              Body() {
              }
};

class BodyDefTable : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SFString bodySceneGraphNodeName;
         exposedField MF<int> bapIDs;
         exposedField MF<int> vertexIds;
         exposedField MF<int> bapCombinations;
         exposedField MF<Vec3f> displacements;
         exposedField SF<int> numInterpolateKeys;

         public:
              BodyDefTable() {
                   numInterpolateKeys = 2;
              }
};

class BodySegmentConnectionHint : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SFString firstSegmentNodeName;
         exposedField SFString secondSegmentNodeName;
         exposedField MF<int> firstVertexIdList;
         exposedField MF<int> secondVertexIdList;

         public:
              BodySegmentConnectionHint() {
                   firstVertexIdList += NULL;
                   secondVertexIdList += NULL;
              }
};

class DirectiveSound : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<Vec3f> direction;
         exposedField SF<float> intensity;
         exposedField SF<Vec3f> location;
         exposedField SFAudioNode source;
         exposedField SFNode<class PerceptualParameters> perceptualParameters;
         exposedField SF<Bool> roomEffect;
         exposedField SF<Bool> spatialize;
         field MF<float> angles;
         field MF<float> directivity;
         field SF<float> speedOfSound;
         field SF<float> distance;
         field SF<Bool> useAirabs;

         public:
              DirectiveSound() {
                   direction = Vec3f(0, 0, -1);
                   intensity = 1;
                   location = Vec3f(0, 0, 0);
                   roomEffect = FALSE;
                   spatialize = TRUE;
                   angles += 1;
                   directivity += 1;
                   speedOfSound = 340;
                   distance = 100;
                   useAirabs = FALSE;
              }
};

class Hierarchical3DMesh : public StreamConsumer
{
         BIFS_DECLARE_NODE

         eventIn SF<int> triangleBudget;
         exposedField SF<float> level;
         eventOut SF<Bool> doneLoading;
         void OntriangleBudget();

         public:
              Hierarchical3DMesh() {
                   triangleBudget = 1000;
                   level = 1;
              }
};

class MaterialKey : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<Bool> isKeyed;
         exposedField SF<Bool> isRGB;
         exposedField SF<Color3f> keyColor;
         exposedField SF<float> lowThreshold;
         exposedField SF<float> highThreshold;
         exposedField SF<float> transparency;

         public:
              MaterialKey() {
                   isKeyed = TRUE;
                   isRGB = TRUE;
                   keyColor = Color3f(0, 0, 0);
                   lowThreshold = 0;
                   highThreshold = 0;
                   transparency = 0;
              }
};

class PerceptualParameters : public MediaObject
{
         BIFS_DECLARE_NODE

         exposedField SF<float> sourcePresence;
         exposedField SF<float> sourceWarmth;
         exposedField SF<float> sourceBrilliance;
         exposedField SF<float> roomPresence;
         exposedField SF<float> runningReverberance;
         exposedField SF<float> envelopment;
         exposedField SF<float> lateReverberance;
         exposedField SF<float> heavyness;
         exposedField SF<float> liveness;
         exposedField MF<float> omniDirectivity;
         exposedField MF<float> directFilterGains;
         exposedField MF<float> inputFilterGains;
         exposedField SF<float> refDistance;
         exposedField SF<float> freqLow;
         exposedField SF<float> freqHigh;
         exposedField SF<Time> timeLimit1;
         exposedField SF<Time> timeLimit2;
         exposedField SF<Time> timeLimit3;
         exposedField SF<Time> modalDensity;

         public:
              PerceptualParameters() {
                   sourcePresence = 1;
                   sourceWarmth = 1;
                   sourceBrilliance = 1;
                   roomPresence = 1;
                   runningReverberance = 1;
                   envelopment = 0;
                   lateReverberance = 1;
                   heavyness = 1;
                   liveness = 1;
                   omniDirectivity += 1;
                   directFilterGains += 1;
                   directFilterGains += 1;
                   directFilterGains += 1;
                   inputFilterGains += 1;
                   inputFilterGains += 1;
                   inputFilterGains += 1;
                   refDistance = 1;
                   freqLow = 250;
                   freqHigh = 4000;
                   timeLimit1 = 0.02;
                   timeLimit2 = 0.04;
                   timeLimit3 = 0.1;
                   modalDensity = 0.8;
              }
};

class ServerCommand : public StreamConsumer
{
         BIFS_DECLARE_NODE

         eventIn SF<Bool> trigger;
         exposedField SF<Bool> enable;
         eventIn SFString command;
         void Ontrigger();
         void Oncommand();

         public:
              ServerCommand() {
                   trigger = FALSE;
                   enable = FALSE;
              }
};

#endif // _Nodes2_h sentry.
/* End of automatically generated file */
