/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and edited by Mauro Rossi (CSELT),
    Guido Franceschini (CSELT) and Michael Stepping (FTK)
    in the course of development of the MPEG-4 DMIF (ISO/IEC 14496-6)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4  DMIF  (ISO/IEC 14496-6)  tools  as  specified
    by  the  MPEG-4 DMIF (ISO/IEC 14496-6)  standard.  ISO/IEC  gives
    users of  the  MPEG-4  DMIF  (ISO/IEC 14496-6)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming  conformance  to  the  MPEG-4  DMIF 
    (ISO/IEC 14496-6). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 DMIF  (ISO/IEC 14496-6)
    conforming  products. Triton R&D Ltd.
    retains full  right to use the code for  its  own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non  MPEG-4  DMIF  (ISO/IEC 14496-6)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1998.
************************************************************************/

// Contact: guido.franceschini@cselt.it

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: DMIF
 * FILE:      MyChannel.cpp
 * AUTHOR:    Mauro Rossi (CSELT)
 * OVERVIEW:  Implementation of MyChannel.
 * 
 **************************************************************************/

#include <iostream.h>
#include "MyChannel.h"

void MyChannel::DPIC_ChannelDelete_Cnf (
	const UINT nServiceId,
	const RESPONSE eResponse)
{
	DAIChannelDeleteParam cnfParam;
	DAIChannelDeleteElement cnfEl;

	cnfEl.m_nChid = GetChannelId();
	cnfEl.m_eResponse = eResponse;
	
	// not used, but now initialized
	cnfEl.m_eReason = REASON_OK;

	cnfParam += cnfEl;
	m_pSink->DAI_Channel_Delete_Cnf(nServiceId,cnfParam);
}

void MyChannel::DPIC_PacketReceived_Ind(
	const BYTE *pStreamData,
	int nStreamDataLength,
	const BOOL bErr)
{
	int eFlag = bErr ? DATA_CORRUPTED : DATA_OK;
	m_pSink->DAI_Received_Data(GetChannelId(),(char*)pStreamData,nStreamDataLength,eFlag);
}

Application_Sink* MyChannel::GetSink()
{
	return m_pSink;
}

UINT MyChannel::GetChannelId()
{
	return (UINT)this;
}
