/*------------------------------------------------------------------
	 1999 CSELT - Centro Studi e Laboratori Telecomunicazioni.
	All rights reserved.
------------------------------------------------------------------*/


#ifndef _bag_h_
#define _bag_h_

#ifdef SUN
#ifndef BOOL
#define BOOL Bool
#endif
#endif

#ifndef TRUE
#define TRUE 1
#endif


#ifndef FALSE
#define FALSE 0
#endif


template <class T>
class bagElem {
public:
	T info;
	bagElem* next;
};


template <class T>
class Bag {
protected:
	bagElem<T>* head;
private:
	bagElem<T>** pos; 
	int numberOfElements;
	BOOL pop();
public:
	Bag();
	Bag(Bag&);
	int number() const;
	int size() const;
	void insert(T*);
	int erase(T*);
	BOOL rewind() const;
	BOOL next() const;
	T* present() const;
	~Bag() {
        	while(pop());
		delete pos;
		}
};


template <class T>
Bag<T>::Bag() {
	head=NULL;
	pos=new (bagElem<T>*);
	*pos=NULL;
	numberOfElements=0;
}

template <class T>
Bag<T>::Bag(Bag<T>& r) {
	///cout<<"Bag::Bag(Bag&) --- copy constructor ";
	head=NULL;
	pos=new (bagElem<T>*);
	*pos=NULL;
	numberOfElements=0;
	if(r.rewind())
	do {
		insert(r.present());
		//cout<<*(present())<<" ";
		}while(r.next());
	//cout<<endl;
}


template <class T>
BOOL Bag<T>::pop() {
        bagElem<T>* el = head;
	if(head!=NULL) {
		head=head->next;
		if(*pos==el) *pos=head;
		delete el;
		numberOfElements--;
		return(TRUE);
		}
	else {
		*pos=NULL;
		return(FALSE);
		}
}

template <class T>
int Bag<T>::number() const {
	return numberOfElements;
}

template <class T>
void Bag<T>::insert(T* x) {
	//cout<<"Bag::insert"<<endl;
        bagElem<T>* el;
	el=new bagElem<T>;
	el->info=*x;
	el->next=head;
	head=el;
	numberOfElements++;
}

template <class T>
int Bag<T>::erase(T* x) {
        bagElem<T>* el = head;
        bagElem<T>* d;

	if(head!=NULL) {
		if(el->info==*x) {
			head=el->next;
			delete el;
			numberOfElements--;
			return 0;
			}
		else {
			while(el->next->info != *x && el->next!=NULL) el=el->next;
			if(el->next != NULL) {
				d=el->next;
				el->next=d->next;
				if(*pos==d) *pos=d->next;
				delete d;
				numberOfElements--;
				return 0;
				}
			}
		}
	return -1;
}



template <class T>
BOOL Bag<T>::rewind() const {
	*pos=head;
	if(head==NULL) return FALSE;
	else return TRUE;
}

template <class T>
T* Bag<T>::present() const {
	return &((*pos)->info);
}

template <class T>
BOOL Bag<T>::next() const {
	if(*pos) {
		*pos=(*pos)->next;
		return (*pos!=NULL);
		}
	else return NULL;
}

template <class T>
int Bag<T>::size() const {
	if(numberOfElements>0) {
		return(numberOfElements * sizeof(head->info));
		}
	else {
		return 0;
		}
}


#endif

