#ifndef _list_h_
#define _list_h_

#include "Mydefs.h"

template <class R,class S,class T>
class elem {
public:
	T* info;
	R index;
	S index2;
	elem* next;
	Bool deleteFlag;
	elem(Bool f) : deleteFlag(f) {}
	~elem() {
		if(deleteFlag) delete info;
		}
};


template <class R,class S,class T>
class SimpleList {
private:
	elem<R,S,T>* h;
	elem<R,S,T>** z;
	void prel();
public:
	SimpleList();
	~SimpleList();
	void pushElem(elem<R,S,T>*);
	void enqueueElem(elem<R,S,T>*);
	Bool popElem(elem<R,S,T>*&);
	void removeElem(elem<R,S,T>*);
	Bool IsEmpty();
	elem<R,S,T>* findElem1(R*);
	elem<R,S,T>* findElem2(S*,Bool);	// if TRUE, it looks for the next occourence, 
										// if FALSE, it starts from the begin of the list
	Bool rewind() const;
	Bool next() const;
	elem<R,S,T>* present() const;
	R getPresentIndex1() const;
	S getPresentIndex2() const;
	void erasePresent();

	void print();
	void print2();
};


template <class R,class S,class T>
class List : public SimpleList<R,S,T> {
protected:
//	SimpleList<R,S,T> fsmList;
	elem<R,S,T>* el;
	Bool deleteFlag;
public:
	int erase(R); // 0:OK - 1:error.
	Bool find(R,T*&);//TRUE se lo trova.
	Bool lookFor(R*);//TRUE se lo trova.
	T* getPnt(R);
	T* getPnt1(const char*);
	///T* getPnt(S);
	Bool pop(T*&);//FALSE se la lista e' vuota.
	Bool isEmpty();//TRUE se la lista e' vuota.
	T* present();
	void printFSM();
	void printMSG();
	~List() {
       		elem<R,S,T>* p_el;
        	while(popElem(p_el)) delete p_el;
		}
};

template <class R,class T>
class SingleIndexedList : public List<R,R,T> {
public:
	SingleIndexedList(Bool f) {deleteFlag=f; }
	int insert(R,T*);
};

template <class R,class S,class T>
class DoubleIndexedList : public List<R,S,T> {
public:
	DoubleIndexedList(Bool f) {deleteFlag=f; }
	int insert(R,S,T*); // allows multiple elements with the same 2nd index (S).
	T* getPnt2(S,Bool);
	T* getPnt2(const char*,Bool);
	Bool find1(R*,S*&,T*&); //TRUE se lo trova.
	Bool find2(S*,R*&,T*&); //TRUE se lo trova.
	Bool lookFor2(S*); //TRUE se lo trova.
};



///////////////////List


template <class R,class S,class T>
void SimpleList<R,S,T>::prel() {
	elem<R,S,T>* p=h;
	cout<<"elem list:"<<endl; fflush(NULL);
	if(p!=NULL) {
		do {	
		cout<<hex<<p<<dec<<endl;
		p=p->next;
	    	}while(p!=NULL);
	    cout<<"endoflist."<<endl; fflush(NULL);
	}
	else {
		cout<<"empty."<<endl; fflush(NULL);
		}

}


template <class R,class S,class T>
SimpleList<R,S,T>::SimpleList() {
	z=new (elem<R,S,T>*);
	*z=NULL;
	h=NULL;
}

template <class R,class S,class T>
SimpleList<R,S,T>::~SimpleList() {
	delete z;
}

template <class R,class S,class T>
Bool SimpleList<R,S,T>::rewind() const {
	*z=h;
	if(*z==NULL) return FALSE;
	else return TRUE;
}

template <class R,class S,class T>
elem<R,S,T>* SimpleList<R,S,T>::present() const {
	return *z;
}

template <class R,class S,class T>
R SimpleList<R,S,T>::getPresentIndex1() const {
	return ((*z)->index);
}

template <class R,class S,class T>
S SimpleList<R,S,T>::getPresentIndex2() const {
	return ((*z)->index2);
}

template <class R,class S,class T>
Bool SimpleList<R,S,T>::next() const {
	if(*z) {
		*z=(*z)->next;
		return (*z!=NULL);
		}
	else return NULL;
}

template <class R,class S,class T>
void SimpleList<R,S,T>::erasePresent() {
	removeElem(*z);
}


template <class R,class S,class T>
void SimpleList<R,S,T>::pushElem(elem<R,S,T>* el) {
	el->next=h;
	h=el;
}

template <class R,class S,class T>
void SimpleList<R,S,T>::enqueueElem(elem<R,S,T>* el) {
	elem<R,S,T>* p;
	//prel();
	if(h==NULL) {
		h=el;
		}
	else {	
		p=h;
		while((p->next)!=NULL) p=p->next;
		p->next=el;
		}
	el->next=NULL;
	//prel();
}

template <class R,class S,class T>
Bool SimpleList<R,S,T>::popElem(elem<R,S,T>*& el) {
	//prel();
	if(h!=NULL) {
		el=h;
		h=el->next;
		return(TRUE);
		}
	else {
		el=NULL;
		return(FALSE);
		}
	//prel();
}

template <class R,class S,class T>
void SimpleList<R,S,T>::removeElem(elem<R,S,T>* el) {
	//prel();
	*z = el->next;
	if(h==el) h=el->next;
	else {
		elem<R,S,T>* p=h;
		while(p->next != el && p->next!=NULL) p=p->next;
		if(p->next==NULL) {
			cout<<"ERROR: remove: element not found"<<endl;
			}
		else {
			p->next = el->next;
			}
	}
	//prel();
}

template <class R,class S,class T>
Bool SimpleList<R,S,T>::IsEmpty() {
	return (h==NULL ? TRUE : FALSE);
}

template <class R,class S,class T>
elem<R,S,T>* SimpleList<R,S,T>::findElem1(R* x) {
	elem<R,S,T>* p;
	p=h;
	//cout<<"List::findElem1 "<<*x<<endl;
	if(p==NULL) return NULL;
	while((p!=NULL) && (p->index != *x)) {
		//cout<<"p->index="<<p->index<<endl;
		p=p->next;
		}
	//cout<<"p="<<p<<endl;
	return p;
}

template <class R,class S,class T>
elem<R,S,T>* SimpleList<R,S,T>::findElem2(S* x,Bool goOn) {
	static elem<R,S,T>* sp=h;
	elem<R,S,T>* p;
	if(goOn) {
		if(sp!=NULL) p=sp->next;
		else p=NULL;
		}
	else p=h;
	//cout<<"p="<<hex<<p<<dec<<endl;
#ifdef _PRINT_LST_NAME
	//cout<<"List::findElem2 "<<*x<<endl;
#endif
	//cout<<"x=";
	//for(j=0;j<20;j++) cout<<hex<<(int)((x->toString())[j])<<dec<<".";
	//cout<<endl;
	if(p==NULL) {
		//cout<<"findElem2 p==NULL"<<endl;
		return NULL;
		}
	while((p!=NULL) && (p->index2 != *x)) {
		//cout<<"list index=";
		//for(j=0;j<20;j++) cout<<hex<<(int)((p->index.toString())[j])<<dec<<".";
		//cout<<endl;
		//cout<<p->index<<endl;
		//cout<<"list index2=";
		//for(j=0;j<20;j++) cout<<hex<<(int)((p->index2.toString())[j])<<dec<<".";
		//cout<<endl;
		//cout<<p->index2<<endl;
		p=p->next;
		}
	sp=p;
	return p;
}

template <class R,class S,class T>
void SimpleList<R,S,T>::print() {
	/*
	elem<R,S,T>* p;
	if(printFSMList) {
	p=h;
	cout<<"FSM in lista:"<<endl;
	while(p!=NULL) {
	//////	cout<<" stato della FSM session fsm:"<<p->index<<" ="<<p->info->sessionFSM->GetState().StateName()<<endl;
	/////	cout<<"                     SDB fsm:"<<p->index<<" ="<<p->info->sdbFSM->GetState().StateName()<<endl;
		p=p->next;
		}
	cout<<"fine elenco."<<endl;
	}
	*/
	cout<<"print not implemented."<<endl;
}

template <class R,class S,class T>
void SimpleList<R,S,T>::print2() {
#if 0
	elem<R,S,T>* p;
	if(printMSGList) {
	p=h;
	cout<<"Messaggi in lista:"<<endl;
	while(p!=NULL) {
		cout<<" Messaggio: "<<p->info<<" indice:"<<p->index<<" sID="<<p->info->sessionId<<" tID="<<p->info->transactionId<<endl;
		p=p->next;
		}
	cout<<"fine elenco."<<endl;
	}
#endif
}


////////////List

template <class R,class T>
int SingleIndexedList<R,T>::insert(R ind, T* fsm) {
	el=new elem<R,R,T>(deleteFlag);
	//cout<<"single insert -   ind="<<ind<<endl;
	if( !findElem1(&ind) ) {
		el->info=fsm;
		el->index=ind;
		//cout<<"single insert - index="<<el->index<<endl;
		enqueueElem(el);
		return 0;
		}
	else {
		cout<<"list::insert(single)   - index "<<ind<<" exists"<<endl;
		return 1;
		}
}

template <class R,class S,class T>
int DoubleIndexedList<R,S,T>::insert(R ind, S ind2, T* fsm) {
	el=new elem<R,S,T>(deleteFlag);
	//cout<<"insert -   ind2="<<ind2<<endl;
	if( !findElem1(&ind) ) {
		el->info=fsm;
		el->index=ind;
		el->index2=ind2;
		//cout<<"insert - index="<<el->index<<"    index2="<<el->index2<<endl;
		enqueueElem(el);
		//cout<<"insert - index="<<el->index<<"    index2="<<el->index2<<endl;
		return 0;
		}
	else {
		cout<<"list::insert(double)   - index "<<ind<<" exists"<<endl;
		return 1;
		}
}

template <class R,class S,class T>
int List<R,S,T>::erase(R ind) {
	int r;
	elem<R,S,T>* p_el = findElem1(&ind);
	if(p_el!=NULL) {
		removeElem(p_el);
		r=0;
		}
	else r=1;
	delete p_el;
	return r;
}

template <class R,class S,class T>
Bool List<R,S,T> :: isEmpty() {
	return IsEmpty();
}

template <class R,class S,class T>
T* List<R,S,T> :: present() {
	return ((SimpleList<R,S,T>::present())->info);
}

template <class R,class S,class T>
Bool List<R,S,T> :: find(R x,T*& fsm) {
	el = findElem1(&x);
	if(el==NULL) {
		fsm=NULL;
		return(FALSE); 
		}
	else {
		fsm=el->info;
		return(TRUE);
		}
}

template <class R,class S,class T>
Bool DoubleIndexedList<R,S,T> :: find1(R* x,S*& i2,T*& inf) {
	el = findElem1(x);
	if(el==NULL) {
		i2=NULL;
		inf=NULL;
		return(FALSE); 
		}
	else {
		i2=&(el->index2);
		inf=el->info;
		return(TRUE);
		}
}

template <class R,class S,class T>
Bool DoubleIndexedList<R,S,T> :: find2(S* x,R*& i1,T*& inf) {
	el = findElem2(x,FALSE);
	if(el==NULL) {
		i1=NULL;
		inf=NULL;
		return(FALSE); 
		}
	else {
		i1=&(el->index);
		inf=el->info;
		return(TRUE);
		}
}

template <class R,class S,class T>
T* List<R,S,T> :: getPnt(R x) {
	el = findElem1(&x);
	if(el==NULL) {
		cout<<"List: not found!!"<<endl;
		cerr<<"List: not found!!"<<endl;
		return NULL;
		}
	else {
		//cout<<"getPnt, p="<<el<<endl;
		return(el->info);
		}
}

template <class R,class S,class T>
T* List<R,S,T> :: getPnt1(const char* c) {
	R x;
	x.set(c);
	el = findElem1(&x);
	if(el==NULL) {
		cout<<"List: not found."<<endl;
		return NULL;
		}
	else {
		return(el->info);
		}
}

template <class R,class S,class T>
T* DoubleIndexedList<R,S,T> :: getPnt2(const char* c,Bool goOn) {
	S x;
	x.set(c);
	el = findElem2(&x,goOn);
	if(el==NULL) {
		cout<<"List: not found."<<endl;
		return NULL;
		}
	else {
		return(el->info);
		}
}

template <class R,class S,class T>
T* DoubleIndexedList<R,S,T> :: getPnt2(S x,Bool goOn) {
	el = findElem2(&x,goOn);
	if(el==NULL) {
		//cout<<"DoubleIndexedList: not found."<<endl;
		return NULL;
		}
	else {
		return(el->info);
		}
}


template <class R,class S,class T>
Bool List<R,S,T> :: lookFor(R* x) {
	el = findElem1(x);
	if(el==NULL) {
		return(FALSE); 
		}
	else {
		return(TRUE);
		}
}


template <class R,class S,class T>
Bool DoubleIndexedList<R,S,T> :: lookFor2(S* x) {
	el = findElem2(x,FALSE);
	if(el==NULL) {
		return(FALSE); 
		}
	else {
		return(TRUE);
		}
}


template <class R,class S,class T>
Bool List<R,S,T> :: pop(T*& fsm) {
	char buf[BUFFERLEN];
	BStream bstr(buf);
	elem<R,S,T>* p_el;
	if(popElem(p_el)) {
		bstr<<*((p_el)->info);
		bstr>>fsm;
		delete(p_el);
		return TRUE;
		}
	else {
		fsm=NULL;
		delete(p_el);
		return FALSE;
		}
}


template <class R,class S,class T>
void List<R,S,T>::printFSM() {
	print();
}

template <class R,class S,class T>
void List<R,S,T>::printMSG() {
	print2();
}


#if 0
Il CC di Banco lo vuole in .h 
template <class R,class T>
List<R,T>::~List<R,T>() {
	elem<R,T>* p_el;
	while(popElem(p_el)) delete p_el;	
}
#endif
/// #if0


#endif

