/*
This software module was originally developed by Apple Computer, Inc.
in the course of development of MPEG-4. 
This software module is an implementation of a part of one or 
more MPEG-4 tools as specified by MPEG-4. 
ISO/IEC gives users of MPEG-4 free license to this
software module or modifications thereof for use in hardware 
or software products claiming conformance to MPEG-4.
Those intending to use this software module in hardware or software
products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company,
the subsequent editors and their companies, and ISO/IEC have no
liability for use of this software module or modifications thereof
in an implementation.
Copyright is not released for non MPEG-4 conforming
products. Apple Computer, Inc. retains full right to use the code for its own
purpose, assign or donate the code to a third party and to
inhibit third parties from using the code for non 
MPEG-4 conforming products.
This copyright notice must be included in all copies or
derivative works. Copyright (c) 1999.
*/
/*
	$Id: MP4TrackReaderClient.h,v 1.1.1.1 2000/01/28 23:44:52 rls Exp $
*/

#ifndef INCLUDED_MP4TRACKREADERCLIENT_H
#define INCLUDED_MP4TRACKREADERCLIENT_H

#include "MP4Movies.h"
#include "MP4Service.h"
#include "ztl.h"

class MP4TrackReaderClient
{
	public:
		enum status
		{
			starting,
			idle,
		    reading,
			writing,
			finished
		};

		MP4TrackReaderClient( MP4Track theTrack, int ESID, int chID, ServiceClientSink *sink );
		virtual ~MP4TrackReaderClient();
		
		status getStatus();
		void requestStop();
		int requestPlay();
		int getID() { return m_id; }
	private:
		void readerLoop();

		MP4Track           m_track;
		int                m_id;
		int                m_chID;
		ServiceClientSink *m_sink;
		MP4TrackReader     m_reader;
		MP4Handle          m_sampleH;
		status             m_status;
		bool               m_stopRequested;
};

#endif