/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and edited by Mauro Rossi (CSELT), George
    Tselikis (Xbind Inc.) and Michael Stepping (FTK)
    in the course of development of the MPEG-4 DMIF (ISO/IEC 14496-6)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4  DMIF  (ISO/IEC 14496-6)  tools  as  specified
    by  the  MPEG-4 DMIF (ISO/IEC 14496-6)  standard.  ISO/IEC  gives
    users of  the  MPEG-4  DMIF  (ISO/IEC 14496-6)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming  conformance  to  the  MPEG-4  DMIF 
    (ISO/IEC 14496-6). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 DMIF  (ISO/IEC 14496-6)
    conforming  products. Triton R&D Ltd.
    retains full  right to use the code for  its  own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 DMIF (ISO/IEC 14496-6)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1998.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: DMIF
 * FILE:      DAItypes.h
 * AUTHOR:    Mauro Rossi (CSELT)
 * OVERVIEW:  Definitions for the DMIF-Application Interface.
 * 
 **************************************************************************/

#ifndef _DAItypes_h_
#define _DAItypes_h_

#ifndef _WINSOCK2API_
#ifndef __unix /*rba*/
#define ntohs(n) (((n)%256)*256 + (n)/256)
#define htons(n) (((n)%256)*256 + (n)/256)
#endif
#endif

typedef unsigned char	BYTE;
#ifdef WIN32 /*rba*/
typedef unsigned short	u_short;
#elif __unix
typedef unsigned short	USHORT;
#endif
typedef unsigned int	UINT;

// Response parameter
typedef enum tagResponseParameter
{
	RESPONSE_OK								= 0x0000,
	RESPONSE_SERVICEDLL_NOT_FOUND			= 0x0001,
	RESPONSE_SERVICEDLL_ERROR				= 0x0002,
	RESPONSE_URL_NOT_RECOGNIZED				= 0x0003,
	RESPONSE_CHANNEL_NOT_FOUND				= 0x0004,
	RESPONSE_RESOURCES_EXHAUSTED			= 0x0005,
	RESPONSE_REMOTE_ERROR					= 0x0006,
	RESPONSE_URL_NOT_FOUND					= 0x0007,
	RESPONSE_END_OF_DATA					= 0x0008,
	RESPONSE_FUNCTION_NOT_SUPPORTED			= 0x0009,
	RESPONSE_CONNECTION_DOWN				= 0x000A,
	RESPONSE_CHANNEL_DELETED				= 0x000B,
	RESPONSE_FUNCTION_ABORTED				= 0x000C,
	RESPONSE_SERVICE_DOES_NOT_EXIST			= 0x000D,
	RESPONSE_SIGNALLING_ERROR				= 0x000E,
	RESPONSE_UNKNOWN_ERROR					= 0xFFFF
} RESPONSE;

// Reason parameter
typedef enum tagReasonParameter
{
	REASON_OK								= 0x0000,
	REASON_REMOTE_ERROR						= 0x0001,
	REASON_REMOTE_INITIATED					= 0x0002,
	REASON_UNKNOWN_ERROR					= 0xFFFF
} REASON;

// Direction parameter for transport content
typedef enum tagDIRECTION
{
	UNSPECIFIED				= 0x00,
	DOWNSTREAM				= 0x01,
	UPSTREAM				= 0x02,
	BIDIRECTIONAL			= 0x03
} DIRECTION;

typedef enum tagDATA
{
	DATA_OK					= 0x00,
	DATA_CORRUPTED			= 0xFF
} DATA_STATUS;

#endif  //_DAItypes_h_
