/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
#define _JAVA_
#include <stdlib.h>
#include "sommit_sectfilt_SommitSectionFilter.h"
#include "..\SI_api_Native\SFilterBridge.h"
#include <windows.h>

JNIEnv *mEnv = NULL;
JVMSupport *externalJVM;

jclass mclassk = NULL;
jmethodID methodID = NULL;
jobject sfInterface = NULL;


JNIEXPORT void JNICALL Java_sommit_sectfilt_SommitSectionFilter_startFilterNat
  (JNIEnv *env, jclass mclass, jint index, jint id, jobject I, jint PID, jbyteArray posMask, jbyteArray posValue, jbyteArray negMask, jbyteArray negValue)
{
	MessageBox(NULL, "startFilterNat enter", "***DEBUG***", MB_OK);
	STARTFUNCPTR startfilter;
	jbyte *posMaskC;
	jbyte *posValueC;
	int poslen;
	char *sig = "(I[B)V";
	
	mEnv = env;
	
	//sfInterface = mEnv->NewGlobalRef(I);
	
	sfInterface = I;
	
	//bali/hw/sectfilt/HwSfController
	if(!(mclassk = externalJVM->getEnv()->FindClass("bali/hw/sectfilt/HwSfController"))){
		MessageBox(NULL, "startFilterNat class not found", "***DEBUG***", MB_OK);
		return;
	}

	if (!(methodID = externalJVM->getEnv()->GetMethodID(mclassk, "newSection", sig))){
			MessageBox(NULL, "startFilterNat method id not found", "***DEBUG***", MB_OK);
		return;
	}

	posMaskC =  env->GetByteArrayElements( posMask, 0);
	posValueC = env->GetByteArrayElements( posValue, 0);
	poslen =    env->GetArrayLength( posValue);
/*
	posMaskC =  externalJVM->getEnv()->GetByteArrayElements( posMask, 0);
	posValueC = externalJVM->getEnv()->GetByteArrayElements( posValue, 0);
	poslen =    externalJVM->getEnv()->GetArrayLength( posValue);
*/
	startfilter = getStartFunc();
	startfilter(index,
		     id,
		     sfInterface,
		     PID,
			(unsigned char  *) posMaskC,
			(unsigned char  *) posValueC,
			NULL,
			NULL,
			poslen,
			0);

	if(externalJVM->getEnv()->ExceptionOccurred()){
		externalJVM->getEnv()->ExceptionDescribe();
		externalJVM->getEnv()->ExceptionClear();
	}
		MessageBox(NULL, "startFilterNat exit", "***DEBUG***", MB_OK);
	
	MessageBox(NULL, "startFilterNat exit without Error", "***DEBUG***", MB_OK);
 }

JNIEXPORT void JNICALL Java_sommit_sectfilt_SommitSectionFilter_stopFilterNat
  (JNIEnv *env, jclass mclass, jint index)
{
	STOPFUNCPTR stopfilter;
//	MessageBox(NULL, "stopFilterNat enter", "***DEBUG***", MB_OK);

	//menv = NULL;

	stopfilter = getStopFunc();

	stopfilter(index);

	if(externalJVM->getEnv()->ExceptionOccurred()){
		externalJVM->getEnv()->ExceptionDescribe();
		externalJVM->getEnv()->ExceptionClear();
	}

	//mEnv->DeleteGlobalRef(sfInterface);
}

__declspec (dllexport) void CnewSection(int id, unsigned char *section, int section_length)
{
	jvalue *args = new jvalue[2];
	
//	MessageBox(NULL, "CnewSection enter", "***DEBUG***", MB_OK);

	args[0].i = id; //First argument (int)
	if(section_length){
		args[1].l = mEnv->NewByteArray(section_length);
	} else {
		return;
	}
	
	mEnv->SetByteArrayRegion((jbyteArray) args[1].l, 0, section_length, (signed char *) section);

	mEnv->CallVoidMethodA(sfInterface, methodID, args);

	if(externalJVM->getEnv()->ExceptionOccurred()){
		externalJVM->getEnv()->ExceptionDescribe();
		externalJVM->getEnv()->ExceptionClear();
	}
	
}

__declspec (dllexport) void initSectionFilterImpLibrary(JVMSupport *JVM){
		externalJVM = JVM;
	}
