/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveEvent.java $
*       Last save $Date: 2000/06/06 18:43:03 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: HwSfResourceEvent.java,v $
* Revision 1.1  2000/06/06 18:43:03  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:41  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-18 10:44:26+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
*/

package bali.hw.sectfilt;
import  bali.support.Debug;
import  java.util.EventObject;

/*********************
 This event is sent to indicate a section filter resource change.

 @see HwSectionFilterData
 @see HwSectionFilter
 @see HwSectionFilterResourceListener
*/
public class  HwSfResourceEvent
	extends EventObject
{
	/** A section filter was claimed. */
	    public final static int CLAIMED    = 0;
    /** A section filter was released. */
    	public final static int RELEASED      = 1;

	/*******************
	*/
	HwSfResourceEvent( Object source, int result )
	{ 
		super( source ); 
		_result = result;
	}
	
	/*******************
	Return the result of this retrieve action.
	*/
	public int getResult()
	{
		return _result;
	}

	////////////////////////// PRIVATE /////////////////////////////////
	private int 			    _result;
}

