/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListener.java $
*       Last save $Date: 2000/06/06 18:43:04 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: ReleaseSfEnhancer.java,v $
* Revision 1.1  2000/06/06 18:43:04  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:42  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-11 11:48:02+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package bali.hw.sectfilt;
import  bali.support.Debug;
import  java.util.Vector;
/********************
This class releases a section filter when an event has been
encountered. This class is intended for SI based filter operations
that return SUCCESS or some failure message.
*/
public class ReleaseSfEnhancer
    implements HwSfListener
{
    /**************
	*/
    public ReleaseSfEnhancer( HwSfListener list )
	{
        /*DBG*/Debug.msg( Debug.HWSF_LE, Debug.IMPL, "ReleaseSfEnhancer ");
        _finished = false;
      	_list    = list;
	}
    
	/**************
	A new HwSfEvent, process the event, release the filter reosurce and resend the event.
	*/
    public void newHwSfEvent( HwSfEvent e)
    {
        /*DBG*/Debug.msg( Debug.HWSF_LE, Debug.IMPL, "ReleaseSfEnhancer newHwSfEvent");
        if ( !_finished )
        {
            /*DBG*/Debug.msg(Debug.HWSF_LE, "ReleaseSfEnhancer Event received, release filter resource");
            HwSfController sfc = (HwSfController)e.getSource();
            _finished = true;
            sfc.release();
            _list.newHwSfEvent( e );
        }
        else
        {
            /*DBG*/Debug.msg(Debug.HWSF_LE, "ReleaseSfEnhancer Already finished, event ignored.");
        }
    }
    
	
	//////////////// PRIVATE ///////////////
	private HwSfListener _list;
    private boolean      _finished;
}

