/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2000/06/06 18:43:05 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 25/03/99
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: HwTunerEvent.java,v $
* Revision 1.1  2000/06/06 18:43:05  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:44  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999-04-01 13:31:05+02  vdheuvel
* Added TUNING and TUNING_OVER event.
*
* Revision 1.1  1999-03-25 13:07:06+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
*/

package bali.hw.tuner;
import java.util.EventObject;

/************************
This event is send by the tuner when a tuning event occurs.
*/
public class HwTunerEvent
    extends EventObject
{
    /** Tuning has started. */
    public static final int TUNING         = 0;
    /** Tuning has been completed. */
    public static final int TUNING_OVER    = 1;

    /**********************
    */
    HwTunerEvent( Object source, int type )
    {
        super( source );
        _type = type;
    }
    
    /**********************
    */
    public int getType()
    {
        return _type;
    }
    
    private int _type;
       
}
