/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali.si 
*  File name   $Logfile: $
*       Last save $Date: 2000/06/06 18:43:06 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 08/02/99
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: MonitorEvent.java,v $
* Revision 1.1  2000/06/06 18:43:06  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:47  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999-04-26 17:37:26+02  vdheuvel
* The old/new table mechanism has been extended to BasicMonitor.
*
* Revision 1.1  1999-02-08 15:24:38+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
*/

package bali.retrieve;
import java.util.EventObject;
import bali.table.SITable;
/*******************
This event is send when a monitor has detected a new version of a table.
*/
public class MonitorEvent
    extends EventObject
{
	/**************
	Create a new MonitorEvent.
	@param source   The Monitor sending this event.
	@param oldTable The table previously filtered. When this event indicates
	                the first table, this value is null.
	@param newTable The new table version.
	*/
	MonitorEvent( Monitor source, SITable oldTable, SITable newTable )
	{
	    super( source );
	    _oldTable = oldTable;
	    _newTable = newTable;
	}
	
	/*****************
	Return the newly filtered table version.
	*/
	public SITable getNewTable()
	{
	    return ( _newTable );
	}

	/*****************
	Return the previously filtered table version (null when this is the
	first table).
	*/
	public SITable getOldTable()
	{
	    return ( _oldTable );
	}
	
	///////////////////// IMPLEMENTATION ////////////////////////////
	private SITable _oldTable;
	private SITable _newTable;
}







