/*******************************************************************************
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali (support package)
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListenerInterfaceAdapter.java $
*       Last save $Date: 2000/06/06 18:43:07 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 1/1/98
*  First Author        : H.v.Woerkom
*                        NatLab - Eindhoven
* 
*  Description         : ListenerInterfaceAdapter 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: RetrievalListenerInterfaceAdapter.java,v $
* Revision 1.1  2000/06/06 18:43:07  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:49  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-30 18:11:46+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
 * 
 * 2     26-03-98 15:03 Woerkom
 * After renaming operation
 * 
 * 1     26-03-98 14:19 Woerkom
 * 
 * 1     26-03-98 11:34 Woerkom
 * Interface for ListenerHandler
*
*******************************************************************************/

package bali.retrieve;
import bali.support.ListenerInterfaceAdapter;
import java.util.EventObject;
import java.util.EventListener;

/**
Adapter class for notifying RetrieveListeners.
*/

class RetrievalListenerInterfaceAdapter 
	implements ListenerInterfaceAdapter 
{
	RetrievalListenerInterfaceAdapter( RetrievalListener l )
	{
		_l = l;
	}
	
    /*******************
    Called by ActiveEventSender to send the event.
    */
	public void notifyListeners( EventObject event )
	{
		_l.newRetrievalEvent( (RetrievalEvent)event );
	}
	
	///////////// PRIVATE ///////////////
	private RetrievalListener _l;
}
