/*******************************************************************************
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali (support package)
*  File name   $Logfile: /func_test_platf2/bali/support/ListenerInterfaceAdapter.java $
*       Last save $Date: 2000/06/06 18:43:09 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 1/1/98
*  First Author        : H.v.Woerkom
*                        NatLab - Eindhoven
* 
*  Description         : ListenerInterfaceAdapter 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: ListenerInterfaceAdapter.java,v $
* Revision 1.1  2000/06/06 18:43:09  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:16:54  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-10-19 17:34:22+02  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 14:00 Vdheuvel
 * Creation
 * 
 * 2     26-03-98 15:03 Woerkom
 * After renaming operation
 * 
 * 1     26-03-98 14:19 Woerkom
 * 
 * 1     26-03-98 11:34 Woerkom
 * Interface for ListenerHandler
*
*******************************************************************************/

package bali.support;

import java.util.EventObject;

/**
Adapter class for notifying listeners.
*/

public interface ListenerInterfaceAdapter 
{
    /**
    This method will be called by the ActiveEventSender. The implementation
    of this method should call the 'post' method (or equivalent) on the
    specific Listener interface(s). This will then actually send the event
    to the listeners. This method is always called on a thread of the
    ActiveEventSender.
    */
	public void notifyListeners( EventObject event );
}
