/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/bali/si/table/TDT.java $
*       Last save $Date: 2000/06/06 18:43:12 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 10/12/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: TDT.java,v $
* Revision 1.1  2000/06/06 18:43:12  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:04  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.2  1999-04-15 09:53:18+02  vdheuvel
* Files changed to hook the system up to the TM demultipler and the
* TM hardware. Changes include, swapping the java.util.Date class
* for the bali.tm.Date class (to prevent using 64 bit floats). Changing
* the HW sect filt used by bali.hw.SectFilt.
*
* Revision 1.1  1999-02-12 15:13:40+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 2     10-11-98 15:54 Vdheuvel
 * Bug fix in TDT and TOT parsing. Changed SITable to support empty
 * constructor.
 * 
 * 1     10-11-98 10:16 Vdheuvel
 * Time Decsription Table wrapper
*/
package bali.table;

/*DATE_NORMAL*/ import  java.util.Date;
//DATE_TM*/     import  bali.tm.Date;
import bali.hw.sectfilt.HwSection;
import bali.support.Debug;
import bali.support.TablePart;
import org.davic.mpeg.dvb.DvbTransportStream;

/****************************************
This class parses the filtered PAT tables and allows access to the different PAT components.
*/
public class TDT
    extends SITable
{
	/** */ public final static int PID = 0x14; 
	/** */ public final static int TABLE_ID = 0x70; 

	/***************************************
	*/
	public TDT( TDT table, DvbTransportStream ts, Date filterTime )
	{
		super( table, new SITableInfo( 0, true, ts, filterTime ) );
	}

	/***************************************
	*/
	public TDT( HwSection[] arSec, DvbTransportStream ts, Date filterTime )
	    throws InvalidTableException
    {
		super( arSec, new SITableInfo( 0, true, ts, filterTime ) );
        /*DBG*/ Debug.msg(Debug.TABLE, "parse TOT");
    }

    /*****************
    Returns the TableIdentifier of this TDT.
    */
    public TableIdentifier getTableIdentifier()
    {
        synchronized( this )
        {
            if ( _tableIdentifier == null )
            {
                DvbTransportStream ts = _ti.getSourceTs();
                _tableIdentifier = new TableIdentifier( TableIdentifier.TDT, ts.getOriginalNetworkId(), ts.getTransportStreamId() );
            }
        }
        return _tableIdentifier;
    }

	/***************************************
	Return the UTC time of this TDT
	*/
    public Date getUTCTime()
    {
 		return _arSec[0].getUTCTime( 3 );
    }

	
}
