/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  Module              : bali 
*  File name   $Logfile: /func_test_platf2/bali/si/table/TS.java $
*       Last save $Date: 2000/06/06 18:43:13 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: TS.java,v $
* Revision 1.1  2000/06/06 18:43:13  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:05  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-30 18:18:50+01  vdheuvel
* 39 march 1999, start of archive.
* Middleware packages DAVIC API implementation.
*
 * 
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package bali.table;
import bali.support.TablePart;
import java.util.Vector;
import java.util.Enumeration;

/**************
This class represents a TS loop from a BAT or NIT.
*/
public class TS
    extends FilteredSITable
{
	TS( TablePart tp, SITableInfo ti )
	{
	    super( ti );
		_tablePart = tp;
		
        int descLen = _tablePart.get12bits( 4 );
        _descriptorList = new DescriptorList( new TablePart( _tablePart, 6, descLen ) );
		//DBG System.out.println("NIT. : TransportStream : or_nw_id "+getOriginalNetworkId()+ " , ts_id "+getTransportStreamId() );
	}

	public int getTransportStreamId()
	{
		return _tablePart.get16bits( 0 );
	}
	
	public int getOriginalNetworkId()
	{
		return _tablePart.get16bits( 2 );
	}
	
	public DescriptorList getDescriptorList()
    {
		return _descriptorList;
    }
    
    //////////////////////// PRIVATE ///////////////////////////////////
	private DescriptorList _descriptorList;
	private TablePart _tablePart;
}

