/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/org/davic/net/dvb/si/SIEventListener.java $
*       Last save $Date: 2000/06/06 18:43:19 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SIEventListener.java,v $
* Revision 1.1  2000/06/06 18:43:19  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:24  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-03-17 18:14:09+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
 * 
 * 1     9-11-98 14:01 Vdheuvel
 * Creation
*/
package org.davic.net.dvb.si;

/**
 * This interface shall be implemented by using application classes in order to listen to SI objects.
 * When this API is implemented on a JDK 1.1 or higher platform, this object will inherit from
 * java.util.EventListener
 * @see SIEventObject
 * @see SIEventObjectType
 * @since DAVIC1.3
*/

public interface SIEventListener 
    extends java.util.EventListener
{

    /**
     * This method is called back by the listened SI object to notify the listener about an event.
     * @param anEvent The notified event.
     * @see SIEventObject
     * @see SIEventObjectType
    */
    public void post(  SIEventObject anEvent );

}
