/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/org/davic/net/dvb/si/SIEventObject.java $
*       Last save $Date: 2000/06/06 18:43:20 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SIEventObject.java,v $
* Revision 1.1  2000/06/06 18:43:20  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:25  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-03-17 18:03:59+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
 * 
 * 1     9-11-98 14:01 Vdheuvel
 * Creation
*/
package org.davic.net.dvb.si;

/**
 * Objects of this class are sent to listener objects of the using application to 
 * notify an event has happened.
 * When this API is implemented on a JDK 1.1 or higher platform, this object will inherit from
 * java.util.EventObject.
 * @see SIEventObjectType
 * @see SIEventListener
 * @since DAVIC1.3
*/

public class SIEventObject 
    extends java.util.EventObject
{

    /**
     * Get the event type of this event.
     * @return The event type (the possible values are defined in the SIEventObjectType interface).
     * @see SIEventObjectType
    */
    public byte getType()
    {
        // actual code shall replace the following statement
        return (_type);
    }
    
    /**
     * When this event is of the type RUNNING_STATUS_CHANGED this method returns the new
     * running status of the source SIInformation object (the possible values are defined 
     * in the SIRunningStatus interface). If the event is of a different type this method returns -1.
     
     * @return The running status of the source SIInformation object or -1.
     * @see SIRunningStatus
     * @see #getSource
    */
    public byte getRunningStatus( )
    {
        // actual code shall replace the following statement
        return (_runStat);
    }
    
    //////////////////// IMPLEMENTATION ////////////////////
    SIEventObject( Object source, byte runStat, byte type )
    {
        super( source );
        _runStat = runStat;
        _type    = type;
    }
    
    ////////////////// PRIVATE ////////////////////////////////
    private byte _runStat;
    private byte _type;
}
