/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/org/davic/net/dvb/si/SIEventObjectType.java $
*       Last save $Date: 2000/06/06 18:43:20 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SIEventObjectType.java,v $
* Revision 1.1  2000/06/06 18:43:20  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:25  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-11-05 11:00:22+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
 * 
 * 1     9-11-98 14:01 Vdheuvel
 * Creation
 * 
 * 1     9-11-98 13:56 Vdheuvel
 * Creation
*/
package org.davic.net.dvb.si;

/**
 * This interface defines the constants corresponding to the event type values.
 * @see SIEventListener
 * @see SIEventObject
 * @since DAVIC1.3
*/

public interface SIEventObjectType
{

/**
 * The tracked object does not exist any more.
*/
public final static byte SOURCE_OBJECT_KILLED = 1;

/**
 * The running status and possible some other information of the tracked object has changed.
 * (this value is valid only if the tracked object is an SIEvent or SIService object).
*/
public final static byte RUNNING_STATUS_CHANGED = 2;

/**
 * The information represented by the tracked object has possibly changed.
*/
public final static byte WARNING_ON_INFORMATION_VALIDITY = 3;
}
