/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: /func_test_platf2/org/davic/net/dvb/si/SIIteratorImpl.java $
*       Last save $Date: 2000/06/06 18:43:20 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 28/10/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
*
* $Log: SIIteratorImpl.java,v $
* Revision 1.1  2000/06/06 18:43:20  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:26  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1998-12-01 11:44:32+01  vdheuvel
* start of archive, 29 march 1999
* DAVIC API implementation
*
 * 
 * 1     9-11-98 14:01 Vdheuvel
 * Creation
*/
package org.davic.net.dvb.si;
import  java.util.Vector;
import  java.util.Enumeration;

/**
 * This class implements SIIterator interface to allow to browse through a set of SI objects.
 * In order to maintain consistency within the set of SI objects, this browsing does NOT initiate an 
 * actual access to the stream.
 * @since DAVIC1.3
*/
public class SIIteratorImpl
	implements SIIterator
{
	/** This method implements java.util.Enumeration.hasMoreElements
	*/
	public boolean hasMoreElements()
	{
		return ( _e.hasMoreElements() );
	}

	/** This method implements java.util.Enumeration.nextElement
	*/
	public Object nextElement(	) 
	    throws java.util.NoSuchElementException
	{
		_index ++ ;
		return ( _e.nextElement() );
	}

    /**
     * Get the number of remaining objects in the iterator.
     * @return The number of remaining objects.
    */
	public int numberOfRemainingObjects(
	)
	{
		return ( _number - _index );
	}

    /////////////// PACKAGE /////////////////
    /*******************
    */
	SIIteratorImpl( Enumeration e, int number )
	{
		_number = number;
		_index  = 0;
		_e = e;
	}
	
    /*******************
    */
	SIIteratorImpl( Vector vec )
	{
	    set( vec);
	}

    /*******************
    */
	SIIteratorImpl()
	{
		// when overridden
		_e = null;
		_number = 0;
		_index  = 0;
	}
	
    /*******************
    Method used by subclasses to initialise this SIIterator using
    a Vector.
    */
	void set( Vector vec )
	{
		_number = vec.size();
		_index = 0;
		_e = vec.elements();
	}
	
	////////////// PRIVATE ////////////////////////
	private int _number;
	private int _index;
	private Enumeration _e;
}
