/*

* Copyright(c) Philips Consumer Electronics B.V. 1998

* All rights reserved. Reproduction in whole or in part is

* prohibited without the written consent of the copyright holder.

*

*  Project             : Bali

*  Module              : bali.si

*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListener.java $

*       Last save $Date: 2000/06/06 18:43:22 $

*             $Revision: 1.1 $

*          Last $Author: alavilli $

*  Creation Date       : 7/12/98

*  First Author        : S.A.F.A. van den Heuvel

*                        NatLab - Eindhoven

*

*

*  Change history      :

*  ---------------

*

* $Log: NetworkInterfaceEvent.java,v $
* Revision 1.1  2000/06/06 18:43:22  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:30  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-04-14 10:35:36+02  vdheuvel
* Creation.
*

* Revision 1.3  1998-12-11 17:52:07+01  vdheuvel

* After problem fix CSVS (it threw away all 'strange' files using ^M as /n.)

*

 *

 * 1     9-11-98 13:59 Vdheuvel

 * Creation

*/



package org.davic.net.tuning;

import java.util.EventObject;



/** Base class for events related to network interfaces

  * Events that inherit from NetworkInterfaceEvent will

  * be sent to all registered listeners, when they are sent.

  */

public abstract class NetworkInterfaceEvent 

    extends EventObject

{



  /** The constructor for the event

    * @param networkInterface the network interface which the event

    * is generated for.

    */



  public NetworkInterfaceEvent(Object networkInterface) 

  {

    super( networkInterface );

  }



  /** Returns the NetworkInterface that generated the event

    */

  public Object getSource() 

  {

    return super.getSource();

  }

}







