/*
* Copyright(c) Philips Consumer Electronics B.V. 1998
* All rights reserved. Reproduction in whole or in part is
* prohibited without the written consent of the copyright holder.
*
*  Project             : Bali
*  Module              : bali.si
*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListener.java $
*       Last save $Date: 2000/06/06 18:43:23 $
*             $Revision: 1.1 $
*          Last $Author: alavilli $
*  Creation Date       : 7/12/98
*  First Author        : S.A.F.A. van den Heuvel
*                        NatLab - Eindhoven
*
*
*  Change history      :
*  ---------------
*
* $Log: NetworkInterfaceReservedEvent.java,v $
* Revision 1.1  2000/06/06 18:43:23  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:32  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-04-14 10:35:36+02  vdheuvel
* Creation.
*
 *
 * 1     9-11-98 13:59 Vdheuvel
 * Creation
*/

package org.davic.net.tuning;
/* import org.davic.resources.ResourceStatusEvent; */

/** This event informs that the NetworkInterface returned by the
  * getNetworkInterface method has been reserved
  * by an application or other entity in the system.
  */

public class NetworkInterfaceReservedEvent
    extends org.davic.resources.ResourceStatusEvent
{
  /** Constructor for the event
    * @param ni the NetworkInterface object representing the network
    *           interface that has been reserved.
    */
  public NetworkInterfaceReservedEvent(Object ni) 
  {
    super(ni);
  }

  /** Returns the network interface that has been reserved
    * @return the NetworkInterface object representing the network interface
    *         that has been reserved
    */
  public Object getSource() 
  {
    return null;
  }

}
