/*

* Copyright(c) Philips Consumer Electronics B.V. 1998

* All rights reserved. Reproduction in whole or in part is

* prohibited without the written consent of the copyright holder.

*

*  Project             : Bali

*  Module              : bali.si

*  File name   $Logfile: /func_test_platf2/bali/si/scheduler/RetrieveListener.java $

*       Last save $Date: 2000/06/06 18:43:23 $

*             $Revision: 1.1 $

*          Last $Author: alavilli $

*  Creation Date       : 7/12/98

*  First Author        : S.A.F.A. van den Heuvel

*                        NatLab - Eindhoven

*

*

*  Change history      :

*  ---------------

*

* $Log: NetworkInterfaceTuningOverEvent.java,v $
* Revision 1.1  2000/06/06 18:43:23  alavilli
* After SISF integration into the CORE4 code
*
* Revision 1.1.2.1  1999/07/09 14:17:32  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-04-14 10:35:36+02  vdheuvel
* Creation.
*

* Revision 1.3  1998-12-11 17:58:34+01  vdheuvel

* After problem fix CSVS (it threw away all 'strange' files using ^M as /n.)

*

 *

 * 1     9-11-98 13:59 Vdheuvel

 * Creation

*/



package org.davic.net.tuning;



/** This event signals that the NetworkInterface has completed

  * its tuning action

  */	

public class NetworkInterfaceTuningOverEvent 

    extends NetworkInterfaceEvent 

{



  /** Constant for the status code that indicates that the Network Interface 

    * has been tuned to a new transport stream. 

    */

  public final static int SUCCEEDED = 0;



  /** Constant for the status code that indicates that the tuning action 

    * has failed. 

    */

  public final static int FAILED = 1;

  

  /** Constructor for the event

    * @param networkInterface NetworkInterface that generated the event

    * @param status Status code that informs if the tuning action succeeded

    */

  public NetworkInterfaceTuningOverEvent(Object networkInterface, int status)

   	{

		super(networkInterface);

		_status = status;

	}



  /** Constructor for the event

    * @param networkInterface NetworkInterface that generated the event

    * @param status Status code that informs if the tuning action succeeded

    */

  NetworkInterfaceTuningOverEvent(Object networkInterface )

   	{

		super(networkInterface);

		_status = SUCCEEDED;

	}



  /** Returns the status code of the tuning action

    * @return status code

    */

  public int getStatus() 

  {

    return _status;

  }



    //////////////////////////////// IMPLEMENTATION /////////////////////////

    private int _status;

}







