/*
* Copyright(c) Philips Consumer Electronics B.V. 1998                         
* All rights reserved. Reproduction in whole or in part is                  
* prohibited without the written consent of the copyright holder.            
*                                                                            
*  Project             : Bali
*  File name   $Logfile: $
*       Last save $Date: 2000/07/21 20:39:02 $
*             $Revision: 1.2 $
*          Last $Author: alavilli $
*  Creation Date       : early 1998
*  First Author        : H. v. Woerkom
*                        NatLab - Eindhoven
* 
*                                                                          
*  Change history      :
*  ---------------
* $Log: DescriptorListUI.java,v $
* Revision 1.2  2000/07/21 20:39:02  alavilli
* adding missing files in the previous checkin for SISF
*
* Revision 1.1.2.1  1999/07/09 14:27:28  depetris
* Aggiornati i file per lo sviluppo e il rilascio a MPEG-J.
* Integra la versione 2.5 del core.
*
* Revision 1.1  1999-04-23 14:35:57+02  vdheuvel
* Replaces old DescriptorUI
*
* Revision 1.2  1999-04-23 10:51:54+02  vdheuvel
* Adapted to the new ftp.
*
*
*/

package test_awt;

import java.awt.*;
import org.davic.net.dvb.si.*;

public class DescriptorListUI extends Panel {
	public List _dList;
	public Button exit;
	public Button refresh;
	public Frame frame;

	public DescriptorListUI( String source, SIIterator t ) {
		synchronized (t) {
			_descriptors = new Descriptor[t.numberOfRemainingObjects()];
			for (int i = 0; t.hasMoreElements(); i++) {
				_descriptors[i] = (Descriptor) t.nextElement();
			}
		}

		setLayout(new FlowLayout());

		add(new Label("Descriptors"));
		_dList = new MyList(7,false,250);
		add(_dList);

		refresh = new Button("Refresh");
		add(refresh);

		exit = new Button("Exit");
		add(exit);

		validate();

		frame = new Frame("Descriptors of " + source );
		frame.setLayout(new BorderLayout());
		frame.add("North",this);
		frame.pack();
		frame.show();

		updateAll();
	}

	public void updateAll() {
	    _dList.removeAll();
		for (int i = 0; i < _descriptors.length; i++) {
			_dList.addItem("descriptor " + _descriptors[i].getTag() + ", length " + _descriptors[i].getContentLength() );
		}
		validate();
	}

	public boolean handleEvent(Event e) {
		if (e.target == exit) {
			if (e.id == Event.ACTION_EVENT) {
				frame.dispose();
				frame = null;
			}
		} else if (e.target == _dList) {
			if (e.id == Event.ACTION_EVENT) { // double-click
				int s = _dList.getSelectedIndex();

				if (s != -1) {
					new DescriptorUI( _descriptors[s] );
				}	
			}
		} else if (e.target == refresh) {
			if (e.id == Event.ACTION_EVENT) {
				updateAll();
			}
		}
		return super.handleEvent(e);
	}

	private Descriptor _descriptors[];
}
