#if !defined(_IPMPKEY_h)  // Sentry, use file only if it's not already included.
#define _IPMPKEY_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       IPMPKEY.h
AUTHOR:     Franco Casalino (CSELT franco.casalino@cselt.it)
OVERVIEW:   Declaration of IPMPKEY, the class that handles IPMPKEY streams
-------------------------------------------------------------------------*/
#include "MuxStream.h"

class IPMPKEYStream : public Stream
{
    unsigned long m_nAU;
    float m_dt;
	int  m_cNext;
	long m_lDTS;
	long  m_nCount;
	int m_countframe;
	int m_lTime;
	long  a[4];

public:
	IPMPKEYStream (FILE *fStream, ESDesc *pDescriptor);
	virtual long GetDTS ();
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
	virtual bool IsEndOfAU () {return (!m_bStart &&
		(	m_cNext [0] == EOF ||
			(m_cNext [0] == 0 && m_cNext [1] == 0 &&
			(m_cNext [2] & 0x8c) == 0x80)
		));}
};

#endif	// _G723_h sentry