// This software module was originally developed by Wenlong Dong(Rockwell 
// Science Center) and Wei Wu(Rockwell Science Center) in the course of 
// development of the MPEG-4 Systems standard
// (ISO/IEC 14496-1).  This software module is an implementation of a part
// of one or more MPEG-4 Systems tools as specified by the MPEG-4 Systems
// standard.  ISO/IEC gives users of the MPEG-4 Systems standard free
// license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// For more information or to receive an up to date version of this module,
// you may call Wenlong Dong at wdong@usc.edu or Wei Wu at 
// weiwu@jupiter.risc.rockwell.com.
//
// Copyright 1998.

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:	Script Node
FILE: 		ScriptDefs.h
AUTHOR:		Wenlong Dong (Rockwell Science Center)
			Wei Wu       (Rockwell Science Center)
			Yuval Fisher (Rockwell Science Center)
OVERVIEW:	This file includes main routine for Vrmlscript binary decoder and
			interpreter.
----------------------------------------------------------------------*/
#ifndef _ScriptDefs_h
#define _ScriptDefs_h

#define NUMBITS_STATEMENT	3
#define NUMBITS_EXPR_TYPE	6
#define MAX_NUM_EXPR		100

enum 
{
	ST_IF, 
	ST_FOR, 
	ST_WHILE, 
	ST_RETURN, 
	ST_BREAK, 
	ST_CONTINUE, 
	ST_COMPOUND_EXPR
};

enum
{
	ET_IDENTIFIER,
	ET_STRING,
	ET_NUMBER,
	ET_CURVED_EXPR,
	ET_OBJECT_METHOD_CALL,
	ET_OBJECT_MEMBER_ACCESS,
	ET_FUNCTION_CALL,
	ET_ARRAY_DEREFERENCE,
	ET_NEW,
	ET_NOT,
	ET_ONESCOMP,
	ET_NEGATIVE,
	ET_INCREMENT,
	ET_DECREMENT,
	ET_POST_INCREMENT,
	ET_POST_DECREMENT,
	ET_MULTIPLY,
	ET_DIVIDE,
	ET_MOD,
	ET_PLUS,
	ET_MINUS,
	ET_LSHIFT,
	ET_RSHIFT,
	ET_RSHIFTFILL,
	ET_LT,
	ET_LE,
	ET_GT,
	ET_GE,
	ET_EQ,
	ET_NE,
	ET_AND,
	ET_XOR,
	ET_OR,
	ET_LAND,
	ET_LOR,
	ET_CONDTEST,
	ET_ASSIGN,
	ET_PLUSEQ,
	ET_MINUSEQ,
	ET_MULTIPLYEQ,
	ET_DIVIDEEQ,
	ET_MODEQ,
	ET_LSHIFTEQ,
	ET_RSHIFTEQ,
	ET_RSHIFTFILLEQ,
	ET_ANDEQ,
	ET_XOREQ,
	ET_OREQ,
	NUMBER_OF_EXPR_TYPE
};

#endif /* _ScriptDefs_h */