/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
/*
  $Id: EventOut.java,v 1.9 2000/12/12 21:02:23 kyong Exp $
*/

package org.iso.mpeg.mpegj.scene;

public interface EventOut
{
	public interface Anchor
	{
		int children = 0;
		int description = 1;
		int parameter = 2;
		int url = 3;
	}
	public interface AnimationStream
	{
		int loop = 0;
		int speed = 1;
		int startTime = 2;
		int stopTime = 3;
		int url = 4;
		int duration_changed = 5;
		int isActive = 6;
	}
	public interface Appearance
	{
		int material = 0;
		int texture = 1;
		int textureTransform = 2;
	}
	public interface AudioBuffer
	{
		int loop = 0;
		int pitch = 1;
		int startTime = 2;
		int stopTime = 3;
		int children = 4;
		int numChan = 5;
		int phaseGroup = 6;
		int duration_changed = 7;
		int isActive = 8;
	}
	public interface AudioClip
	{
		int description = 0;
		int loop = 1;
		int pitch = 2;
		int startTime = 3;
		int stopTime = 4;
		int url = 5;
		int duration_changed = 6;
		int isActive = 7;
	}
	public interface AudioDelay
	{
		int children = 0;
		int delay = 1;
	}
	public interface AudioFX
	{
		int children = 0;
		int orch = 1;
		int score = 2;
		int params = 3;
	}
	public interface AudioMix
	{
		int children = 0;
		int numInputs = 1;
		int matrix = 2;
	}
	public interface AudioSource
	{
		int children = 0;
		int url = 1;
		int pitch = 2;
		int speed = 3;
		int startTime = 4;
		int stopTime = 5;
	}
	public interface AudioSwitch
	{
		int children = 0;
		int whichChoice = 1;
	}
	public interface Background
	{
		int groundAngle = 0;
		int groundColor = 1;
		int backUrl = 2;
		int bottomUrl = 3;
		int frontUrl = 4;
		int leftUrl = 5;
		int rightUrl = 6;
		int topUrl = 7;
		int skyAngle = 8;
		int skyColor = 9;
		int isBound = 10;
	}
	public interface Background2D
	{
		int backColor = 0;
		int url = 1;
		int isBound = 2;
	}
	public interface Billboard
	{
		int children = 0;
		int axisOfRotation = 1;
	}
	public interface Bitmap
	{
		int scale = 0;
	}
	public interface Box
	{
	}
	public interface Circle
	{
		int radius = 0;
	}
	public interface Collision
	{
		int children = 0;
		int collide = 1;
		int collideTime = 2;
	}
	public interface Color
	{
		int color = 0;
	}
	public interface ColorInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface CompositeTexture2D
	{
		int children = 0;
		int pixelWidth = 1;
		int pixelHeight = 2;
		int background = 3;
		int viewport = 4;
	}
	public interface CompositeTexture3D
	{
		int children = 0;
		int pixelWidth = 1;
		int pixelHeight = 2;
		int background = 3;
		int fog = 4;
		int navigationInfo = 5;
		int viewpoint = 6;
	}
	public interface Conditional
	{
		int buffer = 0;
		int isActive = 1;
	}
	public interface Cone
	{
	}
	public interface Coordinate
	{
		int point = 0;
	}
	public interface Coordinate2D
	{
		int point = 0;
	}
	public interface CoordinateInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface CoordinateInterpolator2D
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface Curve2D
	{
		int point = 0;
		int fineness = 1;
		int type = 2;
	}
	public interface Cylinder
	{
	}
	public interface CylinderSensor
	{
		int autoOffset = 0;
		int diskAngle = 1;
		int enabled = 2;
		int maxAngle = 3;
		int minAngle = 4;
		int offset = 5;
		int isActive = 6;
		int rotation_changed = 7;
		int trackPoint_changed = 8;
	}
	public interface DirectionalLight
	{
		int ambientIntensity = 0;
		int color = 1;
		int direction = 2;
		int intensity = 3;
		int on = 4;
	}
	public interface DiscSensor
	{
		int autoOffset = 0;
		int enabled = 1;
		int maxAngle = 2;
		int minAngle = 3;
		int offset = 4;
		int isActive = 5;
		int rotation_changed = 6;
		int trackPoint_changed = 7;
	}
	public interface ElevationGrid
	{
		int color = 0;
		int normal = 1;
		int texCoord = 2;
	}
	public interface Expression
	{
		int expression_select1 = 0;
		int expression_intensity1 = 1;
		int expression_select2 = 2;
		int expression_intensity2 = 3;
		int init_face = 4;
		int expression_def = 5;
	}
	public interface Extrusion
	{
	}
	public interface Face
	{
		int fap = 0;
		int fdp = 1;
		int fit = 2;
		int ttsSource = 3;
		int renderedFace = 4;
	}
	public interface FaceDefMesh
	{
	}
	public interface FaceDefTables
	{
		int faceDefMesh = 0;
		int faceDefTransform = 1;
	}
	public interface FaceDefTransform
	{
	}
	public interface FAP
	{
		int viseme = 0;
		int expression = 1;
		int open_jaw = 2;
		int lower_t_midlip = 3;
		int raise_b_midlip = 4;
		int stretch_l_corner = 5;
		int stretch_r_corner = 6;
		int lower_t_lip_lm = 7;
		int lower_t_lip_rm = 8;
		int lower_b_lip_lm = 9;
		int lower_b_lip_rm = 10;
		int raise_l_cornerlip = 11;
		int raise_r_cornerlip = 12;
		int thrust_jaw = 13;
		int shift_jaw = 14;
		int push_b_lip = 15;
		int push_t_lip = 16;
		int depress_chin = 17;
		int close_t_l_eyelid = 18;
		int close_t_r_eyelid = 19;
		int close_b_l_eyelid = 20;
		int close_b_r_eyelid = 21;
		int yaw_l_eyeball = 22;
		int yaw_r_eyeball = 23;
		int pitch_l_eyeball = 24;
		int pitch_r_eyeball = 25;
		int thrust_l_eyeball = 26;
		int thrust_r_eyeball = 27;
		int dilate_l_pupil = 28;
		int dilate_r_pupil = 29;
		int raise_l_i_eyebrow = 30;
		int raise_r_i_eyebrow = 31;
		int raise_l_m_eyebrow = 32;
		int raise_r_m_eyebrow = 33;
		int raise_l_o_eyebrow = 34;
		int raise_r_o_eyebrow = 35;
		int squeeze_l_eyebrow = 36;
		int squeeze_r_eyebrow = 37;
		int puff_l_cheek = 38;
		int puff_r_cheek = 39;
		int lift_l_cheek = 40;
		int lift_r_cheek = 41;
		int shift_tongue_tip = 42;
		int raise_tongue_tip = 43;
		int thrust_tongue_tip = 44;
		int raise_tongue = 45;
		int tongue_roll = 46;
		int head_pitch = 47;
		int head_yaw = 48;
		int head_roll = 49;
		int lower_t_midlip_o = 50;
		int raise_b_midlip_o = 51;
		int stretch_l_cornerlip = 52;
		int stretch_r_cornerlip = 53;
		int lower_t_lip_lm_o = 54;
		int lower_t_lip_rm_o = 55;
		int raise_b_lip_lm_o = 56;
		int raise_b_lip_rm_o = 57;
		int raise_l_cornerlip_o = 58;
		int raise_r_cornerlip_o = 59;
		int stretch_l_nose = 60;
		int stretch_r_nose = 61;
		int raise_nose = 62;
		int bend_nose = 63;
		int raise_l_ear = 64;
		int raise_r_ear = 65;
		int pull_l_ear = 66;
		int pull_r_ear = 67;
	}
	public interface FDP
	{
		int featurePointsCoord = 0;
		int textureCoord = 1;
		int faceDefTables = 2;
		int faceSceneGraph = 3;
	}
	public interface FIT
	{
		int FAPs = 0;
		int Graph = 1;
		int numeratorExp = 2;
		int denominatorExp = 3;
		int numeratorImpulse = 4;
		int numeratorTerms = 5;
		int denominatorTerms = 6;
		int numeratorCoefs = 7;
		int denominatorCoefs = 8;
	}
	public interface Fog
	{
		int color = 0;
		int fogType = 1;
		int visibilityRange = 2;
		int isBound = 3;
	}
	public interface FontStyle
	{
	}
	public interface Form
	{
		int children = 0;
		int size = 1;
		int groups = 2;
		int constraints = 3;
		int groupsIndex = 4;
	}
	public interface Group
	{
		int children = 0;
	}
	public interface ImageTexture
	{
		int url = 0;
	}
	public interface IndexedFaceSet
	{
		int color = 0;
		int coord = 1;
		int normal = 2;
		int texCoord = 3;
	}
	public interface IndexedFaceSet2D
	{
		int color = 0;
		int coord = 1;
		int texCoord = 2;
	}
	public interface IndexedLineSet
	{
		int color = 0;
		int coord = 1;
	}
	public interface IndexedLineSet2D
	{
		int color = 0;
		int coord = 1;
	}
	public interface Inline
	{
		int url = 0;
	}
	public interface LOD
	{
		int level = 0;
	}
	public interface Layer2D
	{
		int children = 0;
		int size = 1;
		int background = 2;
		int viewport = 3;
	}
	public interface Layer3D
	{
		int children = 0;
		int size = 1;
		int background = 2;
		int fog = 3;
		int navigationInfo = 4;
		int viewpoint = 5;
	}
	public interface Layout
	{
		int children = 0;
		int wrap = 1;
		int size = 2;
		int horizontal = 3;
		int justify = 4;
		int leftToRight = 5;
		int topToBottom = 6;
		int spacing = 7;
		int smoothScroll = 8;
		int loop = 9;
		int scrollVertical = 10;
		int scrollRate = 11;
	}
	public interface LineProperties
	{
		int lineColor = 0;
		int lineStyle = 1;
		int width = 2;
	}
	public interface ListeningPoint
	{
		int jump = 0;
		int orientation = 1;
		int position = 2;
		int bindTime = 3;
		int isBound = 4;
	}
	public interface Material
	{
		int ambientIntensity = 0;
		int diffuseColor = 1;
		int emissiveColor = 2;
		int shininess = 3;
		int specularColor = 4;
		int transparency = 5;
	}
	public interface Material2D
	{
		int emissiveColor = 0;
		int filled = 1;
		int lineProps = 2;
		int transparency = 3;
	}
	public interface MovieTexture
	{
		int loop = 0;
		int speed = 1;
		int startTime = 2;
		int stopTime = 3;
		int url = 4;
		int duration_changed = 5;
		int isActive = 6;
	}
	public interface NavigationInfo
	{
		int avatarSize = 0;
		int headlight = 1;
		int speed = 2;
		int type = 3;
		int visibilityLimit = 4;
		int isBound = 5;
	}
	public interface Normal
	{
		int vector = 0;
	}
	public interface NormalInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface OrderedGroup
	{
		int children = 0;
		int order = 1;
	}
	public interface OrientationInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface PixelTexture
	{
		int image = 0;
	}
	public interface PlaneSensor
	{
		int autoOffset = 0;
		int enabled = 1;
		int maxPosition = 2;
		int minPosition = 3;
		int offset = 4;
		int isActive = 5;
		int trackPoint_changed = 6;
		int translation_changed = 7;
	}
	public interface PlaneSensor2D
	{
		int autoOffset = 0;
		int enabled = 1;
		int maxPosition = 2;
		int minPosition = 3;
		int offset = 4;
		int isActive = 5;
		int trackPoint_changed = 6;
		int translation_changed = 7;
	}
	public interface PointLight
	{
		int ambientIntensity = 0;
		int attenuation = 1;
		int color = 2;
		int intensity = 3;
		int location = 4;
		int on = 5;
		int radius = 6;
	}
	public interface PointSet
	{
		int color = 0;
		int coord = 1;
	}
	public interface PointSet2D
	{
		int color = 0;
		int coord = 1;
	}
	public interface PositionInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface PositionInterpolator2D
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface ProximitySensor2D
	{
		int center = 0;
		int size = 1;
		int enabled = 2;
		int isActive = 3;
		int position_changed = 4;
		int orientation_changed = 5;
		int enterTime = 6;
		int exitTime = 7;
	}
	public interface ProximitySensor
	{
		int center = 0;
		int size = 1;
		int enabled = 2;
		int isActive = 3;
		int position_changed = 4;
		int orientation_changed = 5;
		int enterTime = 6;
		int exitTime = 7;
	}
	public interface QuantizationParameter
	{
	}
	public interface Rectangle
	{
		int size = 0;
	}
	public interface ScalarInterpolator
	{
		int key = 0;
		int keyValue = 1;
		int value_changed = 2;
	}
	public interface Script
	{
		int url = 0;
	}
	public interface Shape
	{
		int appearance = 0;
		int geometry = 1;
	}
	public interface Sound
	{
		int direction = 0;
		int intensity = 1;
		int location = 2;
		int maxBack = 3;
		int maxFront = 4;
		int minBack = 5;
		int minFront = 6;
		int priority = 7;
		int source = 8;
	}
	public interface Sound2D
	{
		int intensity = 0;
		int location = 1;
		int source = 2;
	}
	public interface Sphere
	{
	}
	public interface SphereSensor
	{
		int autoOffset = 0;
		int enabled = 1;
		int offset = 2;
		int isActive = 3;
		int rotation_changed = 4;
		int trackPoint_changed = 5;
	}
	public interface SpotLight
	{
		int ambientIntensity = 0;
		int attenuation = 1;
		int beamWidth = 2;
		int color = 3;
		int cutOffAngle = 4;
		int direction = 5;
		int intensity = 6;
		int location = 7;
		int on = 8;
		int radius = 9;
	}
	public interface Switch
	{
		int choice = 0;
		int whichChoice = 1;
	}
	public interface TermCap
	{
		int capability = 0;
		int value = 1;
	}
	public interface Text
	{
		int string = 0;
		int length = 1;
		int fontStyle = 2;
		int maxExtent = 3;
	}
	public interface TextureCoordinate
	{
		int point = 0;
	}
	public interface TextureTransform
	{
		int center = 0;
		int rotation = 1;
		int scale = 2;
		int translation = 3;
	}
	public interface TimeSensor
	{
		int cycleInterval = 0;
		int enabled = 1;
		int loop = 2;
		int startTime = 3;
		int stopTime = 4;
		int cycleTime = 5;
		int fraction_changed = 6;
		int isActive = 7;
		int time = 8;
	}
	public interface TouchSensor
	{
		int enabled = 0;
		int hitNormal_changed = 1;
		int hitPoint_changed = 2;
		int hitTexCoord_changed = 3;
		int isActive = 4;
		int isOver = 5;
		int touchTime = 6;
	}
	public interface Transform
	{
		int center = 0;
		int children = 1;
		int rotation = 2;
		int scale = 3;
		int scaleOrientation = 4;
		int translation = 5;
	}
	public interface Transform2D
	{
		int children = 0;
		int center = 1;
		int rotationAngle = 2;
		int scale = 3;
		int scaleOrientation = 4;
		int translation = 5;
	}
	public interface Valuator
	{
		int outSFBool = 0;
		int outSFColor = 1;
		int outMFColor = 2;
		int outSFFloat = 3;
		int outMFFloat = 4;
		int outSFInt32 = 5;
		int outMFInt32 = 6;
		int outSFRotation = 7;
		int outMFRotation = 8;
		int outSFString = 9;
		int outMFString = 10;
		int outSFTime = 11;
		int outSFVec2f = 12;
		int outMFVec2f = 13;
		int outSFVec3f = 14;
		int outMFVec3f = 15;
		int Factor1 = 16;
		int Factor2 = 17;
		int Factor3 = 18;
		int Factor4 = 19;
		int Offset1 = 20;
		int Offset2 = 21;
		int Offset3 = 22;
		int Offset4 = 23;
		int Sum = 24;
	}
	public interface Viewpoint
	{
		int fieldOfView = 0;
		int jump = 1;
		int orientation = 2;
		int position = 3;
		int bindTime = 4;
		int isBound = 5;
	}
	public interface VisibilitySensor
	{
		int center = 0;
		int enabled = 1;
		int size = 2;
		int enterTime = 3;
		int exitTime = 4;
		int isActive = 5;
	}
	public interface Viseme
	{
		int viseme_select1 = 0;
		int viseme_select2 = 1;
		int viseme_blend = 2;
		int viseme_def = 3;
	}
	public interface WorldInfo
	{
	}
}
