/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
import org.iso.mpeg.mpegj.resource.*;
import org.iso.mpeg.mpegj.scene.*;
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegj.net.*;

public class NewSceneExample implements MPEGlet
{
	MpegjTerminal mpegjTerminal;
	Scene m_scene;
	MySceneListener m_sceneListener;

	public void init()
	{
		mpegjTerminal = new MpegjTerminal(this);
		m_sceneListener = new MySceneListener();
		try {
			// Getting a reference to the Scene object from the MpegjTerminal object
			m_scene = m_sceneListener.getScene( mpegjTerminal );
		} catch( MPEGJException mpegj_exp )
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		}
		catch ( InterruptedException ie )
		{ 
			System.out.println("Exception " + ie.toString());
		}
		catch ( SceneManagerNotFoundException se )
		{ 
			System.out.println("Exception " + se.toString());
		}
				
	}

	public void run()
	{

		System.out.println("**** Starting Frame Listener Test ****");		

		try 
		{
			MPRendererFrameListener x;
			mpegjTerminal.getResourceManager().getRenderer().addMPRendererFrameListener(
				x = new MPRendererFrameListener() {
					public void frameEvent(MPRendererFrameEvents event)
					{
						System.out.println("FrameEvent: " + event.toString());
					}
				},
				15  
			);
			Thread.sleep(5100);
			mpegjTerminal.getResourceManager().getRenderer().removeMPRendererFrameListener(x);
		}
		catch( MPEGJException mpegj_exp ) 
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		} 
		catch( InterruptedException ie ) 
		{
			System.out.println("Exception " + ie.toString());
		}
		
		System.out.println("**** Starting Route Test ****");		

		try 
		{
			m_scene.insertRoute(m_scene.getNode(4), EventOut.Transform2D.translation, m_scene.getNode(5), EventIn.Transform2D.translation);
			m_scene.getNode(4).sendEventIn(EventIn.Transform2D.translation,
				new SFVec2fFieldValue() {
					public float[] getSFVec2fValue() {
						float[] v = { 30,30 };
						return v;
					}
				}
			);
			m_scene.deleteRoute(m_scene.getNode(4), EventOut.Transform2D.translation, m_scene.getNode(5), EventIn.Transform2D.translation);
			m_scene.getNode(4).sendEventIn(EventIn.Transform2D.translation,
				new SFVec2fFieldValue() {
					public float[] getSFVec2fValue() {
						float[] v = { 60,60 };
						return v;
					}
				}
			);
		}
		catch( MPEGJException mpegj_exp ) 
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		} 

		System.out.println("**** Starting USENAME Test ****");		

		try 
		{
			m_scene.getNode("AAA");
			//System.out.println("node AAA " + m_scene.getNode("AAA"));
		}
		catch( MPEGJException mpegj_exp ) 
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		} 

		System.out.println("**** DONE ****");		
	}

	public void stop()
	{
	}
	public void destroy()
	{
	}

}

