/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegj.scene.*;
import java.util.Hashtable;

class MyNewNode implements SFNodeFieldValue, NewNode {
	int m_type;
	int m_id;
	Hashtable m_fields = new Hashtable();
	NodeValue m_value;
	
	MyNewNode(NodeValue value) {
		m_value = value;
	}
	
	MyNewNode(int type, int id) {
		m_type = type;
		m_id = id;
		m_value = this;
	}
	
	void setField(int defID, FieldValue value) {
		m_fields.put(new Integer(defID), value);
	}
	
	public NodeValue getSFNodeValue() {
		return m_value;
	}
	
	public int getNodeType() {
		return m_type;
	}
	
	public int getNodeID() {
		return m_id;
	}
	
	public FieldValue getField(int defID) {
		return (FieldValue) m_fields.get(new Integer(defID));
	}
}
