/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegj.scene.*;
import java.util.Hashtable;

/**
	Sets the geometry of a DEF 1 Shape node to a Box node with size 2,3,4.
	Uses two extra utility classes: MySFNode and MySFVec3f.
 */
public class MyNodeCreator {
	public void createBox(Scene scene) throws MPEGJException {
		Node shapeNode, shapeNode2;
		
		shapeNode2 = scene.getNode(1);
		shapeNode = scene.getNode(2);

		// Create the representation of the Rectangle and Circle node.
		MyNewNode rectangle = new MyNewNode(NodeType.Rectangle, 2);
		MyNewNode circle = new MyNewNode(NodeType.Circle, 2);
		
		// Add the size field to the representation.
		rectangle.setField(Field.Rectangle.size, new MySFVec2f(50, 50));
		circle.setField(Field.Circle.radius, new MySFFloatFieldValue(50));

		// Send the Box node as an eventIn to the geometry field.
		MyNewNode largeCircle = new MyNewNode(NodeType.Circle, 1);
		MyNewNode smallcircle = new MyNewNode(NodeType.Circle, 1);
		
		largeCircle.setField(Field.Circle.radius, new MySFFloatFieldValue((float)60.0));
		smallcircle.setField(Field.Circle.radius, new MySFFloatFieldValue((float)30.0));

		try 
		{
			for(int i=0; i < 4; i++) 
			{
				// Send the circle node as an eventIn to the geometry field.
				shapeNode2.sendEventIn(EventIn.Shape.geometry, largeCircle);
				shapeNode.sendEventIn(EventIn.Shape.geometry, rectangle);
				Thread.sleep(500);

				shapeNode2.sendEventIn(EventIn.Shape.geometry, smallcircle);
				shapeNode.sendEventIn(EventIn.Shape.geometry, circle);
				Thread.sleep(500);
			}
			
			
		}
		catch(InterruptedException ie) 
		{
		}
		
	}
}
