/***********************************************************************
This software module was originally developed by Zvi Lifshitz
(Triton R&D Ltd.) in the course of development of the MPEG-4 Systems
(ISO/IEC 14496-1) standard. This software module is an implementation of
a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Triton R&D Ltd. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  1999.
************************************************************************/
import org.iso.mpeg.mpegj.resource.*;
import org.iso.mpeg.mpegj.scene.*;
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegj.net.*;

public class SceneExample implements MPEGlet
{
	MpegjTerminal mpegjTerminal;
	Scene m_scene;
	MySceneListener m_sceneListener;
	MyTranslate m_translate;
	MyEventOutListener m_eventoutListener;
	MyNodeCreator m_nodeCreater;
	// other declarations

	// testing ...
	public static void main(String args[])
	{
	}

	public void init()
	{
		mpegjTerminal = new MpegjTerminal(this);
		m_sceneListener = new MySceneListener();
		try {
			// Getting a reference to the Scene object from the MpegjTerminal object
			m_scene = m_sceneListener.getScene( mpegjTerminal );
		} catch( MPEGJException mpegj_exp )
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		}
		catch ( InterruptedException ie )
		{ 
			System.out.println("Exception " + ie.toString());
		}
		catch ( SceneManagerNotFoundException se )
		{ 
			System.out.println("Exception " + se.toString());
		}
				
	}

	public void run()
	{
		System.out.println("**** Starting Translation Test ****");		
		//to access and modify a field in the BIFS scene
		final int [][] translation = new int[4][2];
		
		translation[0][0] = 0;			
		translation[0][1] = -100;
		
		translation[1][0] = -100;			
		translation[1][1] = 0;

		translation[2][0] = 0;			
		translation[2][1] = 100;

		translation[3][0] = 100;			
		translation[3][1] = 0;
		
		try 
		{
			m_translate = new MyTranslate();
			for(int i = 0; i < 16; i++) 
			{
				m_translate.translate(m_scene,translation[i%4][0],translation[i%4][1]);
				Thread.sleep(500);
			}
		} 
		catch( MPEGJException mpegj_exp ) 
		{ 
			System.out.println("Exception " + mpegj_exp.toString());
		} 
		catch( InterruptedException ie ) 
		{
			System.out.println("Exception " + ie.toString());
		}

		System.out.println("**** END Translation Test ****");		
/*
		//to receive notifications of changes to the scene
		try {
		m_eventoutListener.register(m_scene);
		}catch( MPEGJException mpegj_exp ) { }

		// creating and adding a new node (in this case, a Box node) to 
		//the Scene
		*/
		System.out.println("\n**** Node Field Test ****");
		try {
			m_nodeCreater = new MyNodeCreator();
			m_nodeCreater.createBox(m_scene);
		} catch( MPEGJException mpegj_exp )
		{ 
		}
		System.out.println("**** END Node Field Test ****");
	}

	public void stop()
	{
	}
	public void destroy()
	{
	}

}

