/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import org.iso.mpeg.mpegj.resource.*;

import org.iso.mpeg.mpegjRefImpl.resource.RendererImp;
import org.iso.mpeg.mpegjRefImpl.net.*;
import org.iso.mpeg.mpegjRefImpl.*;
import org.iso.mpeg.mpegj.decoder.MPDecoder;
import org.iso.mpeg.mpegj.decoder.*;
import org.iso.mpeg.mpegj.scene.*;

//SIA
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegj.net.*;
import org.iso.mpeg.mpegj.resource.CapabilityManagerNotFoundException;
//END SIA

/*
	Authours:
		SIA
		PRAVEEN
*/
public class AtlanticDemo extends WindowAdapter implements ActionListener, MPEGlet
{
  static AtlanticDemo mainWin;  //SIA
  JTabbedPane tabbed;
  MediaTracker tracker;
  CapabilityManager terminal;
  JFrame jframe;
  JProgressBar jpAppMemory, jpTermMemory;
  public ScrollingChart sc = null;
  public int el0, el1;
  public JLabel jAppMemoryLabel, jTermMemoryLabel;
  Color fgColor;

// SIA
	JButton alMonitorButton;
	JButton closeButton;
	ResourcesMonitor resourceMonitor;
// END SIA

// SIA: implementation of the methods of MPEGJlet interface
	MpegjTerminal MpegjTerminal = new MpegjTerminal();	
	
	private ResourceManager resourceManager;
	private NetworkManagerImp netManager;
	private DMIFMonitorImp dmifMonitor;
	
	//*** YUNTAI ***/
	// accessed from ResourceManager to change decoder
	// ...hack.. need to be fixed
	public static ResourceManager _resourceManager;	
	//*** YUNTAI ***/
	public void run(){
	}

	public void init()
	{
		try 
		{
			_resourceManager = resourceManager = MpegjTerminal.getResourceManager();
			netManager =    (NetworkManagerImp) MpegjTerminal.getNetworkManager();
			dmifMonitor =    (DMIFMonitorImp)netManager.getDMIFMonitor();            
			terminal = resourceManager.getCapabilityManager();
			if(terminal == null)
			{ 			
				throw(new CapabilityManagerNotFoundException());
			}
		} catch(NetworkManagerNotFoundException ex)
		{
		} catch(CapabilityManagerNotFoundException ex)
		{
		} catch(MPEGJException ex){
		}

	    JLabel jl;
	    jframe = new JFrame("SOMMIT MPEG-J Local Management Applet - Written by L.Deri");
	    jframe.setSize(800, 490);
	    jframe.addWindowListener((WindowListener)this);

	    tracker = new MediaTracker(jframe);
	    tabbed = new JTabbedPane();
		tabbed.addTab("Dynamic Capability", createDynamicCapabilityPanel());
	    tabbed.addTab("Static Capability",  createStaticCapabilityPanel());
	    tabbed.addTab("Terminal Profile",  createTerminalProfilePanel());
		jframe.getContentPane().setLayout(new BorderLayout());
		jframe.getContentPane().add("Center", tabbed);

		JPanel jpanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpanel.add(new ImageItem(loadImage("icons/Logo.gif")));
		jpanel.add(jl = new JLabel("(C) Finsiel 1998 on behalf of the SOMMIT Consortium."));
		jl.setMinimumSize(new Dimension(350, 30));
		jl.setPreferredSize(new Dimension(350, 30));

		jframe.getContentPane().add("South", jpanel);
		jframe.setVisible(true);
        
        //MPEGj - Integration with new API -  praveen
	    EventHandler[] EH;
	    RendererImp rend = null;
	    MPDecoder[] dec;
    		
	    // to get the chanel info from the dmif monitor
	    Vector sInfo = dmifMonitor.getServiceSessionsInfos();
	    Vector cInfo = dmifMonitor.getChannelsInfos(0);
    	
	    dec = new MPDecoder[cInfo.capacity()]; 
	    int len = cInfo.capacity();
    	 
	    EH = new EventHandler[len+1]; // one for renderer
    	
	    try {
		    rend = (RendererImp)resourceManager.getRenderer(); 
		    EH[0] = new EventHandler();
		    rend.addMPRendererMediaListener(EH[0]);    		
	    } catch( RendererNotFoundException rnfe) { }	
	    int count = 0;    
	    for ( int k = 0; k < cInfo.size(); k++ ) {
	    	long channelId = ((ChannelsDescriptor)cInfo.elementAt(k)).channelId;	
    	    long ESid = channelId;	    
	        long ODid = dmifMonitor.getODID(channelId);
	        if ( ODid != -1 ) {
		        ObjectDescriptorImp odImp = new ObjectDescriptorImp(ODid);
		        ES_DescriptorImp esImp = new ES_DescriptorImp(ESid);
		        try {
			        dec[count] = resourceManager.getDecoder(odImp, esImp);	
			        if( dec[count] != null ){
		      	    EH[count+1] = new EventHandler();
			            dec[count].addMPDecoderMediaListener(EH[count+1]);   
				    count++;			        
			        }
		        } catch( DecoderNotFoundException  dnfe) { }
          		    catch (BadNodeException bne) { }	    
	        } 
	    }	    
	    

	}
	public void stop(){}
	public void destroy(){}
//END SIA

  public static void main(String args[]) {
	// This method is not part of the MPEG-let
	// but it is added for convenience to run the MPEG-let as an application from IM1-2D
	//main code
    mainWin = new  AtlanticDemo();
	mainWin.init();
	mainWin.run();
  }

//SIA
	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand() == "ALM"){
			resourceMonitor.mainStart(dmifMonitor);
		}
		else {
			if(e.getActionCommand() == "Close")
				jframe.dispose();
		}
	 
	}
//END SIA

  public AtlanticDemo() {
    /*
	JLabel jl;
    jframe = new JFrame("SOMMIT MPEG-J Local Management Applet - Written by L.Deri");
    jframe.setSize(800, 490);
    jframe.addWindowListener((WindowListener)this);

    //terminal = new CapabilityManager(); //see init() method
    
    tracker = new MediaTracker(jframe);
    tabbed = new JTabbedPane();
    tabbed.addTab("Dynamic Capability", createDynamicCapabilityPanel());
    tabbed.addTab("Static Capability",  createStaticCapabilityPanel());
    tabbed.addTab("Terminal Profile",  createTerminalProfilePanel());
    jframe.getContentPane().setLayout(new BorderLayout());
    jframe.getContentPane().add("Center", tabbed);

    JPanel jpanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
    jpanel.add(new ImageItem(loadImage("icons/Logo.gif")));
    jpanel.add(jl = new JLabel("(C) Finsiel 1998 on behalf of the SOMMIT Consortium."));
    jl.setMinimumSize(new Dimension(350, 30));
    jl.setPreferredSize(new Dimension(350, 30));

    jframe.getContentPane().add("South", jpanel);
    
    //if(sc != null) sc.setForegroundColor(jl.getForeground());
    
    jframe.setVisible(true);*/
  }
  
  //////////////////////////////////////////////////

  private Image loadImage(String name) {
    return((new ImageIcon(name)).getImage());
  }

  //////////////////////////////////////////////////
  private Component createRow(String iconName, Object element) {
    return(createRow(iconName, element, null));
  }

  private Component createRow(Object element, JLabel label) {
    return(createRow(null, element, label));
  }

  private Component createRow(String iconName, Object element, JLabel label) {
    Component img;
    JPanel jpanel = new JPanel();
    int width, max_width=80;

    if(element == null) 
      element = "";

    jpanel.setLayout(new FlowLayout(FlowLayout.LEFT));

    if(iconName == null)
      img = null;
    else
      img = new ImageItem(loadImage("icons/"+iconName));

    if(img != null) {
      width = (max_width-img.getSize().width)/2;
      jpanel.add(Box.createHorizontalStrut(width)); // Empty box    
      jpanel.add(img);
      jpanel.add(Box.createHorizontalStrut(width)); // Empty box
    }

    if(element instanceof String)
      jpanel.add(new JLabel((String)element));
    else
      jpanel.add((Component)element);

    if(label != null)
      jpanel.add(label);
      
    return(jpanel);
  }

  //////////////////////////////////////////////////

  private Component createMultimediaPanel() {
    JPanel jpanel = new JPanel();
    JList jlist;

    jpanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    
    jpanel.add(new JLabel("Audio"));
    jlist = new JList(terminal.getAudioDrivers());
    jlist.setVisibleRowCount(3); jlist.setSelectedIndex(0);
    
    jpanel.add(new JScrollPane(jlist));

    jpanel.add(new JLabel("MIDI"));
    jlist = new JList(terminal.getMIDIDrivers());
    jlist.setVisibleRowCount(3); jlist.setSelectedIndex(0);
    jpanel.add(new JScrollPane(jlist));

    jpanel.add(new JLabel("Video"));
    jlist = new JList(terminal.getVideoDrivers());
    jlist.setVisibleRowCount(3); jlist.setSelectedIndex(0);
    jpanel.add(new JScrollPane(jlist));

    return(jpanel);
  }

  //////////////////////////////////////////////////

  private Component createStaticCapabilityPanel() {
    JPanel jpanel = new JPanel(new GridLayout(8, 1));
    String value;
    Dimension d;
    int speed = terminal.getCPUSpeed(0);

    //////////////////////////////////////////////////
    
    if(speed != -1)
        jpanel.add(createRow("CPU.gif", terminal.getCPUType(0)
    			 +" running at "+terminal.getCPUSpeed(0)+" Mhz"));
    else
        jpanel.add(createRow("CPU.gif", terminal.getCPUType(0)));
        
    jpanel.add(createRow("Mouse.gif", terminal.getMouseType()));
    d = terminal.getScreenSize();
    jpanel.add(createRow("Display.gif", terminal.getDisplayType()+" - "+d.width+"x"+d.height
			 +" - "+terminal.getDisplayColorDepth()+" bits/pixel - "
			 +terminal.getScreenResolution()+" dots/inch"));
    jpanel.add(createRow("Network.gif", terminal.getNetworkType()));
    
    jpanel.add(createRow("Ports.gif", terminal.getNumSerialPorts()+" serial port(s) - "+
			 terminal.getNumParallelPorts()+" parallel port(s)"));
    jpanel.add(createRow("Windows.gif", terminal.getOSType()+" "+terminal.getOSLanguage()));
    jpanel.add(createRow("Modem.gif",   terminal.getModemType()));

    //////////////////////////////////////////////////   
    jpanel.add(createRow("Multimedia.gif", createMultimediaPanel()));
    //////////////////////////////////////////////////

    return(new JScrollPane(jpanel));
  }

  //////////////////////////////////////////////////
  private Component createTerminalProfilePanel() {
    JPanel jpanel = new JPanel(new GridLayout(2, 1));
    String value="";

    switch(terminal.getSceneDescriptionProfile()) {
       case TerminalProfileManager.Profile_Simple:   value = "Simple"; break; 
       case TerminalProfileManager.Profile_Complete: value = "Complete"; break;     
    }
    
    jpanel.add(createRow("Movie.gif", value+" Scene Description Profile"));

    switch(terminal.getGraphicsCombinationProfile()) {
       case TerminalProfileManager.Profile_2D:    value = "2D"; break;
       case TerminalProfileManager.Profile_VRML:  value = "VRML"; break;     
       case TerminalProfileManager.Profile_Audio: value = "Audio"; break;     
    }
    
    jpanel.add(createRow("Palette.gif", value+" Graphics Combination Profile"));

    return(new JScrollPane(jpanel));
  }
  //////////////////////////////////////////////////

  private Component createDynamicCapabilityPanel() {
    JPanel jpanel = new JPanel(new GridLayout(2, 1));
    JPanel jnestedpanel = new JPanel(new GridLayout(2, 1));
    int maxVal, actVal, percentage;
    jpAppMemory = new JProgressBar();
    jpTermMemory = new JProgressBar();
    Dimension dim = new Dimension(200, 30);

    maxVal = (int)(terminal.getTotalApplicationMemory()/1024);
    actVal = maxVal-(int)(terminal.getFreeApplicationMemory()/1024);
    percentage = (int)((actVal*100)/maxVal);
    jAppMemoryLabel = new JLabel(new String(percentage+"% ["+
					  actVal+"/"+maxVal+" Kb - Java VM]"));
    jAppMemoryLabel.setMinimumSize(dim);
    jAppMemoryLabel.setPreferredSize(dim);
    jpAppMemory.setMinimum(0);
    jpAppMemory.setMaximum(maxVal);
    jpAppMemory.setValue(actVal);
    jnestedpanel.add(createRow(jpAppMemory, jAppMemoryLabel));
    
    maxVal = (int)(terminal.getTotalTerminalMemory()/1024);
    actVal = maxVal-(int)(terminal.getFreeTerminalMemory()/1024);
    percentage = (int)((actVal*100)/maxVal);
    jTermMemoryLabel = new JLabel(new String(percentage+"% ["+
					     actVal+"/"+maxVal+" Kb - Terminal]"));
    jTermMemoryLabel.setMinimumSize(dim);
    jTermMemoryLabel.setPreferredSize(dim);
    jpTermMemory.setMinimum(0);
    jpTermMemory.setMaximum(maxVal);
    jpTermMemory.setValue(actVal);
    jnestedpanel.add(createRow(jpTermMemory, jTermMemoryLabel));

    jpanel.add(createRow("MemGauge.gif", jnestedpanel));
    
    sc = new ScrollingChart();
    jpanel.add(createRow("SysMon.gif", sc));

//SIA
	alMonitorButton = new JButton("ALMonitor...");
	alMonitorButton.addActionListener(this);
	alMonitorButton.setActionCommand("ALM");
	jpanel.add(alMonitorButton);
	closeButton = new JButton("Close...");
	closeButton.addActionListener(this);
	closeButton.setSize(1,1);
	closeButton.setActionCommand("Close");
	jpanel.add(closeButton);
//END SIA
    new Thread(new Updater(this)).start();
    return(jpanel);
  }


  public void windowClosing(WindowEvent e) {
	 //SIA
	//System.exit(0);
	jframe.dispose();
	//SIA END  
  }
}


