/*
		A basic implementation of the JFrame class.
*/

import java.awt.*;
import java.io.*;
import javax.swing.*;
import org.iso.mpeg.mpegj.decoder.*;
import java.util.*;
import org.iso.mpeg.mpegj.*;
import org.iso.mpeg.mpegjRefImpl.decoder.*;

public class DecoderEventFrame extends javax.swing.JFrame
{

	public DecoderEventFrame (MPDecoderImp decoder, int cond)
	{
		dec = decoder;
		condition = cond;
		getContentPane().setLayout(null);
		setSize(405,305);
		setVisible(false);
		String exception = new String(); 
		switch( condition ) {
			case 0:
				exception = "Event: Decoder Overflow ";
				break;
			case 1:
				exception = "Event: Decoder Sync Error ";
				break;
			case 2:
				exception = "Event: Stream End ";
				break;
			case 3:
				exception = "Event: Stream Overflow";
				break;
			case 4:
				exception = "Event: Stream Start ";
				break;
			case 5:
				exception = "Event: Stream Underflow";
				break;
		}
		String source = new String();
		switch(dec.getDecoderType() ) {
			case 4:
				source = "in Video Decoder";				
				break;
			case 5:
				source = "in Audio Decoder";				
				break;
			case 9:
				source = "in MPEGJ Decoder";				
				break;

		}
		long od = dec.getOD();
		long esid =  dec.getESDescriptor().getES_ID();
		source += " (" + od + "/" + esid + ")";
		
		exp1.setText(exception);
		getContentPane().add(exp1);
		exp1.setForeground(java.awt.Color.red);
		exp1.setFont(new Font("Dialog", Font.BOLD, 15));
		exp1.setBounds(60,16,252,20);
		exp2.setText(source);
		getContentPane().add(exp2);
		exp2.setForeground(java.awt.Color.blue);
		exp2.setFont(new Font("Dialog", Font.BOLD, 15));
		exp2.setBounds(60,40,252,20);
		JLabel1.setText("Do you want to Stop the Decoder ?");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(java.awt.Color.blue);
		JLabel1.setFont(new Font("Dialog", Font.BOLD, 15));
		JLabel1.setBounds(60,65,252,20);
		JButton1.setText("Stop");
		getContentPane().add(JButton1);
		JButton1.setBounds(100,90,96,24);
		done.setText("Close");
		getContentPane().add(done);
		done.setBounds(200,90,96,24);

		JLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		JLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel2.setText("Restart the Decoder ?");
		getContentPane().add(JLabel2);
		JLabel2.setForeground(java.awt.Color.blue);
		JLabel2.setFont(new Font("Dialog", Font.BOLD, 14));
		JLabel2.setBounds(60,120,241,26);
		JLabel2.setVisible(false);
		JButton2.setText("Start");
		getContentPane().add(JButton2);
		JButton2.setBounds(144,156,96,24);
		JButton2.setVisible(false);

		attach.setText("Attach");
		getContentPane().add(attach);
		attach.setBounds(25,180,96,24);
		attach.setVisible(true);
		attach.setEnabled(false);

		detach.setText("Detach");
		getContentPane().add(detach);
		detach.setBounds(125,180,96,24);
		detach.setVisible(true);
		detach.setEnabled(true);
		//*** YUNTAI new button ***/
		// to change detach a decoder from one stream 
		// and attach to the next one
		
		attachtonext.setText("Attach to Next ES");
		getContentPane().add(attachtonext);
		attachtonext.setBounds(220,180,142,24);
		attachtonext.setVisible(true);
		attachtonext.setEnabled(false);
		//notimpl.setText("( Attach & Detach not integrated with this Release ! )");
		//getContentPane().add(notimpl);
		//notimpl.setForeground(java.awt.Color.blue);
		//notimpl.setFont(new Font("Dialog", Font.BOLD, 10));
		//notimpl.setBounds(60,220,260,20);
		if(dec.getDecoderType() == 5)
			detach.setEnabled(false);
			
		if(dec.getDecoderType() == 9) {
			detach.setEnabled(false);
			attach.setEnabled(false);
			JButton1.setEnabled(false);
			JButton2.setEnabled(false);
		}

		try {
			myAction ma = new myAction();
			//*** YUNTAI ***/
			AttachToNextAction ana = new AttachToNextAction(decoder);
			attachtonext.addActionListener(ana);		
			//*** YUNTAI ***/
			JButton1.addActionListener(ma);
			JButton2.addActionListener(ma);
			done.addActionListener(ma);
			detach.addActionListener(ma);
			attach.addActionListener(ma);
			
		}catch( Exception ex) { System.out.println("exception in frame"); }
	}

	public DecoderEventFrame (String sTitle, MPDecoderImp decoder, int cond)
	{		
		this(decoder,cond);
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new DecoderEventFrame( new MPDecoderImp(13,14), 0)).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();

		super.addNotify();

		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;

		// Adjust size of frame according to the insets and menu bar
		Insets insets = getInsets();
		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
			menuBarHeight = menuBar.getPreferredSize().height;
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	boolean frameSizeAdjusted = false;
	static boolean isStop = false;
	public MPDecoderImp dec;
	public int condition = -1;

	javax.swing.JLabel exp1 = new javax.swing.JLabel();	
	javax.swing.JLabel exp2 = new javax.swing.JLabel();	
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JButton JButton1 = new javax.swing.JButton();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JButton JButton2 = new javax.swing.JButton();
	javax.swing.JButton done = new javax.swing.JButton();
	javax.swing.JButton attach = new javax.swing.JButton();
	javax.swing.JButton detach = new javax.swing.JButton();
	javax.swing.JButton attachtonext = new javax.swing.JButton();
	javax.swing.JLabel notimpl = new javax.swing.JLabel();

	//**** YUNTAI ***/
	// new actionlistener for attachtonetxt button
	class AttachToNextAction implements java.awt.event.ActionListener
	{
		MPDecoderImp _dec = null;
		public AttachToNextAction(MPDecoderImp dec) 
		{
			_dec = dec;
		}
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			if (event.getSource() == attachtonext )				
				attachtonext_actionPerformed(_dec,event);
		}	
	}
	class myAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();			
			if (object == JButton1 ) 
				JButton1_actionPerformed(event);
			else if ( object == JButton2)
				JButton2_actionPerformed(event);				
			else if ( object == done )
				JButton3_actionPerformed(event);
			else if ( object == attach )
				JButton4_actionPerformed(event);				
			else if ( object == detach )
				JButton5_actionPerformed(event);
		}
	}
	
	void attachtonext_actionPerformed(MPDecoderImp dec, java.awt.event.ActionEvent event)
	{
		// find next stream
		Vector v = null;
		try 
		{
			v = AtlanticDemo._resourceManager.getAvailableDecoder(new DecoderTypeImp(dec.type));
		} catch(org.iso.mpeg.mpegj.decoder.InvalidDecoderTypeException e) 
		{
			return;
		}
		for (Enumeration e = v.elements() ; e.hasMoreElements() ;) {
			MPDecoderImp decImp = (MPDecoderImp)e.nextElement();
			if (decImp.getOD() == dec.getOD()) 	        
			{
				
				if (decImp.getESID() != dec.getESID()) 
				{
					decImp.detach();
					dec.attach((int)decImp.getESID());
					dispose();
					return;
				}
			}
		}
	}
	
	void JButton1_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		isStop = true;
		dec.stop();
			 
		JButton1_actionPerformed_Interaction1(event);
			 
		JButton1_actionPerformed_Interaction2(event);
	}

	void JButton1_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// JLabel2 Show the JLabel
			JLabel2.setVisible(true);
		} catch (Exception e) {
		}
	}

	void JButton1_actionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			// JButton2 Show the JButton
			JButton2.setVisible(true);
		} catch (Exception e) {
		}
	}
	
	void JButton2_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		isStop = false;	
		dec.start();
		try {
			// JLabel2 Show the JLabel
			JLabel2.setVisible(false);
			JButton2.setVisible(false);
		} catch (Exception e) {
		}	 
		dispose();
	}
	void JButton3_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		dispose();
	}
	
	void JButton4_actionPerformed(java.awt.event.ActionEvent event)
	{
		//*** YUNTAI START 
		dec.attach((int)dec.getESDescriptor().getES_ID());
		dispose();
		//*** YUNTAI END
	}

	
	void JButton5_actionPerformed(java.awt.event.ActionEvent event)
	{

		dec.detach();
		attach.setEnabled(true);
		attachtonext.setEnabled(true);
		detach.setEnabled(false);
	}


}
