/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class ImageItem extends JPanel {
    Image img;
    int w, h;
    boolean scale;
    Color repaintColor = null;
    
    ActionListener actionListener;
    
    ImageItem(Image _img) {    
        scale = false;
        if(_img != null)
          setPrivImage(_img);
        else
        {
            h = 32;
            w = 32;
        }
    }
    
    ImageItem(Image _img, int _w, int _h) {        
        scale = false;

        if(_img != null)
          setPrivImage(_img);

        h = _h;
        w = _w;
        scale = true;
    }

    private void setPrivImage(Image _img) {
        setPrivImage(_img, false);
    }
    
    private void setPrivImage(Image _img, boolean fixedSize) {
        img = _img;
    
        if((img != null) && (!fixedSize))
        {
            if(!scale)
            {
                h = img.getHeight(null);
                w = img.getWidth(null);
            }
            
            setSize(getPreferredSize());
        }
    }
    
	public Dimension getPreferredSize() {
        //System.out.println("getPreferredSize(): ["+w+", "+h+"]");
	    return(new Dimension(w, h));
	}
    
    public void setRepaintColor(Color c) {
        repaintColor = c;
    }
    
    public void paint(Graphics g) {
	    if(img != null)
	    {
            //System.out.println("paint: ["+w+", "+h+"]");
	        if(repaintColor != null)
	        {
	            g.setColor(repaintColor);
	            g.fillRect(0, 0, w, h);
	        }
	        g.drawImage(img, 0, 0, w, h, this);   
	    }
    }    
    
    public void setImage(Image _img, boolean fixedSize) {
        setPrivImage(_img, fixedSize);
        repaint();
    }
    
    public void setImage(Image _img) {
        setImage(_img, false);
    }

}