/********************************************************************
 This software module was originally developed by Roberto Becchini
 (SIA - I - SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT 
Consortium) and edited by Luca Deri (Finsiel - I - SOMMIT Consortium),
 Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import org.iso.mpeg.mpegj.net.*; 
import java.util.Vector;
import java.rmi.*;
import java.io.*;
import org.iso.mpeg.mpegjRefImpl.net.*;

public class MonitorSourceRemote implements ActionListener{
	public ResourcesMonitorRemote theMonitor;
	private int numberOfChannels;
	private String url, status;
	private JobRemote myThread;
	private QosMetrics metrics;
	private Vector sInfo = new Vector(); 
	private Vector cInfo = new Vector(); 

	public MonitorSourceRemote (ResourcesMonitorRemote monitor)
	{
		theMonitor = monitor;
		myThread = new JobRemote(this);
		myThread.start();
		
	}
	
	private int oldNumOfChan = 0; 

	public void actionPerformed(ActionEvent e){
		int i, j; 
		int k;	
		long cId; 
		try{

		sInfo = myThread.getSInfo(); 
		}
		catch(Exception exc){
			exc.printStackTrace();
			System.out.println("Unable to communicate to the remote server...");
		}
		numberOfChannels = ((ServiceSessionDescriptorImp)sInfo.elementAt(0)).numberOfChannels; 		
		
		try{
			cInfo = (Vector)(myThread.getCInfo(0)); 
		}
		catch(Exception ex){
			ex.printStackTrace();
			System.out.println("Unable to communicate to the remote server...");
		}

		Integer mint ;
		if( numberOfChannels > oldNumOfChan)
		{
			for(k = oldNumOfChan; k < numberOfChannels; k++)
			{
				cId = ((ChannelsDescriptor)cInfo.elementAt(k)).channelId;
				oldNumOfChan++;
				mint = new Integer((int)cId);
				String mstring = mint.toString((int)cId);
				theMonitor.addChannel(cId);
			}
		}
	

		for(i=0; i<theMonitor.sessions.size(); i++){
			for(j=0; j< ((SessionInformations)theMonitor.sessions.elementAt(i)).channels.size(); j++){
				
				theMonitor.updateNumberOfChannels(i, numberOfChannels);
				url = ((ServiceSessionDescriptorImp)sInfo.elementAt(0)).url; 
				theMonitor.updateUrl(i, url);
				int rate;
				rate = ((ChannelsDescriptor)cInfo.elementAt(j)).auRate;

				theMonitor.upDateAURate(i, j, rate);

				
				int err = ((ChannelsDescriptor)cInfo.elementAt(j)).error; 
				theMonitor.upDateError(i,j, err);

				theMonitor.upDateQosInformations(i, j, ((ChannelsDescriptor)cInfo.elementAt(j)).qos);

			int state;
			state= ((ChannelsDescriptor)cInfo.elementAt(j)).status;
			theMonitor.upDateStatus(i, ((ChannelsDescriptor)cInfo.elementAt(j)).channelId, state);	


			}
		}
	}
}