/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/
import java.awt.*;
import java.util.*;
import java.lang.*;

public class PieChart extends Panel {
    Vector elements;
    Image bufferedImage;
    boolean debug = true;
    static int shadow = 10; /* #pixel */
    static int gap = 30;    /* #pixel */
    static Color bgColor = new Color(204, 204, 204);
    
    PieChart() {
        elements = new Vector();
        setSize(getPreferredSize());
    }
    
  ChartElement addElement(String name, int value, Color c)
    {
        ChartElement el = new ChartElement(name, value, c);
        elements.addElement(el);
	return(el);
    }
    
  public Dimension getPreferredSize() { return(new Dimension(200+gap, 50)); }
    
  public void local_paint(Graphics g) {
        Dimension s = getSize();
        int i, j, total, begin, val, size_x, size_y, draw_y;
        
        size_x = (s.width-gap)/2;
        size_y = s.height-shadow;
        
        for(i=0, total=0; i<elements.size(); i++)
          total += (int)((ChartElement)elements.elementAt(i)).value;

        for(j=shadow; j>=0; j--) // Draw shadow
            for(i=0, begin=0; i<elements.size(); i++)
            {
              ChartElement elem = (ChartElement)elements.elementAt(i);
              val = (int)((elem.value*360)/total);

              if(j <= 1)
                g.setColor(elem.col);
              else
                g.setColor(elem.col.darker());
    
              //if(debug) System.out.println("["+size_x+", "+size_y+", "+begin+", "+val+"]");
              g.fillArc(0, j, size_x, size_y, begin, val); 

              begin += val;
            }
        
        // Draw labels
        for(i=0, begin=0; i<elements.size(); i++)
        {
          ChartElement elem = (ChartElement)elements.elementAt(i);
          draw_y = i*15+10;
          g.setColor(elem.col);
          g.fillRect(size_x+10,draw_y-10, 10, 10);
          g.setColor(Color.black);
          g.drawString(elem.name+" ["+((int)(((int)elem.value*100)/total))+"%]", size_x+25, draw_y);
        }
    }    
    
    
  private Image createOffScreen() {
    Dimension d = getPreferredSize();

    Image image = createImage(d.width, d.height);
    Graphics offscreen = image.getGraphics();
    offscreen.setColor(bgColor /*Color.lightGray*/);
    offscreen.fillRect(0, 0, d.width, d.height);
    local_paint(offscreen);
    return(image);
  }
  
  public void paint(Graphics g) {
    
    if(false)
        local_paint(g);
    else
    {
      bufferedImage = createOffScreen();
      g.drawImage(bufferedImage, 0, 0, this);    
      bufferedImage = null;
    }
  }
    
}


