 /********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.awt.*;
import java.util.*;
import java.lang.*;

public class ScrollingChart extends Panel {
    Vector elements;
    Image bufferedImage;
    boolean debug = true;
    private int lastValue; /* #pixel */
    static Color bgColor = new Color(204, 204, 204);
    private Color fgColor;
    static int scrollInterval = 10;
    static double multiple = 1.5;
    
    public ScrollingChart() {
        lastValue = 1;
        bufferedImage = null;
        setSize(getPreferredSize());
        fgColor = Color.red;
    }
    
   public void plotElement(int value)
    {
        Dimension d = getPreferredSize();
        
        //System.out.println("Plot: "+value);
        
        if(bufferedImage == null)
            return;
            
        if(value < 1) value = 1;
        if(value >= 100) value = 99;
        
        value = (int)(value * multiple);

        Graphics offscreen = bufferedImage.getGraphics();
        offscreen.copyArea(scrollInterval+2, 1, d.width-scrollInterval-3, d.height-2, -scrollInterval, 0);
        offscreen.setColor(bgColor);
        offscreen.fillRect(d.width-scrollInterval-1, 1, scrollInterval, d.height-2);
        offscreen.setColor(fgColor);
        
        Polygon poly = new Polygon();
        poly.addPoint(d.width-scrollInterval-2, d.height-lastValue);
        poly.addPoint(d.width-2, d.height-value);
        poly.addPoint(d.width-2, d.height-1);
        poly.addPoint(d.width-scrollInterval-2, d.height-1);
        offscreen.fillPolygon(poly);
        lastValue = value;
        repaint();            
    }
    
 public Dimension getPreferredSize() { return(new Dimension(400, (int)(100*multiple))); }
        
  private Image createOffScreen() {
    Dimension d = getPreferredSize();
    Image image = createImage(d.width, d.height);
    Graphics offscreen = image.getGraphics();
    offscreen.setColor(bgColor);
    offscreen.fillRect(0, 0, d.width, d.height);
    offscreen.setColor(Color.darkGray);
    offscreen.drawRect(0, 0, d.width-1, d.height-1);
    return(image);
  }
  
  public void setForegroundColor(Color c) {
    fgColor = c; 
  }

  public void paint(Graphics g) {
      if(bufferedImage == null)
          bufferedImage = createOffScreen();
      g.drawImage(bufferedImage, 0, 0, this);    
  }
    
}


