/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.util.*;
import java.awt.*;
import java.io.*;
import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

import org.iso.mpeg.mpegj.resource.*;

public class TerminalServer extends UnicastRemoteObject implements TerminalServerInterface {
  CapabilityManager terminal;


  public TerminalServer() throws RemoteException {
    super();
    terminal = new CapabilityManager();
  }

  public static void main(String args[])
  {
    // Create and install the security manager
    System.setSecurityManager(new RMISecurityManager());

    try {
      TerminalServer server = new TerminalServer();
      Naming.rebind("TerminalServer", server);
      System.out.println("TerminalServer alive 'n kickin'...");
    } catch (Exception e) {
      e.printStackTrace();
    }
  }


  public void notifyApplicationFreeMemory(long freeApplicationMemory, Observer objToNotify) 
       throws IllegalArgumentException, RemoteException  {	
	 terminal.notifyApplicationFreeMemory(freeApplicationMemory, objToNotify);
  }
    
    /* *************************************** */
  public void notifyTerminalFreeMemory(long freeTerminalMemory, Observer objToNotify) 
    throws RemoteException {
    terminal.notifyTerminalFreeMemory(freeTerminalMemory, objToNotify);
  }

    /* *************************************** */

  public void notifyTerminalLoad(long cpuLoadPercentage, Observer objToNotify)
       throws IllegalArgumentException, RemoteException  {
    terminal.notifyTerminalLoad(cpuLoadPercentage, objToNotify);
  }

    /* *************************************** */

  public void notifyTerminalNetworkLoad(long nwLoadPercentage, Observer objToNotify)
       throws IllegalArgumentException, RemoteException  {
    terminal.notifyTerminalNetworkLoad(nwLoadPercentage, objToNotify);
  }


  public void deleteObserver(Observer objToDeregister)  throws RemoteException{
    terminal.deleteObserver(objToDeregister);
  }

    /////////////////////////////////////////////    

    
  public int getNumCPUs() throws RemoteException {
    return(terminal.getNumCPUs());
  }

    /* *************************************** */

  public int getCPUSpeed(int cpuIdx) throws RemoteException {
    return(terminal.getCPUSpeed(cpuIdx));
  }
    
    /* *************************************** */
    
  public String getCPUType(int cpuIdx) throws IllegalArgumentException, RemoteException {
    return(terminal.getCPUType(cpuIdx));
  }
    
    /* *************************************** */

  public String getMouseType()  throws RemoteException{
    return(terminal.getMouseType());
  }

    /* *************************************** */

  public int getDisplayColorDepth() throws RemoteException {
    return(terminal.getDisplayColorDepth());
  }

    /* *************************************** */

  public String getDisplayType() throws RemoteException {
    return(terminal.getDisplayType());
  }

    /* *************************************** */

  public String getKeyboardType() throws RemoteException { 
    return(terminal.getKeyboardType());
  }

    /* *************************************** */

  public String getNetworkType() throws RemoteException {
    return(terminal.getNetworkType());
  }

    /* *************************************** */

  public int getNumParallelPorts() throws RemoteException {
    return(terminal.getNumParallelPorts());
  }

    /* *************************************** */

    public int getNumSerialPorts() throws RemoteException {
        return(terminal.getNumSerialPorts());
    }

    /* *************************************** */

      public Dimension getScreenSize() throws RemoteException {
        return(terminal.getScreenSize());
      }

    /* *************************************** */

      public short getScreenDepth() throws RemoteException {
        return(terminal.getScreenDepth());
      }

    /* *************************************** */

      public short getScreenResolution() throws RemoteException { 
        return(terminal.getScreenResolution());
      }

    /* *************************************** */
      public String getOSLanguage() throws RemoteException {
        return(terminal.getOSLanguage());
      }

      /* *************************************** */
      public String getOSType() throws RemoteException { 
        return(terminal.getOSType());
    }	

    /* *************************************** */

    public String getTerminalArchitecture() throws RemoteException {
        return(terminal.getTerminalArchitecture());
    }	

    /* *************************************** */

    public String[] getAudioDrivers() throws RemoteException {
        return(terminal.getAudioDrivers());
    }

    /* *************************************** */

    public String[] getMIDIDrivers() throws RemoteException {
        return(terminal.getMIDIDrivers());
    }	

    /* *************************************** */

    public String[] getVideoDrivers() throws RemoteException {
        return(terminal.getVideoDrivers());
    } 

    /* *************************************** */
 
    public String getModemType() throws RemoteException {
        return(terminal.getModemType());
    } 

    /////////////////////////////////////////////    

    public long getFreeTerminalMemory() throws RemoteException { 
        return(terminal.getFreeTerminalMemory());
    }

    /* *************************************** */

    public long getTotalTerminalMemory()  throws RemoteException { 
        return(terminal.getTotalTerminalMemory());
    }

    /* *************************************** */
    
  public long getTotalApplicationMemory()  throws RemoteException{ 
        return(terminal.getTotalApplicationMemory());
  }
    
    /* *************************************** */
    
  public long getFreeApplicationMemory()  throws RemoteException{ 
        return(terminal.getFreeApplicationMemory());
  }
    
    /* *************************************** */

  public long getTerminalLoad()  throws RemoteException {
        return(terminal.getTerminalLoad());
  }

    /* *************************************** */
    
  public long getNetworkLoad() throws RemoteException {
        return(terminal.getNetworkLoad());
  }
    
    /////////////////////////////////////////////    
    
  public short getSceneDescriptionProfile() throws RemoteException {
        return(terminal.getSceneDescriptionProfile());
  }
    
    /* *************************************** */

  public short getGraphicsCombinationProfile() throws RemoteException {
        return(terminal.getGraphicsCombinationProfile());
  }    

} // End class

