/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/

import java.util.*;
import java.rmi.*;
import java.awt.*;

public interface TerminalServerInterface extends Remote {
  public void notifyApplicationFreeMemory(long freeApplicationMemory, Observer objToNotify) throws IllegalArgumentException, RemoteException;
  public void notifyTerminalFreeMemory(long freeTerminalMemory, Observer objToNotify) throws RemoteException;
  public void notifyTerminalLoad(long cpuLoadPercentage, Observer objToNotify) throws IllegalArgumentException, RemoteException;
  public void notifyTerminalNetworkLoad(long nwLoadPercentage, Observer objToNotify) throws IllegalArgumentException, RemoteException;
  public void deleteObserver(Observer objToDeregister) throws RemoteException;
  public int getNumCPUs() throws RemoteException ;
  public int getCPUSpeed(int cpuIdx) throws RemoteException;
  public String getCPUType(int cpuIdx) throws IllegalArgumentException, RemoteException;
  public String getMouseType() throws RemoteException;
  public int getDisplayColorDepth() throws RemoteException;
  public String getDisplayType() throws RemoteException;
  public String getKeyboardType() throws RemoteException;
  public String getNetworkType() throws RemoteException;
  public int getNumParallelPorts() throws RemoteException;
  public int getNumSerialPorts() throws RemoteException;
  public Dimension getScreenSize() throws RemoteException;
  public short getScreenDepth() throws RemoteException;
  public short getScreenResolution() throws RemoteException;
  public String getOSLanguage() throws RemoteException;
  public String getOSType() throws RemoteException;
  public String getTerminalArchitecture() throws RemoteException;
  public String[] getAudioDrivers() throws RemoteException;
  public String[] getMIDIDrivers() throws RemoteException;
  public String[] getVideoDrivers() throws RemoteException;
  public String getModemType() throws RemoteException;
  public long getFreeTerminalMemory() throws RemoteException;
  public long getTotalTerminalMemory() throws RemoteException;
  public long getTotalApplicationMemory() throws RemoteException;
  public long getFreeApplicationMemory() throws RemoteException;
  public long getTerminalLoad() throws RemoteException;
  public long getNetworkLoad() throws RemoteException;
  public short getSceneDescriptionProfile() throws RemoteException;
  public short getGraphicsCombinationProfile() throws RemoteException;
}