/********************************************************************
 This software module was originally developed by Luca Deri (Finsiel 
- I - SOMMIT Consortium) and edited by Roberto Becchini (SIA - I - 
SOMMIT Consortium), Barbara Silano (SIA - I - SOMMIT Consortium), 
Gianluca De Petris (CSELT - I - SOMMIT Consortium) in the course of 
development of the MPEG-4 Systems (ISO/IEC 14496-1). This software 
module is an implementation of part of one or more MPEG-4 Systems 
(ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems (ISO/IEC 
14496-1). ISO/IEC gives users of the MPEG-4 Systems (ISO/IEC 14496-1) 
free license to this software module or modifications thereof for use 
in hardware or software products claiming conformance to the MPEG-4 
Systems (ISO/IEC 14496-1). Those intending to use this software 
module in hardware or software products are advised that its use may 
infringe existing patents. THE ORIGINAL DEVELOPER OF THIS SOFTWARE 
MODULE AND HIS/HER COMPANY, THE SUBSEQUENT EDITORS AND THEIR 
COMPANIES, AND ISO/IEC HAVE NO LIABILITY FOR USE OF THIS SOFTWARE 
MODULE OR MODIFICATIONS THEREOF. No license to this software module 
is granted for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. The SOMMIT Consortium retains full right to use the 
software module for his/her own purpose, assign or donate the 
software module to a third party and to inhibit third parties from 
using the code for non MPEG-4 Systems (ISO/IEC 14496-1) conforming 
products. This copyright notice must be included in all copies or 
derivative works of the software module. Copyright 1999
********************************************************************/
 
 /**
 *
 *
 * <p>This class is used to update the management applet by periodically polling data.
 * 
 * @author  Luca Deri (l.deri@tecsiel.it)
 * @version 1.0, 11/1998
 */

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*;
import org.iso.mpeg.mpegj.resource.*;


public class Updater implements Runnable {
	AtlanticDemo theDemo;

	public Updater(AtlanticDemo _theDemo) {
    	theDemo = _theDemo;
  	}

 	public void run() {
    	for(;;) {      
      		int maxVal, actVal, percentage;
      		String actStr, tmpVal, tmpVal1;

      		maxVal = (int)(theDemo.terminal.getTotalApplicationMemory()/1024);
	      	actVal = maxVal-(int)(theDemo.terminal.getFreeApplicationMemory()/1024);

	      	if(actVal > 1024)
	        	tmpVal = (int)(actVal/1024)+" Mb";
	      	else
	        	tmpVal = (int)(actVal)+" Kb";
	 
		   	if(maxVal > 1024)
		    	tmpVal1 = (int)(maxVal/1024)+" Mb";
	      	else
	        	tmpVal1 = (int)(maxVal)+" Kb";
	      
	      	percentage = (int)((actVal*100)/maxVal);
	      	actStr = new String(percentage+"% ["+tmpVal+"/"+tmpVal1+" - Java VM]");
	      	theDemo.jpAppMemory.setValue(actVal);
	      	theDemo.jAppMemoryLabel.setText(actStr);

	      	maxVal = (int)(theDemo.terminal.getTotalTerminalMemory()/1024);
	      	actVal = maxVal-(int)(theDemo.terminal.getFreeTerminalMemory()/1024);
	      	percentage = (int)((actVal*100)/maxVal);
	      	if(actVal > 1024)
        		tmpVal = (int)(actVal/1024)+" Mb";
      		else
        		tmpVal = (int)(actVal)+" Kb";
 
      		if(maxVal > 1024)
        		tmpVal1 = (int)(maxVal/1024)+" Mb";
      		else
        		tmpVal1 = (int)(maxVal)+" Kb";

      		actStr = new String(percentage+"% ["+tmpVal+"/"+tmpVal1+" - Terminal]");
      		theDemo.jpTermMemory.setValue(actVal);
      		theDemo.jTermMemoryLabel.setText(actStr);

      		theDemo.sc.plotElement((int)theDemo.terminal.getTerminalLoad());
      
      		try { Thread.sleep(3000); } catch(Exception ex) { ; }
    	}
  	}
}
