/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.), Mauro Rossi (CSELT) and Guido Franceschini
    (CSELT), and edited by Michael Stepping (FTK)
    in the course of development of the MPEG-4 DMIF (ISO/IEC 14496-6)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4  DMIF  (ISO/IEC 14496-6)  tools  as  specified
    by  the  MPEG-4 DMIF (ISO/IEC 14496-6)  standard.  ISO/IEC  gives
    users of  the  MPEG-4  DMIF  (ISO/IEC 14496-6)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming  conformance  to  the  MPEG-4  DMIF 
    (ISO/IEC 14496-6). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 DMIF  (ISO/IEC 14496-6)
    conforming  products. Triton R&D Ltd. and CSELT
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non  MPEG-4  DMIF  (ISO/IEC 14496-6)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1998.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: DMIF
 * FILE:      ChSemList.h
 * OVERVIEW:  Definitions of the ChannelSemaphoreList
 * 
 **************************************************************************/

#ifndef _ChSemList_h_
#define _ChSemList_h_

#include "MList.h"

class ChannelSemaphoreListElement
{
public:
	DWORD		m_nThreadId;
	ZSemaphore	m_smpChannelSemaphore;
	ZSemaphore	m_smpDataReadySemaphore;
public:
	ChannelSemaphoreListElement() :
	  	m_nThreadId(0)
	{}
	bool operator == (ChannelSemaphoreListElement const &el) const 
	{return (m_nThreadId == el.m_nThreadId);}
};

class ChannelSemaphoreList
{
private:
	MList<ChannelSemaphoreListElement>* m_pList;
	ZSemaphore	m_smpListSemaphore;
public:
	ChannelSemaphoreList();
	~ChannelSemaphoreList();
	ChannelSemaphoreListElement* 	AddThread		(DWORD p_nThreadId);
	ChannelSemaphoreListElement*	GetElementPtr	(DWORD p_nThreadId);
	void	DeleteThread		(DWORD p_nThreadId);
//	int		DataReadySemaphoreP	(DWORD p_nThreadId);
//	int		DataReadySemaphoreV	(DWORD p_nThreadId);
//	int		ChannelSemaphoreP	(DWORD p_nThreadId);
//	int		ChannelSemaphoreV	(DWORD p_nThreadId);
};

#endif _ChSemList_h_
