/*
This software module was originally developed by Apple Computer, Inc.
and edited by Guido Franceschini (CSELT) in the course of development of MPEG-4. 
This software module is an implementation of a part of one or 
more MPEG-4 tools as specified by MPEG-4. 
ISO/IEC gives users of MPEG-4 free license to this
software module or modifications thereof for use in hardware 
or software products claiming conformance to MPEG-4.
Those intending to use this software module in hardware or software
products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company,
the subsequent editors and their companies, and ISO/IEC have no
liability for use of this software module or modifications thereof
in an implementation.
Copyright is not released for non MPEG-4 conforming
products. Apple Computer, Inc. retains full right to use the code for its own
purpose, assign or donate the code to a third party and to
inhibit third parties from using the code for non 
MPEG-4 conforming products.
This copyright notice must be included in all copies or
derivative works. Copyright (c) 1999.
*/
/*
	$Id: MP4TrackReaderClient.h,v 1.2 2000/01/20 00:15:18 mleditsc Exp $
*/

#ifndef INCLUDED_MP4TRACKREADERCLIENT_H
#define INCLUDED_MP4TRACKREADERCLIENT_H

#include "MP4Movies.h"
#include "FileMP4Instance.h"
#include "ztl.h"

class MP4TrackReaderClient
{
	public:
		enum status
		{
			starting,
			idle,
		    reading,
			writing,
			finished,
			eof
		};
		enum mode
		{
			play,
			pause,
		    stop
		};

		MP4TrackReaderClient( MP4Track theTrack, int ESID, int chID, int nTmpId, ServiceSink_base *sink, Service_base *pService );
		virtual ~MP4TrackReaderClient();
		
		status getStatus();
		void requestPlay();
		void requestPause();
		void requestStop();
		int getchID() { return m_chID; } // CSELT added
	private:
		void readerLoop();

		MP4Track           m_track;
		int                m_id;
		int                m_chID;
		int				   m_nTmpId;
		ServiceSink_base*  m_sink;
		Service_base*      m_pService;
		MP4TrackReader     m_reader;
		MP4Handle          m_sampleH;
		status             m_status;
		mode               m_mode;
		ZSemaphore         m_smpMode;
};

#endif