#include "G723Class.H"

#include "TypeDef2.h" // Include for G723 types
#include "Decod2.h" // Include for G723 C functions

#include "Deccng2.h"

// riitta 060399
#include "g723.h"

extern "C"
{
  enum Crate WrkRate;
}

/*******************************************************************************
the entry point to the decoder DLL
*******************************************************************************/

void * CreateInstance()
{
  return new G723Class;
}

/*******************************************************************************
*******************************************************************************/

/* virtual */
bool G723Class::Init()
{
  Init_Decod();
  Init_Dec_Cng();

  return TRUE;
}

/* virtual */
void G723Class::Run()
{
  Init();

  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
  DecoderImp::Run();
}

/* virtual */
BOOL G723Class::Decode(
  unsigned char * pucInput,
  int /*iInputLength*/,
  unsigned char * pucOutput,
  int & riOutputLength)
{
//  int iError;

  if (riOutputLength < GetOptimalOutputSize())
  {
    riOutputLength = GetOptimalOutputSize();
	  TRACE("G723Class::Decode: OutLength: %d, OptOutSize: %d \n", riOutputLength, GetOptimalOutputSize());

    return FALSE;
  }

  // riitta 060399 
  // I'd suggest to use the G723Dec function (in g723.c) that takes care of
  // double to short conversion etc...

  // iError = Decod(madOutput, (char *) pucInput, 0); 
  // what's mad output anyway?
  // riitta 060399 This is done as used to be in Telenor player

	if (!G723Dec ((char *)pucOutput, (char *)pucInput)) {
		COMPLAIN("couldn't decode G.723 frame\n");
		TRACE("G723Class::Decode: COULDN'T decode: pInput %08x, pOutput %08x \n", pucInput,pucOutput);
		return FALSE;
	}

	riOutputLength = 480;
  TRACE("G723Class::Decode: pInput %08x, pOutput %08x \n", pucInput, pucOutput);

  return TRUE;
}

// riitta 060399
/*-----------------------------------------------------------------
Find a compatible format and initialize the decoder
-----------------------------------------------------------------*/

BOOL G723Class :: SetFormat (
	Capabilities &formatOptions,
	DecoderParams &decoderParams
)
{
	int i;

	for (i = 0; i < formatOptions.GetFormatCapabilityLength (); i++)
		if (formatOptions.GetFormatCapability (i) == MediaFormat :: PCM)
		{	
			decoderParams.m_nStreamNumber = 0;
			decoderParams.m_format = MediaFormat (MediaFormat :: PCM);
			decoderParams.m_nOptimalAUSize = 24;
			decoderParams.m_nDBSize = 256;
			decoderParams.m_nCBSize = 960;
			decoderParams.m_bRequiresFullAUs = TRUE;
      // riitta 060399
      // INITdec (G723_53);
			return TRUE;
		}

	return FALSE;
}

