#include "JpegClass.H"

/*******************************************************************************
the entry point to the decoder DLL
*******************************************************************************/

void * CreateInstance()
{
  return new JpegClass;
}

/*******************************************************************************
*******************************************************************************/

JpegClass :: JpegClass ()
{
  musWidth = 1024;
  musHeight = 1024;
}

JpegClass :: ~JpegClass ()
{
}

/* virtual */
bool JpegClass::Init()
{
  return TRUE;
}

/* virtual */
void JpegClass::Run()
{
  TRACE("[JPEG::Run] \n");

  Init();

  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
  DecoderImp::Run();
}

/* virtual */
BOOL JpegClass :: Decode (
	LPBYTE pucInput,
	int iInputLength,
	LPBYTE pucOutput,
	int & riOutputLength
)
{
  TRACE("[JPEG::Decode] before W %4d H %4d \n",
    musWidth, musHeight);
  JpegDecodeInMemory (
    pucInput,
    iInputLength,
		pucOutput + 4, 
    &riOutputLength,
		&musWidth, &musHeight);
  // put Width & Height in the first 4 bytes...
  pucOutput[0] = (musWidth >> 8) & 0xff;
  pucOutput[1] = (musWidth) & 0xff;
  pucOutput[2] = (musHeight >> 8) & 0xff;
  pucOutput[3] = (musHeight) & 0xff;
  TRACE("[JPEG::Decode] before W %4d H %4d \n",
    musWidth, musHeight);

  return TRUE;
}

