#ifndef __MPEG4CLASS_H__
#define __MPEG4CLASS_H__

// estiamted length of compressed Access Unit
// SB: these are brutal guesses!!!!

#define M4V_OPTIMALINPUTSIZE  10000
#define M4V_RECOMMENDEDINPUTSIZE  10000

#include "Defs.h"

#include "Mpeg4Dec.h"

class Mpeg4Class : public DecoderImp
{
private:
  MPEG4Decoder * mpoDecoder;

  int miHeight;
  int miWidth;

  BOOL mbInitialised;

  int miOptimalOutputSize;
  int miRecommendedOutputSize;
  int miOutputFormat;
  int miOutputSize;
public:
  Mpeg4Class();
  ~Mpeg4Class();

  virtual bool Init();
  virtual void Run();
  virtual BOOL Decode(
    unsigned char * pucInput,
    int iInputLength,
    unsigned char * pucOutput,
    int & riOutputLength);

  virtual MediaFormat GetFormat();
  virtual MediaFormat SetFormat(
    Capabilities * poCaps);
  virtual int GetOptimalInputSize();
  virtual int GetOptimalOutputSize();
  virtual bool SetOutputBufferFormat(int iFormat);
  virtual int GetRecommendedInputBufferSize();
  virtual int GetRecommendedOutputBufferSize();

  static void Yuv422ToRgb(
    unsigned char* rgbdata,
    short int * yptr,
    short int * uptr,
    short int * vptr,
    int lumcols, int lumrows);
  static void Yuv422ToRgba(
    unsigned char* rgbdata,
    short int * yptr,
    short int * uptr,
    short int * vptr,
    short int * aptr,
    int lumcols, int lumrows);
  static struct yuvconvtable {
    int u1;
    int u2;
    int v1;
    int v2;
  } convtab[256];
  static int cliptab[768];
};

#endif // __MPEG4CLASS_H__
