// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#include "defs.h"
#include "VideoObject2DProxy.h"
#include "Stream.h"
#include "opengl/base/OpenGLVisualRenderer.h"
#include "opengl/base/OpenGLPresenter.h"
// Stefano Battista 98/11/12
// #include "group/Root.h"
#include "Nodes.h"

// Render object description

/* virtual */ void
VideoObject2DProxy::RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD)
{
  RenderDescriptionBox(pRenderer, "VideoObject2D");
}

// Render object

/* virtual */ BOOL
VideoObject2DProxy::Render(const Matrix& rTransformation, const CullFlag& rCullFlag,
                           OpenGLVisualRenderer* pRenderer, DWORD dwTime)
{
  VideoObject2D* pVideoObject = (VideoObject2D*) GetMediaObject();
  MediaStream* pStream = pVideoObject->GetStream();
  
  /* pVideoObject-> */ TestActive();
  
  if (pStream)
    if (/* pVideoObject-> */ GetIsActive()) {
      pRenderer->RegisterStreamConsumer(pVideoObject);
      
      return TextureNode2DProxy::Render(rTransformation, rCullFlag,
        pRenderer, dwTime);
    }
    
    return TRUE;
}


// Test whether movie should be activated or deactivated

void VideoObject2DProxy::TestActive()
{
  VideoObject2D * poVideoObject = GetVideoObject2D();
  
  Time currentTime = poVideoObject->GetRoot()-> /* GetClock(). */ GetTime() / 1000.0;
  
  if ((Bool) poVideoObject->isActive) {
    if (poVideoObject->startTime > currentTime)
      poVideoObject->isActive = FALSE;
    else
      if (!(Bool) poVideoObject->loop)
        if (poVideoObject->stopTime < currentTime && 
            poVideoObject->stopTime > poVideoObject->startTime)
          poVideoObject->isActive = FALSE;
  } else
    if (poVideoObject->startTime <= currentTime)
      if (poVideoObject->stopTime < poVideoObject->startTime)
        poVideoObject->isActive = TRUE;
      else
        if ((Bool) poVideoObject->loop && 
            poVideoObject->stopTime == poVideoObject->startTime)
          poVideoObject->isActive = TRUE;
        else
          if (poVideoObject->stopTime > poVideoObject->startTime && 
              currentTime <= poVideoObject->stopTime)
            poVideoObject->isActive = TRUE;
}

