// -*- c++ -*-

// This software module was originally developed by Karl Anders ygard
// (Telenor R&D) in the course of development of the MPEG-4 Systems
// standard (ISO/IEC 14496-1).  This software module is an implementation
// of a part of one or more MPEG-4 Systems tools as specified by the MPEG-4
// Systems standard.  ISO/IEC gives users of the MPEG-4 Systems standard
// free license to this software module or modifications thereof for use in
// hardware or software products claiming conformance to the MPEG-4 Systems
// standard.  Those intending to use this software module in hardware or
// software products are advised that its use may infringe existing
// patents.  The original developer of this software module and his/her
// company, the subsequent editors and their companies, and ISO/IEC have no
// liability for use of this software module or modifications thereof in an
// implementation.  Copyright is not released for non MPEG-4 Systems
// conforming products.  The original developer retains full right to use
// the code for his/her own purpose, assign or donate the code to a third
// party and to inhibit third parties from using the code for non MPEG-4
// Systems conforming products.  This copyright notice must be included in
// all copies or derivative works.
//
// Copyright 1997.

#ifndef __VIDEOOBJECT2DPROXY_H__
#define __VIDEOOBJECT2DPROXY_H__

#include "TextureNode2DProxy.h"

class VideoObject2D;

/// VideoObject2D renderer class

class VideoObject2DProxy
  : public TextureNode2DProxy
{
public:

  /// Constructor

			VideoObject2DProxy(VideoObject2D* pVideoObject2D);

  /// Render object description

  virtual void		RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

protected:

  /// Render object

  virtual BOOL		Render(const Matrix& rTransformation, const CullFlag& rCullFlag,
			       OpenGLVisualRenderer* pRenderer, DWORD dwTime);

  // SB moved from VideoObject2D
public:
  inline VideoObject2D * GetVideoObject2D()
  { return (VideoObject2D *) GetMediaObject(); }
  // Get whether video should loop
  inline BOOL GetLoop() /* const */
  { return (Bool) GetVideoObject2D()->loop; }
  // Get whether video is active
  inline BOOL GetIsActive() /* const */
  { return (Bool) GetVideoObject2D()->isActive; }

  // Test whether movie should be activated or deactivated
  void TestActive();
};

#include "VideoObject2DProxy.i"

#endif // __VIDEOOBJECT2DPROXY_H__
