/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeTabl.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  Node Data Type tables.
 * 
 * Comment:   Automatically generated on Wed Jul 04 19:40:31 PDT 2001
 *            at Melbourne, Australia
 *            by parsing the MPEG-4 templates.txt file.
 *            Contact: mikeseven@hotmail.com
 *
 **************************************************************************/
#include "defs.h"
#include "Im1defs.h"
#include "Nodes.h"
#include "CrNodes.h"

/* Here are 37 node data types. */
/* and 27 tables have only one node: 
 *    SFAppearanceNode, SFBAPNode, SFBDPNode, 
 *    SFBackground2DNode, SFBackground3DNode, SFBodyDefTableNode, 
 *    SFBodySegmentConnectionHintNode, SFColorNode, SFCoordinate2DNode, 
 *    SFCoordinateNode, SFExpressionNode, SFFAPNode, 
 *    SFFDPNode, SFFITNode, SFFaceDefMeshNode, 
 *    SFFaceDefTablesNode, SFFaceDefTransformNode, SFFogNode, 
 *    SFFontStyleNode, SFLinePropertiesNode, SFNavigationInfoNode, 
 *    SFNormalNode, SFPerceptualParameterNode, SFTextureCoordinateNode, 
 *    SFTextureTransformNode, SFViewpointNode, SFVisemeNode
 */

/* In SF2DNode, we have 41 nodes defined. */
const int SF2DNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background2D :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	OrderedGroup :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound2D :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	WorldInfo :: nodeCode,
	ApplicationWindow :: nodeCode,
	Body :: nodeCode,
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
	MediaSensor :: nodeCode,
	MediaControl :: nodeCode,
	MediaBuffer :: nodeCode,
	MatteTexture :: nodeCode,
	InputSensor :: nodeCode
};

/* In SF3DNode, we have 63 nodes defined. */
const int SF3DNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Collision :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Fog :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	ListeningPoint :: nodeCode,
	NavigationInfo :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	WorldInfo :: nodeCode,
// Version 2 nodes
	AcousticScene :: nodeCode,
	Body :: nodeCode,
	DirectiveSound :: nodeCode,
// Version 3 nodes
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
// Version 4 nodes
	MediaSensor :: nodeCode,
	MediaControl :: nodeCode,
	MediaBuffer :: nodeCode,
	MatteTexture :: nodeCode,
	InputSensor :: nodeCode
};

/* In SFAudioNode, we have 7 nodes defined. */
const int SFAudioNode :: m_nodeTable[]={
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode
};

/* In SFGeometryNode, we have 18 nodes defined. */
const int SFGeometryNode :: m_nodeTable[]={
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Cone :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	ElevationGrid :: nodeCode,
	Extrusion :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	Rectangle :: nodeCode,
	Sphere :: nodeCode,
	Text :: nodeCode,
	Hierarchical3DMesh :: nodeCode
};

/* In SFMaterialNode, we have 4 nodes defined. */
const int SFMaterialNode :: m_nodeTable[]={
	Material :: nodeCode,
	Material2D :: nodeCode,
	AcousticMaterial :: nodeCode,
	MaterialKey :: nodeCode
};

/* In SFStreamingNode, we have 5 nodes defined. */
const int SFStreamingNode :: m_nodeTable[]={
	AnimationStream :: nodeCode,
	AudioClip :: nodeCode,
	AudioSource :: nodeCode,
	Inline :: nodeCode,
	MovieTexture :: nodeCode
};

/* In SFTemporalNode, we have 2 nodes defined. */
const int SFTemporalNode :: m_nodeTable[]={
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode
};

/* In SFTextureNode, we have 5 nodes defined. */
const int SFTextureNode :: m_nodeTable[]={
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	ImageTexture :: nodeCode,
	MovieTexture :: nodeCode,
	PixelTexture :: nodeCode
};

/* In SFTopNode, we have 4 nodes defined. */
const int SFTopNode :: m_nodeTable[]={
	Group :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	OrderedGroup :: nodeCode
};

/* In SFWorldNode, we have 120 nodes defined. */
const int SFWorldNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Appearance :: nodeCode,
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Collision :: nodeCode,
	Color :: nodeCode,
	ColorInterpolator :: nodeCode,
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	Conditional :: nodeCode,
	Cone :: nodeCode,
	Coordinate :: nodeCode,
	Coordinate2D :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	ElevationGrid :: nodeCode,
	Expression :: nodeCode,
	Extrusion :: nodeCode,
	Face :: nodeCode,
	FaceDefMesh :: nodeCode,
	FaceDefTables :: nodeCode,
	FaceDefTransform :: nodeCode,
	FAP :: nodeCode,
	FDP :: nodeCode,
	FIT :: nodeCode,
	Fog :: nodeCode,
	FontStyle :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	ImageTexture :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	LineProperties :: nodeCode,
	ListeningPoint :: nodeCode,
	Material :: nodeCode,
	Material2D :: nodeCode,
	MovieTexture :: nodeCode,
	NavigationInfo :: nodeCode,
	Normal :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PixelTexture :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	Rectangle :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	Sphere :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	Text :: nodeCode,
	TextureCoordinate :: nodeCode,
	TextureTransform :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	Viseme :: nodeCode,
	WorldInfo :: nodeCode,
	AcousticMaterial :: nodeCode,
	AcousticScene :: nodeCode,
	ApplicationWindow :: nodeCode,
	BAP :: nodeCode,
	BDP :: nodeCode,
	Body :: nodeCode,
	BodyDefTable :: nodeCode,
	BodySegmentConnectionHint :: nodeCode,
	DirectiveSound :: nodeCode,
	Hierarchical3DMesh :: nodeCode,
	MaterialKey :: nodeCode,
	PerceptualParameters :: nodeCode,
	TemporalTransform :: nodeCode,
	TemporalGroup :: nodeCode,
	ServerCommand :: nodeCode,
	MediaSensor :: nodeCode,
	MediaControl :: nodeCode,
	MediaBuffer :: nodeCode,
	MatteTexture :: nodeCode,
	InputSensor :: nodeCode
};

/* In SFViewportNode, we have 0 node defined. */
const int SFViewportNode :: m_nodeTable[]={
	0
};

template <NodeType type> int SFNodeType<type> :: GetNodeTableSize () const
{
	return sizeof ( m_nodeTable ) / sizeof (int);
}

template <NodeType type> int SFNodeType<type> :: GetV2ExtSize () const {return 0;}
template <NodeType type> int SFNodeType<type> :: GetV3ExtSize () const {return 0;}
template <NodeType type> int SFNodeType<type> :: GetV4ExtSize () const {return 0;}
template <NodeType type> int SFNodeType<type> :: GetV5ExtSize () const {return 0;}

/* Definition of v2 nodes. */
int SFMaterialNode :: GetV2ExtSize() const { return 2; }
int SFWorldNode :: GetV2ExtSize() const { return 12; }
int SF3DNode :: GetV2ExtSize() const { return 3; }
int SF2DNode :: GetV2ExtSize() const { return 2; }
/* Definition of v3 nodes. */
int SFTemporalNode :: GetV3ExtSize() const { return 2; }
int SFWorldNode :: GetV3ExtSize() const { return 3; }
int SF3DNode :: GetV3ExtSize() const { return 3; }
int SF2DNode :: GetV3ExtSize() const { return 3; }
/* Definition of v4 nodes. */
int SFWorldNode :: GetV4ExtSize() const { return 5; }
int SF3DNode :: GetV4ExtSize() const { return 5; }
int SF2DNode :: GetV4ExtSize() const { return 5; }

/*-----------------------------------------------------------------
Make sure each necessary SFxxxNode class is instantiated.
(This code is never called, it is here to make sure the linker gets
everything intantiated).
-----------------------------------------------------------------*/
void IntantiateTemplateInstances () {
	SF2DNode sf2dnode;
	SF3DNode sf3dnode;
	SFAudioNode sfaudionode;
	SFGeometryNode sfgeometrynode;
	SFMaterialNode sfmaterialnode;
	SFStreamingNode sfstreamingnode;
	SFTemporalNode sftemporalnode;
	SFTextureNode sftexturenode;
	SFTopNode sftopnode;
	SFWorldNode sfworldnode;
	SFViewportNode sfviewportnode;
}
/* End of automatically generated file */
