/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Optibase Ltd.) and  Mikael Bourges-Sevenier (iVAST Inc.)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Optibase Ltd. and iVAST Inc.
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997-2000.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      Nodes3.cpp
 * AUTHORS:   Zvi Lifshitz (Optibase Ltd.), Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  BIFS macros for v3 node objects.
 * 
 * Comment:   Automatically generated on Fri Jun 09 09:58:24 PDT 2000
 *            at Santa Clara, CA, USA
 *            by parsing the MPEG-4 templates.txt file.
 *            Contact: mikael@ivast.com
 *
 **************************************************************************/

#include "defs.h"
#include "Nodes3.h"
#include "CrNodes.h"
#include "NodeCode.h"

/* Currently, we have 5 nodes defined. */

BIFS_IMPLEMENT_NODE_START(TemporalTransform)
    BIFS_EVENT(TemporalTransform, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(TemporalTransform, removeChildren, 1, -1, 0, 0)
    BIFS_CHILDREN(TemporalTransform, children, 0, 2, 0, -1)
    BIFS_FIELD(TemporalTransform, url, 1, 3, 1, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, startTime, 2, 4, 2, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, optimalDuration, 3, 5, 3, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, active, 4, 6, 4, -1, 0, 0)
    BIFS_FIELD1(TemporalTransform, speed, 5, 7, 5, 0, 0, 7, -FLT_MAX, FLT_MAX)
    BIFS_FIELD1(TemporalTransform, scalability, 6, 8, 6, 1, 12, 12, -1, FLT_MAX)
    BIFS_FIELD1_SQ(TemporalTransform, stretchMode, 7, 9, 7, -1, 13, 2, 0, 0, 2)
    BIFS_FIELD1_SQ(TemporalTransform, shrinkMode, 8, 10, 8, -1, 13, 1, 0, 0, 1)
    BIFS_FIELD(TemporalTransform, maxDelay, 9, 11, 9, -1, 0, 0)
    BIFS_FIELD(TemporalTransform, actualDuration, -1, -1, 10, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TemporalTransform)

BIFS_IMPLEMENT_NODE_START(TemporalGroup)
    BIFS_EVENT(TemporalGroup, addChildren, 0, -1, 0, 0)
    BIFS_EVENT(TemporalGroup, removeChildren, 1, -1, 0, 0)
    BIFS_FIELD1(TemporalGroup, priority, 0, 2, 0, -1, 3, 0, 0, FLT_MAX)
    BIFS_CHILDREN(TemporalGroup, children, 1, 3, 1, -1)
    BIFS_FIELD(TemporalGroup, costart, 2, -1, -1, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, coend, 3, -1, -1, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, meet, 4, -1, -1, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, isActive, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(TemporalGroup, activeChild, -1, -1, 3, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(TemporalGroup)

BIFS_IMPLEMENT_NODE_START(MediaSensor)
    BIFS_FIELD(MediaSensor, url, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(MediaSensor, mediaCurrentTime, -1, -1, 1, -1, 0, 0)
    BIFS_FIELD(MediaSensor, isActive, -1, -1, 2, -1, 0, 0)
    BIFS_FIELD(MediaSensor, compositionStartTime, -1, -1, 3, -1, 0, 0)
    BIFS_FIELD(MediaSensor, mediaDuration, -1, -1, 4, -1, 0, 0)
    BIFS_FIELD(MediaSensor, info, -1, -1, 5, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MediaSensor)

BIFS_IMPLEMENT_NODE_START(ServerCommand)
    BIFS_EVENT(ServerCommand, trigger, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, enable, 0, 1, 0, -1, 0, 0)
    BIFS_FIELD(ServerCommand, url, 1, 2, 1, -1, 0, 0)
    BIFS_FIELD(ServerCommand, command, 2, 3, 2, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ServerCommand)

BIFS_IMPLEMENT_NODE_START(MediaControl)
    BIFS_FIELD(MediaControl, duration, 0, 0, 0, -1, 0, 0)
    BIFS_FIELD(MediaControl, enabled, 1, 1, 1, -1, 0, 0)
    BIFS_FIELD(MediaControl, loop, 2, 2, 2, -1, 0, 0)
    BIFS_FIELD(MediaControl, media, 3, 3, 3, -1, 0, 0)
    BIFS_FIELD1(MediaControl, mediaRate, 4, 4, 4, 0, 0, 7, 0, FLT_MAX)
    BIFS_FIELD(MediaControl, mediaStartTime, 5, 5, 5, -1, 0, 0)
    BIFS_FIELD(MediaControl, mediaStopTime, 6, 6, 6, -1, 0, 0)
    BIFS_FIELD(MediaControl, playTime, 7, 7, 7, -1, 0, 0)
    BIFS_FIELD(MediaControl, startTime, 8, 8, 8, -1, 0, 0)
    BIFS_FIELD(MediaControl, postroll, 9, 9, 9, -1, 0, 0)
    BIFS_FIELD(MediaControl, isActive, -1, -1, 10, -1, 0, 0)
    BIFS_FIELD(MediaControl, currentMediaTime, -1, -1, 11, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(MediaControl)

/* End of automatically generated file */
