/*
This software module was originally developed by Apple Computer, Inc.
in the course of development of MPEG-4. 
This software module is an implementation of a part of one or 
more MPEG-4 tools as specified by MPEG-4. 
ISO/IEC gives users of MPEG-4 free license to this
software module or modifications thereof for use in hardware 
or software products claiming conformance to MPEG-4.
Those intending to use this software module in hardware or software
products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company,
the subsequent editors and their companies, and ISO/IEC have no
liability for use of this software module or modifications thereof
in an implementation.
Copyright is not released for non MPEG-4 conforming
products. Apple Computer, Inc. retains full right to use the code for its own
purpose, assign or donate the code to a third party and to
inhibit third parties from using the code for non 
MPEG-4 conforming products.
This copyright notice must be included in all copies or
derivative works. Copyright (c) 1999.
*/
/*
  $Id: ISOMovieFile.c,v 1.0 2000/08/09 01:44:15 rtm Exp $
*/
#include "ISOMovies.h"
#include "MP4Atoms.h"

ISO_EXTERN ( ISOErr )
ISOWriteMovieToFile( ISOMovie theMovie, const char *filename )
{
	MP4PrivateMovieRecordPtr movie;
	ISOErr err;
	
	if ( (theMovie == NULL) || (filename == NULL) )
		BAILWITHERROR( ISOBadParamErr );

	movie = (MP4PrivateMovieRecordPtr) theMovie;
	switch ( movie->fileType ) 
	{
		case ISOMPEG4FileType:
			err = MP4WriteMovieToFile( theMovie, filename );
			break;
			
		case ISOStillJPEG2000FileType:
			BAILWITHERROR( ISOBadParamErr );	/* not yet implemented */
			break;
			
		case ISOMotionJPEG2000FileType:
			err = MJ2WriteMovieToFile( theMovie, filename );
			break;
			
		case ISOQuickTimeFileType:
			err = QTWriteMovieToFile( theMovie, filename );
			break;
			
		default:
			BAILWITHERROR( ISOBadParamErr );
			break;
	}

bail:
	TEST_RETURN( err );

	return err;
}

