//This software module was originally developed by CSELT in the course of   //
//development of the MPEG-4 Systems (ISO/IEC 14496-1) standard.             //
//This software module is an implementation of a part of one or more MPEG-4 //
//Systems (ISO/IEC 14496-1) tools as specified by the MPEG-4 Systems        //
//(ISO/IEC 14496-1) standard. ISO/IEC gives users of the MPEG-4 Systems     //
//(ISO/IEC 14496-1) free license to this software module or modifications   //
//thereof for use in hardware or software products claiming conformance to  //
//the MPEG-4 Systems (ISO/IEC 14496-1). Those intending to use this software//
//module in hardware or software products are advised that its use may      //
//infringe existing patents.                                                //
//The original developer of this software module and his/her company, the   //
//subsequent editors and their companies, and ISO/IEC have no liability     //
//for use of this software module or modifications thereof in an            //
//implementation. Copyright is not released for non MPEG-4 Systems          //
//(ISO/IEC 14496-1) conforming products. CSELT S.pA. retains full right     //
//to use the code for his/her own purpose, assign or donate the code to a   //
//third party and to inhibit third parties from using the code for non      //
//MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright      //
//notice must be included in all copies or derivative works.                //
//Copyright  1999.                                                         //
//This work has been partly developed within the framework of the ESPRIT    //
//European Research Project  "MPEG-4 PC".                                   //
//////////////////////////////////////////////////////////////////////////////

/****************************************************************************
 *
 * File:        Decoder.cpp
 *
 * Author:      Franco Casalino, Antonio Arena
 * Created:     28.05.97
 *
 * Modified:    Matthew Leditschke, 1/7/97
 *
 * Description: JPEG Decoder class definition
 * 
 * Comments: Work derived from the Independent JPEG Group's software
 *
 ****************************************************************************/

//#include "defs.h"
#include <assert.h>
#include "windows.h"
#include "JPEGDec.h"
#include "jpegmemdec.h"

/*-------------------------------------------------------------
The exported function that instantiates the proper decoder
-------------------------------------------------------------*/
void *CreateInstance ()
{
	return new JPEGDecoder;
}



BOOL JPEGDecoder::Decode(LPBYTE pInput,int nInputLength,LPBYTE pOutput,int &rnOutputLength)
{
	// The in-memory decoder does not allow for the storage of the 
	// dimensions of the image.
//	rnOutputLength -= sizeof(DecoderImage);

/*	// Decode the image
	WORD width, height;*/
	BOOL result = JpegDecodeInMemory(pInput, nInputLength,
									 pOutput,
									 &rnOutputLength, &m_width, &m_height);

	// If the width and height are zero, then an error has occurred
	// decoding the image
	if ((m_width == 0) || (m_height == 0))
		assert(0);

/*	// Store the dimensions of the image in the output buffer
	DecoderImage* pImgDetails = (DecoderImage*)pOutput;
	pImgDetails->width   = width;
	pImgDetails->height  = height;
	pImgDetails->pitch   = width * 3;
	pImgDetails->offsetX = 0;
	pImgDetails->offsetY = 0;

	rnOutputLength += sizeof(DecoderImage);*/
	return result;
}



int JPEGDecoder :: GetOptimalInputSize()
		{ return (15500*3); }
int JPEGDecoder :: GetOptimalOutputSize()
	{ return 0; } // FG 23/6  //	{ return (704 * 576 * 3); }
/*int JPEGDecoder :: GetRecommendedInputBufferSize()
		{ return 3 * GetOptimalInputSize(); }
int JPEGDecoder :: GetRecommendedOutputBufferSize()
		{ return 3 * GetOptimalOutputSize(); }*/

/*-------------------------------------------------------------
In this decoder, attributes are fixed for all units
-------------------------------------------------------------*/
DWORD JPEGDecoder :: GetAttributes (
	ATTRIBUTE_CODE code, 
	const LPBYTE
)
{
	switch (code) {
	case FRAME_WIDTH:
		return m_width;
	case FRAME_HEIGHT:
		return m_height;
	case PITCH:
		return 3*m_width;
	case OFFSETX:
		return 0;
	case OFFSETY:
		return 0;
	default:
		return 0;
	}
}
/*-----------------------------------------------------------------
Find a compatible format and initialize the decoder
-----------------------------------------------------------------*/
   

//We use the default implementation.
/*
BOOL JPEGDecoder :: SetFormat (
	Capabilities &formatOptions,
	DecoderParams &decoderParams
)
{
	if (formatOptions.GetFormatCapabilityLength () == 0)
		return FALSE;
	decoderParams.m_nStreamNumber = 0;
	decoderParams.m_format = formatOptions.GetFormatCapability (0);
	decoderParams.m_nDBSize = 10000;
	decoderParams.m_nOptimalAUSize = 0; //FG 23/6 was 256;
	decoderParams.m_nCBSize = -1; // FG 23/6 was GetOptimalOutputSize () * 5;
//	decoderParams.m_nOptimalAUSize = 256;
//	decoderParams.m_nCBSize = GetOptimalOutputSize () * 1;
	decoderParams.m_bRequiresFullAUs = TRUE;
	return TRUE;
}
//static DecoderFactory<JPEGDecoder> JPEGFactory (5,"JPEG");
*/
//PAB: this should have been updated according to Zvi's comments to:
BOOL JPEGDecoder :: SetFormat (
	Capabilities &formatOptions,
	DecoderParams &decoderParams
)
{
//PAB_core50RC1-:	if (formatOptions.GetFormatCapabilityLength () == 0)
//PAB_core50RC1-:		return FALSE;
//PAB_core50RC1-:	decoderParams.m_nStreamNumber = 0;
//PAB_core50RC1-:	decoderParams.m_format = formatOptions.GetFormatCapability (0);
	decoderParams.m_nDBSize = 10000;
	decoderParams.m_nOptimalAUSize = 0; //FG 23/6 was 256;
	decoderParams.m_nCBSize = -1; // FG 23/6 was GetOptimalOutputSize () * 5;
//	decoderParams.m_nOptimalAUSize = 256;
//	decoderParams.m_nCBSize = GetOptimalOutputSize () * 1;
	decoderParams.m_bRequiresFullAUs = TRUE;

	if (formatOptions.GetFormatCapabilityLength () == 0) //PAB_core50RC1+:
		return FALSE; //PAB_core50RC1+:
	decoderParams.m_nStreamNumber = 0; //PAB_core50RC1+:
	decoderParams.m_format = formatOptions.GetFormatCapability (0); //PAB_core50RC1+:

	return TRUE;
}