
// Byte reordering macros 

#ifndef _endian_h_
#define _endian_h_

#define LITTLE_ENDIAN

#if defined(BIG_ENDIAN)

   #define htons(A)  (A)
   #define htonl(A)  (A)
   #define ntohs(A)  (A)
   #define ntohl(A)  (A)

#elif defined(LITTLE_ENDIAN)

#define htons(A)  ((((A) & 0xff00) >> 8) | \
                  ((A) & 0x00ff) << 8))
#define htonl(A)  ((((A) & 0xff000000) >> 24) | \
                 (((A) & 0x00ff0000) >> 8) | \
                 (((A) & 0x0000ff00) << 8) | \
                 (((A) & 0x000000ff) << 24))
#define ntohs     htons
#define ntohl     htonl

#else
//#error "*** Either BIG_ENDIAN or LITTLE_ENDIAN must be #define'd ***
#endif

#endif _endian_h_
