/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  MP4 File Producer
FILE:       VTC.h
AUTHOR:     Jean Le Feuvre (e-Vue Inc , jlefeuvre@e-vue.com), March 2000
OVERVIEW:   Definition of VTCStream, the class that handles VTC
input streams.
-------------------------------------------------------------------------*/

#if !defined(_VTC_h)
#define _VTC_h


#include "MP4Stream.h"

class VTCStream : public Stream
{
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;
	FILE* m_timeFile;
	float m_prevTime[2];
	int m_prevChar[2];
	int m_nextChar;
	int m_readAhead;
	long m_lDTS;
	bool m_bRAP;

public:
	VTCStream (FILE *fStream, ESDesc *pDescriptor);
	~VTCStream ();
	virtual long GetDTS ();
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
};

#endif