//$Log: Predictive.h,v $
//Revision 1.1  2000/03/03 18:41:21  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//
#include "ztl.h"
#include "ztypes.h"
#include "MediaObj.h"
#include "FldTypes.h"
#include "ArithModel.h"
#include "AArithDec.h"
#include "NodeFld.h"


class PredictiveMField {
public :
	// constructeur.
	PredictiveMField(BIFSDecoder *, MediaObject *, 
					Quantizer *, MField * );
	PredictiveMField :: ~PredictiveMField();
	// parse
	BOOL Parse ();
private :
	BOOL ParseArrayOfValues ();
	BOOL ParseIValue ();
	BOOL ParsePValue ();
	void ParseCompMin(int );
	void ParseArrayQP();
	int getNbComp ();
	int getNbBounds( int );
	void resetDecodingModels();
	void createModels();
	void resetModels();
	void clearModels();
	void Compensate();
	void addDelta ();
	void unQuantize ();
	 // 
	BIFSDecoder * m_pCoder;
	MediaObject * m_pNode;
	Quantizer * m_pQuant;
	MField * m_pMField;
	Decoder * m_Decoder ;
	AArithmeticDecoder * m_aad;

	// read Values
	int m_NbFieldsNbBits;
	int m_numberOfFields;
	int m_IPPolicy;
	int m_intraInterval;
	int m_NbBounds;
	int m_CompNbBits;
	int m_NbComp;
	int m_CompMin[3] ; // there's maxi 3 CompMin.
	int m_quantType;   // quantification type.
	int m_quantNbBits;
	int m_curDirection;
	int m_predDirection;
	int m_orientation;
	int m_curQuant [3] ; // quantified value
	int m_predQuant [3]; // previous
	int m_vdelta [3];
	
	ArithModel * m_Model[3];
	ArithModel * m_BitModel;

};