//$Log: NatColor.h,v $
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATCOLORH
#define NATCOLORH
#include "Quantize.h"

class QuantColor;


class NatColor
{
public:
	enum { m_nbComp = 3 };
	NatColor& operator+= (NatColor);
	NatColor& operator-= (NatColor);
	NatColor();
	NatColor(Quantizer * pQuant,float x=0.0, float y=0.0, float z=0.0,bool isPureNat=true);
	NatColor(int nbbits, float mini[],float maxi[], float x, float y, float z,bool isPureNat=true);
	virtual ~NatColor();
	static NatColor parseValue(Quantizer * pQuant);
	QuantColor Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi[3];
	float m_mini[3];
	bool m_isPureNat; // is PureNat i.e. NatColor belongs to [Min;Max]
					  // otherwise NatColor belongs to [Min-Max;Max-Min]
	float m_x;
	float m_y;
	float m_z;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatColor operator+ (NatColor a, NatColor b);
NatColor operator- (NatColor a, NatColor b);
#endif