//$Log: NatInt.h,v $
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATINTH
#define NATINTH
#include "Quantize.h"

class QuantInt;


class NatInt
{
public:
	NatInt& operator+= (NatInt);
	NatInt& operator-= (NatInt);
	NatInt();
	NatInt(Quantizer * pQuant,int v=0, bool isPureNat=true);
	NatInt(int nbbits, float mini,float maxi, int value=0,bool isPureNat=true);
	virtual ~NatInt();
	static NatInt parseValue(Quantizer * pQuant);
	QuantInt Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi;
	float m_mini;
	bool m_isPureNat; // is PureNat i.e. NatInt belongs to [Min;Max]
					  // otherwise NatInt belongs to [Min-Max;Max-Min]
	int m_value;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatInt operator+ (NatInt a, NatInt b);
NatInt operator- (NatInt a, NatInt b);
#endif