//$Log: NatNormal.h,v $
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATNORMALH
#define NATNORMALH
#include "Quantize.h"

class QuantNormal;


class NatNormal
{
public:
	enum { m_nbComp = 3 };
	NatNormal& operator+= (NatNormal);
	NatNormal& operator-= (NatNormal);
	NatNormal& operator = (const NatNormal &);
	NatNormal();
	NatNormal(Quantizer * pQuant,float x=0.0, float y=0.0, float z=0.0, bool isPureNat=true);
	NatNormal(int nbbits, float x, float y, float z, bool isPureNat=true);
	NatNormal(int nbbits, float quat[], bool isPureNat=true);
	virtual ~NatNormal();
	static NatNormal parseValue(Quantizer * pQuant);
	QuantNormal Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	bool m_isPureNat; // is PureNat i.e. NatNormal difference ?
	float m_x;
	float m_y;
	float m_z;
	float m_quat[4]; // quaternion form.
private:
	void computeQuaternions();
#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatNormal operator+ (NatNormal a, NatNormal b);
NatNormal operator- (NatNormal a, NatNormal b);
#endif