//$Log: NatRot.h,v $
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATROTH
#define NATROTH
#include "Quantize.h"

class QuantRot;


class NatRot
{
public:
	enum { m_nbComp = 4 };
	NatRot& operator+= (NatRot);
	NatRot& operator-= (NatRot);
	NatRot& operator = (const NatRot &);
	NatRot();
	NatRot(Quantizer * pQuant,float x=0.0, float y=0.0, float z=0.0,float angle=0.0, bool isPureNat=true);
	NatRot(int nbbits, float x, float y, float z,float angle=0.0, bool isPureNat=true);
	NatRot(int nbbits, float quat[], bool isPureNat=true);
	virtual ~NatRot();
	static NatRot parseValue(Quantizer * pQuant);
	QuantRot Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	bool m_isPureNat; // is PureNat i.e. NatRot difference ?
	float m_x;
	float m_y;
	float m_z;
	float m_angle;
	float m_quat[4]; // quaternion form.
private:
	void computeQuaternions();
#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatRot operator+ (NatRot a, NatRot b);
NatRot operator- (NatRot a, NatRot b);
#endif