//$Log: NatTypes.h,v $
//Revision 1.2  2000/03/09 20:46:09  Alex Cotarmanac'h
//Fixed parameter bug
//
//Revision 1.1  2000/03/03 18:41:22  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTFLOATH
#define QUANTFLOATH
#include "Quantize.h"

class QuantFloat;


class NatFloat
{
public:
	NatFloat& operator+= (NatFloat);
	NatFloat& operator-= (NatFloat);
	NatFloat(Quantizer * pQuant,float v=0.0, bool isPureNat=true);
	NatFloat(int nbbits=-1, float mini=-1,float maxi=-1, float value=0.0f,bool isPureNat=true);
	virtual ~NatFloat();
	static NatFloat parseValue(Quantizer * pQuant);
	QuantFloat Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi;
	float m_mini;
	bool m_isPureNat; // is PureNat i.e. NatFloat belongs to [Min;Max]
					  // otherwise NatFloat belongs to [Min-Max;Max-Min]
	float m_value;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatFloat operator+ (NatFloat a, NatFloat b);
NatFloat operator- (NatFloat a, NatFloat b);
#endif