//$Log: NatVec2f.h,v $
//Revision 1.1.2.1  2000/03/11 12:48:17  Alex Cotarmanac'h
//Vec2f
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef NATVEC2FH
#define NATVEC2FH
#include "Quantize.h"

class QuantVec2f;


class NatVec2f
{
public:
	enum { m_nbComp = 2 };
	NatVec2f& operator+= (NatVec2f);
	NatVec2f& operator-= (NatVec2f);
	NatVec2f();
	NatVec2f(Quantizer * pQuant,float x=0.0, float y=0.0,bool isPureNat=true);
	NatVec2f(int nbbits, float mini[],float maxi[], float x, float y,bool isPureNat=true);
	virtual ~NatVec2f();
	static NatVec2f parseValue(Quantizer * pQuant);
	QuantVec2f Quantize();
public:
	static bool m_predictiveNatScheme;
private:
	int m_nbbits;
	float m_maxi[2];
	float m_mini[2];
	bool m_isPureNat; // is PureNat i.e. NatVec2f belongs to [Min;Max]
					  // otherwise NatVec2f belongs to [Min-Max;Max-Min]
	float m_x;
	float m_y;

#ifdef DEBUGPREDICTIVE
public:
	void Print(FILE *);
#endif
};
NatVec2f operator+ (NatVec2f a, NatVec2f b);
NatVec2f operator- (NatVec2f a, NatVec2f b);
#endif