//$Log: QuantColor.h,v $
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QuantColorH
#define QuantColorH
#include "Quantize.h"
#include "ztl.h"
#include "NatColor.h"	// Added by ClassView
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"


class QuantColor 
{
	friend bool operator != (QuantColor a, QuantColor b);
public:
	enum { m_nbComp = 3 };
	QuantColor();
	QuantColor(Quantizer * pQuant, int x=0, int y=0, int z=0);
	QuantColor(int nbbits, float mini[], float maxi[], int x=0, int y=0, int z=0);
	QuantColor& operator+= (QuantColor);
	QuantColor& operator-= (QuantColor);
	virtual ~QuantColor();
	NatColor unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);//sets static vars
	static QuantColor CompMin(ZArray<QuantColor> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantColor> & d, ZArray<QuantColor> & q, QuantColor PMin, int begin, int end);
	static QuantColor unShift(QuantColor a, QuantColor Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantColor> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
	void WriteIntra(ZArray<bool> & o);
private:
	int m_x;
	int m_y;
	int m_z;
	int m_nbbits;
	float m_maxi[3];
	float m_mini[3];
	static int m_nbAACModels;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantColor> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantColor operator+ (QuantColor a, QuantColor b);
QuantColor operator- (QuantColor a, QuantColor b);
#endif