//$Log: QuantInt.h,v $
//Revision 1.1  2000/03/03 18:41:23  Alex Cotarmanac'h
//Version 1 -- Alexandre Cotarmanac_h
//
//<alexandre.cotarmanac-h@polytechnique.org>
#ifndef QUANTINTH
#define QUANTINTH
#include "Quantize.h"
#include "ztl.h"
#include "NatInt.h"	// Added by ClassView
#include "../Animation/ArithModel.h"
#include "ArithEncoder.h"

class QuantInt 
{
	friend bool operator != (QuantInt a, QuantInt b);
public:
	enum { m_nbComp = 1 };
	QuantInt();
	QuantInt(Quantizer * pQuant, int x=0);
	QuantInt(int nbbits, float mini, float maxi, int x=0);
	QuantInt& operator+= (QuantInt);
	QuantInt& operator-= (QuantInt);
	virtual ~QuantInt();
	NatInt unQuantize();

//   ****			Predictive Encoder Functions
	static void setNbAACModels(Quantizer * pQuant);
	static QuantInt CompMin(ZArray<QuantInt> & qFArray,int begin,int end, int &nbits);
	static void Shift(ZArray<QuantInt> & d, ZArray<QuantInt> & q, QuantInt PMin, int begin, int end);
	static QuantInt unShift(QuantInt a, QuantInt Pmin);
	static void AAEncode(ZArray<bool> & o, ZArray<int> &oIndx, ZArray<QuantInt> & i,int nbbits, int begin, int end, bool isChoice);
	void Encode(BIFSEncoder * pBifs);
	void EncodePMin(BIFSEncoder * pBifs);
	void WriteIntra(ZArray<bool> & o);
private:
	int m_value;
	int m_nbbits;
	float m_maxi;
	float m_mini;
	virtual int EncodeAA(ArithEncoder & aae, ArithModel model[] );
#ifdef DEBUGPREDICTIVE
public:
	static int Decode(ZArray<QuantInt> & decArray, ZArray<bool> & m_outArray,int index,
		int nb,int aadnbBits,Quantizer * m_pQuant, FILE * out, bool isChoice);
	void Print(FILE *);
#endif
};

QuantInt operator+ (QuantInt a, QuantInt b);
QuantInt operator- (QuantInt a, QuantInt b);

#endif