#include "defs.h"
#include "Device.h"
#include "SysCoder.h"
#include "..\2DPlayer-CSELT\VisRend.h"

DeviceFilter::DeviceFilter() : m_nDeviceId(0) {
}

DeviceFilter::~DeviceFilter() {	
/*	int i;
	int n = 0;

	while (m_loadedDevices.GetLength ()) {

		if (n++) Sleep(1000);

		m_smpDevices.P();
		for (i = m_loadedDevices.GetLength (); --i >= 0;)
		{
			delete m_loadedDevices[i];
		}
		m_smpDevices.V ();
	}
*/
}

struct deviceDesc* DeviceFilter :: LockDevice (const DeviceListener* pDeviceListener) 
{
	int i;
	struct deviceDesc* pDeviceDesc=NULL;

	m_smpDevices.P();
	for (i = m_loadedDevices.GetLength (); --i >= 0;)
	{
		if (m_loadedDevices[i]->m_pDeviceListener == pDeviceListener)
		{
			pDeviceDesc = m_loadedDevices[i];
			pDeviceDesc->m_mtxDevice.P();
			pDeviceDesc->m_nUse++;
			pDeviceDesc->m_mtxDevice.V();
			m_smpDevices.V();
			break;
		}
	}
	if (pDeviceDesc==NULL)
		m_smpDevices.V();
	return (pDeviceDesc);
}

struct deviceDesc* DeviceFilter :: LockDevice (const UINT nDeviceId) 
{
	int i;
	struct deviceDesc* pDeviceDesc=NULL;

	m_smpDevices.P();
	for (i = m_loadedDevices.GetLength (); --i >= 0;)
	{
		if (m_loadedDevices[i]->m_nDeviceId == nDeviceId)
		{
			pDeviceDesc = m_loadedDevices[i];
			pDeviceDesc->m_mtxDevice.P();
			pDeviceDesc->m_nUse++;
			pDeviceDesc->m_mtxDevice.V();
			m_smpDevices.V();
			break;
		}
	}
	if (pDeviceDesc==NULL)
		m_smpDevices.V();
	return (pDeviceDesc);
}

void DeviceFilter :: UnlockDevice (struct deviceDesc* pDeviceDesc) 
{
	m_smpDevices.P();
	pDeviceDesc->m_mtxDevice.P();
	pDeviceDesc->m_nUse--;
	pDeviceDesc->m_mtxDevice.V();
	m_smpDevices.V();
}

void DeviceFilter :: DeviceListener_Attach_Req(	DeviceListener*			pDeviceListener,
												const char*				szDeviceURL){
	int i;
	UINT attachedId;
	DEVICE_STATUS eStatus;
	
	BOOL bFound = false;

	m_smpDevices.P ();
	/*-------------------------------------------------------------
	Find which instance can serve this URL. 
	First in the loaded instances
	-------------------------------------------------------------*/
	for (i = m_loadedDevices.GetLength (); --i >= 0;)
	{
		DevicePlugin* pLoadedDevicePlugin = m_loadedDevices[i]->m_pDevicePlugin;
		if (pLoadedDevicePlugin -> IsYourURL (szDeviceURL))
		{	
			m_loadedDevices[i] -> m_pDeviceListener = pDeviceListener;
			m_loadedDevices[i] -> m_eStatus			= PLUGIN_AND_LISTENER_ATTACHED;
			m_loadedDevices[i] -> m_szDeviceURL		= new char[strlen(szDeviceURL) + 1]; strcpy(m_loadedDevices[i] -> m_szDeviceURL	, szDeviceURL);

			attachedId	= m_loadedDevices[i] -> m_nDeviceId;
			eStatus		= m_loadedDevices[i] -> m_eStatus;
			bFound = true;
			break;
		}
	}

	/*-------------------------------------------------------------
	If none of the existing services can handle this URL
	Keep track of its need
	-------------------------------------------------------------*/
	if (i < 0)
	{	
		struct deviceDesc* pDeviceDesc	= new(struct deviceDesc);
		pDeviceDesc->m_nUse				= 0;
		pDeviceDesc->m_pDeviceListener	= pDeviceListener;
		pDeviceDesc->m_pDevicePlugin	= NULL;
		pDeviceDesc->m_nDeviceId		= m_nDeviceId++;
		pDeviceDesc->m_szDeviceURL		= new char[strlen(szDeviceURL) + 1]; strcpy(pDeviceDesc->m_szDeviceURL, szDeviceURL);
		pDeviceDesc->m_eStatus			= LISTENER_ATTACHED_ONLY;
		m_loadedDevices += pDeviceDesc;

		attachedId	= pDeviceDesc->m_nDeviceId;
		eStatus		= pDeviceDesc->m_eStatus;
		bFound = true;
	} 

	/*-------------------------------------------------------------
	Send the Id and the status back
	-------------------------------------------------------------*/
	if (!bFound) {
		eStatus    = DEVICE_UNKNOWN_ERROR;
	}

	pDeviceListener -> DeviceListener_Attach_Cnf(attachedId, eStatus);

	m_smpDevices.V ();

}

void DeviceFilter :: DeviceListener_Detach_Req(	const UINT	nDeviceId) {

	deviceDesc* pDeviceDesc=LockDevice(nDeviceId);

	if (pDeviceDesc)
	{
		pDeviceDesc->m_pDeviceListener = NULL;

		if (pDeviceDesc->m_eStatus == PLUGIN_AND_LISTENER_ATTACHED) {
			pDeviceDesc->m_eStatus	= PLUGIN_ATTACHED_ONLY;
		} else if (pDeviceDesc->m_eStatus == PLUGIN_ATTACHED_ONLY) {
			pDeviceDesc->m_eStatus	= NULL_DEVICE;
		}

		UnlockDevice(pDeviceDesc);
	}
}

void DeviceFilter :: DevicePlugin_Attach_Req(DevicePlugin *pDevicePlugin) {

	int i;
	UINT attachedId;
	DEVICE_STATUS eStatus;
	BOOL bFound = false;

	m_smpDevices.P ();

	/*-------------------------------------------------------------
	Find if a Listener is waiting for this Plugin
	-------------------------------------------------------------*/
	for (i = m_loadedDevices.GetLength (); --i >= 0;)
	{
		if (m_loadedDevices[i] -> m_eStatus	== LISTENER_ATTACHED_ONLY) {
			if (pDevicePlugin->IsYourURL(m_loadedDevices[i] ->m_szDeviceURL)) {

				m_loadedDevices[i] -> m_pDevicePlugin = pDevicePlugin;
				m_loadedDevices[i] -> m_eStatus		  = PLUGIN_AND_LISTENER_ATTACHED;
				attachedId	= m_loadedDevices[i] -> m_nDeviceId;
				eStatus		= m_loadedDevices[i] -> m_eStatus;
				bFound = true;
				break;
			}
		}
	}

	/*-------------------------------------------------------------
	If none of the existing URL can be handled by this Plugin
	-------------------------------------------------------------*/
	if (i < 0)
	{	
		struct deviceDesc* pDeviceDesc	= new(struct deviceDesc);
		pDeviceDesc->m_nUse				= 0;
		pDeviceDesc->m_pDeviceListener	= NULL;
		pDeviceDesc->m_pDevicePlugin	= pDevicePlugin;
		pDeviceDesc->m_nDeviceId		= m_nDeviceId++;
		pDeviceDesc->m_szDeviceURL		=			"";
		pDeviceDesc->m_eStatus			=			PLUGIN_ATTACHED_ONLY;
		m_loadedDevices += pDeviceDesc;

		attachedId	= pDeviceDesc->m_nDeviceId;
		eStatus		= pDeviceDesc->m_eStatus;
		bFound = true;

	} 

	/*-------------------------------------------------------------
	Send the Id and the status back
	-------------------------------------------------------------*/	
	if (!bFound) {
		eStatus    = DEVICE_UNKNOWN_ERROR;
	}

	pDevicePlugin -> DevicePlugin_Attach_Cnf(attachedId, eStatus);

	
	m_smpDevices.V ();

}

void DeviceFilter :: DevicePlugin_Detach_Req(const UINT nDeviceId) {
	deviceDesc* pDeviceDesc=LockDevice(nDeviceId);

	if (pDeviceDesc)
	{
		pDeviceDesc->m_pDevicePlugin = NULL;

		if (pDeviceDesc->m_eStatus == PLUGIN_AND_LISTENER_ATTACHED) {
			pDeviceDesc->m_eStatus	= LISTENER_ATTACHED_ONLY;
		} else if (pDeviceDesc->m_eStatus == PLUGIN_ATTACHED_ONLY) {
			pDeviceDesc->m_eStatus	= NULL_DEVICE;
		}

		UnlockDevice(pDeviceDesc);
	}
}

void DeviceFilter :: DataReceive_Ind(const UINT		nDeviceId,
									 const BYTE*	pStreamData,
									 const int		nStreamDataLength,
									 const int		nErrorFlag) {

	deviceDesc* pDeviceDesc=LockDevice(nDeviceId);

	if (pDeviceDesc)
	{
		if (pDeviceDesc -> m_pDeviceListener) {
			pDeviceDesc -> m_pDeviceListener -> DataReceive_Ind(pStreamData,nStreamDataLength,nErrorFlag);
		}
		
		UnlockDevice(pDeviceDesc);
	}

	return;
}

DeviceListener::DeviceListener() : m_pDeviceFilter(NULL) {
}

/* --------------------------------------------------------------
-					 Keyboard Plug-in							-
---------------------------------------------------------------*/
LPCSTR KeyboardInstance::s_myURLScheme = "keyboard:";

void KeyboardInstance::DataReceive_Ind(const ZString &string) {
	
	SysCoder coder(NULL, NULL, NULL, 0, 0);
	coder.Reset();
	coder.EncodeSFString(string);
	coder.Align();

	m_pDeviceFilter->DataReceive_Ind(m_nDeviceId,coder.GetData(),coder.GetDataLength(),0);
}

BOOL KeyboardInstance::IsYourURL(const char* szDeviceURL) {
	if (_strnicmp( szDeviceURL, s_myURLScheme, strlen(s_myURLScheme) ) == 0) {
		return TRUE;
	}
	return FALSE;
}

/* --------------------------------------------------------------
-					 Web3D KeySensor Plug-in				    -
---------------------------------------------------------------*/
LPCSTR Web3DKeySensorInstance::s_myURLScheme = "Web3Dkeyboard:";

void Web3DKeySensorInstance::DataReceive_Ind(const UINT nKeyPress, 
											 const UINT nKeyRelease, 
											 const UINT nActionKeyPress,
											 const UINT nActionKeyRelease,
											 const BOOL bShiftKey_Changed,
											 const BOOL bControlKey_Changed,
											 const BOOL bAltKey_Changed
											 ) {
	
	SysCoder coder(NULL, NULL, NULL, 0, 0);
	coder.Reset();
	coder.EncodeInt(nKeyPress,32,"keyPress");
	coder.EncodeInt(nKeyRelease,32,"keyRelease");
	coder.EncodeInt(nActionKeyPress,32,"actionKeyPress");
	coder.EncodeInt(nActionKeyRelease,32,"actionKeyRelease");
	coder.EncodeInt(bShiftKey_Changed,1,"shiftKey_changed");
	coder.EncodeInt(bControlKey_Changed,1,"controlKey_changed");
	coder.EncodeInt(bAltKey_Changed,1,"altKey_changed");
	coder.Align();

	m_pDeviceFilter->DataReceive_Ind(m_nDeviceId,coder.GetData(),coder.GetDataLength(),0);
}

BOOL Web3DKeySensorInstance::IsYourURL(const char* szDeviceURL) {
	if (_strnicmp( szDeviceURL, s_myURLScheme, strlen(s_myURLScheme) ) == 0) {
		return TRUE;
	}
	return FALSE;
}
/* --------------------------------------------------------------
-					 Mouse Plug-in								-
---------------------------------------------------------------*/
LPCSTR MouseInstance::s_myURLScheme = "mouse:";

void MouseInstance::DataReceive_Ind(const UINT nX, const UINT nY, const BOOL bClicked) {

	int X = nX;
	int Y = nY;

	X -= m_pDeviceFilter->GetVisualRenderer()->GetScreenWidth() / 2;
	Y  = m_pDeviceFilter->GetVisualRenderer()->GetScreenHeight() / 2 - nY;

	SysCoder coder(NULL, NULL, NULL, 0, 0);
	coder.Reset();
	coder.EncodeFloat(X,"x");
	coder.EncodeFloat(Y,"y");
	coder.EncodeInt(bClicked,1,"click");
	coder.Align();

	m_pDeviceFilter ->DataReceive_Ind(m_nDeviceId,coder.GetData(),coder.GetDataLength(),0);
}

BOOL MouseInstance::IsYourURL(const char* szDeviceURL) {
	if (_strnicmp( szDeviceURL, s_myURLScheme, strlen(s_myURLScheme) ) == 0) {
		return TRUE;
	}
	return FALSE;
}
