//ScriptInterface.h //AC
//<alexandre.cotarmanac-h@polytechnique.org>
//$Log$
/* Purpose:
		Scripts are somehow like protos in the sense
		they define an interface.
		Unlike Protos, a script has no "proper type"
		We shall link a script name to a script interface
*/
#include "ztl.h"
#include "Proto.h"
class NodeField;
class VSNodeField;

class ScriptInterface : public Proto
{
public:
	ScriptInterface(LPCSTR scname):Proto() { m_scriptName=_strdup(scname);};
	// Stores the the interface definition of the script.
	bool StoreScriptDefinition(ZArray<VSNodeField *> & eventArray);
	bool Is(LPCSTR n){ return !strcmp(n,m_scriptName);}
private:
	LPCSTR m_scriptName;
	// Creates the Interface (see Proto::CreateInterfaceField)
	NodeField *CreateInterface(int eventType,int fieldType,LPCSTR szName);
};