// VsSwitch.h: interface for the VsSwitch class.
// Alexandre Cotarmanac'h Echevarria <alexandre.cotarmanach@polytechnique.org>
// AC 200005.

#if !defined(AFX_VSSWITCH_H__D839C157_E15E_46D8_90E7_BDF018471B2C__INCLUDED_)
#define AFX_VSSWITCH_H__D839C157_E15E_46D8_90E7_BDF018471B2C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ztl.h"
#include "vsstatement.h"
#include "vsexpr.h"
//Switch statement

class VsSwitch : public VsStatement  
{
public:

	VsSwitch(VsExpr * switched_expr);
	VsSwitch();	
	virtual ~VsSwitch();
	/**	addCase add a case
		switch_against is the value to which switched_expr is compared.
		switch_against is NULL for default
	*/
	void addCase(VsExpr * switch_against, VsStatementList * case_block);
	/** execute the switch statement
	*/
	virtual VsStatement::Status	execute(VsFunctionCall *);
	
private:
	static bool areEqual(VsValue v1,VsValue v2);
	VsExpr * m_switched_expr;
	ZArray<VsStatementList *> m_caseBodyArray;
	ZArray<VsExpr *> m_caseLabelArray;
};

#endif // !defined(AFX_VSSWITCH_H__D839C157_E15E_46D8_90E7_BDF018471B2C__INCLUDED_)
