// ScriptOutput.cpp: implementation of the ScriptOutput class.
// $Log$
// <alexandre.cotarmanac-h@polytechnique.org>
#include "defs.h"
#include "VSNodeField.h"
#include "ScriptOutput.h"


ScriptOutput::ScriptOutput()
{

}

ScriptOutput::~ScriptOutput()
{

}

void ScriptOutput::traceEvent(SysCoder *pCoder, VSNodeField *vsfld)
{
	switch (vsfld->m_scriptEventType)
	{
	case SCRIPT_EVENTIN:
		TRACEF("eventIn ", 0);
		traceType(pCoder,vsfld->m_scriptEventType);
		break;
	case SCRIPT_EVENTOUT:
		TRACEF("eventOut ", 0);
		traceType(pCoder,vsfld->m_scriptEventType);
		// get default value.

		break;
	case SCRIPT_FIELD:
		TRACEF("field ", 0);
		traceType(pCoder,vsfld->m_scriptEventType);
//		traceValue(pCoder,vsfld->pValue);
		break;
	case SCRIPT_UNDEFINED:
		return;
		break;
	}
	TRACEF(" %s ",vsfld->m_name);
}

void ScriptOutput::traceType(SysCoder *pCoder,int type)
{
 //FIELD_TYPE
	pCoder;
	switch (type)
	{
	case SFNODE: 
		TRACEF("%s", "SFNode"); break;
	case MFNODE: 
		TRACEF("%s", "MFNode"); break;
	case SFBOOL: 
		TRACEF("%s", "SFBool"); break;
	case MFBOOL: 
		TRACEF("%s", "MFBool"); break;
	case SFTIME: 
		TRACEF("%s", "SFTime"); break;
	case MFTIME: 
		TRACEF("%s", "MFTime"); break;
	case SFCOLOR: 
		TRACEF("%s", "SFColor"); break;   
	case MFCOLOR: 
		TRACEF("%s", "MFColor"); break;     
	case SFFLOAT: 
		TRACEF("%s", "SFFloat"); break;     
	case MFFLOAT: 
		TRACEF("%s", "MFFloat"); break;
	case SFINT32: 
		TRACEF("%s", "SFInt32"); break;    
	case MFINT32: 
		TRACEF("%s", "MFInt32"); break;     
	case SFROTATION:
		TRACEF("%s", "SFRotation"); break; 
	case MFROTATION: 
		TRACEF("%s", "MFRotation"); break;  
	case SFSTRING: 
		TRACEF("%s", "SFString"); break;    
	case MFSTRING: 
		TRACEF("%s", "MFString"); break;
	case SFVEC2F: 
		TRACEF("%s", "SFVec2f"); break;    
	case MFVEC2F: 
		TRACEF("%s", "MFVec2f"); break;     
	case SFVEC3F: 
		TRACEF("%s", "SFVec3f"); break;     
	case MFVEC3F: 
		TRACEF("%s", "MFVec3f"); break;
	case SFURL: 
		TRACEF("%s", "SFUrl"); break;
	case MFURL: 
		TRACEF("%s", "MFUrl"); break;
	case SFIMAGE:
		TRACEF("%s", "SFImage"); break;
	case MFIMAGE:
		TRACEF("%s", "MFImage"); break;
	default:
		TRACEF("%s", "ERROR");
	}
}

void ScriptOutput::traceValue(SysCoder *pCoder, NodeField * n)
{
pCoder;
n;
}
