/*
CONTRIBUTION TO THE WG11 PROGRAM MPEG 4 PLAYER
______________________________________________________________________

STANDARDS PROJECT:  MPEG 4 Player
______________________________________________________________________

TITLE:  Animation of 3D Face Mpdels using Animation Definition Tables
______________________________________________________________________

AUTHORS:  	Erich Haratsch, Joern Ostermann

SOURCE:      	AT&T
 
CONTACT:	Joern Ostermann
		AT&T Labs - Research
		Room NSL 3-231
		100 Schultz Drive - Middletown
		Red Bank, NJ  07701-7033
		USA
		email: osterman@research.att.com   
		fax:   +1 732 345 3033
		phone:  +1 732 345 3311		   
______________________________________________________________________

DATE:  July 14, Middletown, New Jersey, USA
______________________________________________________________________

DISTRIBUTION:  MPEG 4 WG11
______________________________________________________________________

ABSTRACT:  fapfile_anim_mpeg_release takes as input an decoded 
downloaded model and decoded AnimationDefinitionTables and animates 
the model with decoded FAP sequences


______________________________________________________________________
Notice

This document has been prepared by AT&T
to assist the Standards Committee WG 11.  It is proposed to the Committee
as a basis for discussion and is not to be construed as a binding proposal
on AT&T. AT&T specifically reserves the right to amend or modify the
material contained herein and nothing herein shall be construed as conferring
or offering licenses or rights with respect to any intellectual property of
AT&T.

AT&T Proprietary
*/
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include "TableIndexedFaceSet_mpeg.h"
#include "Face_mpeg.h"

#include "stdio.h"

#include "DisplayManager_mpeg.h"


#define MAXLINE 200000


int OFFSCREEN_RENDERING = FALSE;

char output_filename[MAXCHAR];


Face face1;
DisplayManager dispm;
void getFile()
{

  if(OFFSCREEN_RENDERING){
    face1.dorendFAPTablesOffScreen();
  }
  else {
    face1.dorendFAPTables();
  }
}

void usage()
{
    printf("USAGE: fapfile_anim_mpeg <-mmodel_file> <-ffap_file>  <-aADTFile> <-ufeaturePointFile> [-ooutput_file]\n");
}

main(int argc, char *argv[])
{
  int c;

  char model_file[MAXCHAR];
  char fap_file[MAXCHAR];
  char ADTFile[MAXCHAR];
  char featurePointFile[MAXCHAR];



  if (argc < 5) {
    usage();
    exit(0);
  }
  dispm.createDisplay(argv[0]); 
 

  while(--argc > 0)
    {
	 
      if ((*++argv)[0] == '-') {
	     
	c=*++argv[0];	
	
	switch(c) {
		
	case 'm':
	  strcpy(model_file, ++argv[0]);		 
	  break;
	
	case 'f':
	  strcpy(fap_file, ++argv[0]);
	  break;
	case 'o':
	  strcpy(output_filename, ++argv[0]);
	  OFFSCREEN_RENDERING = TRUE;
	  break;
		
	
	case 'a':
	  strcpy(ADTFile, ++argv[0]);
	
	  break;

	case 'u':
	  strcpy(featurePointFile, ++argv[0]);
	
	  break;

	default:
	  usage();
	  exit(0);
	}
      }
      else {
	usage();
	exit(0);
      }
    }

  face1.readModel(model_file);
  dispm.addSceneGraph(face1.getSceneGraph());
 
    face1.calcFAPUsModel(featurePointFile);
 

 
    face1.makeFAPTablesFromADTs(ADTFile);

  face1.readFapFileNew(fap_file);

  dispm.mainLoop();
  return 0;
}




