/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeCode.h
 * AUTHOR:    Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  BIFS macros for node objects.
 * 
 * Comment:   Automatically generated on Wed Nov 18 18:14:15 CET 1998
 *            at France Telecom CCETT, Rennes, FRANCE
 *            by parsing the MPEG-4 templates.wrl file.
 *            Contact: mikael.bourgessevenier@cnet.francetelecom.fr
 * 
 **************************************************************************/

#if !defined(_NodeCode_h) // Sentry, use file only if it's not already included
#define _NodeCode_h

/*-----------------------------------------------------------------
  Define node codes
-----------------------------------------------------------------*/

enum {
	CODE_Anchor,
	CODE_AnimationStream,
	CODE_Appearance,
	CODE_AudioBuffer,
	CODE_AudioClip,
	CODE_AudioDelay,
	CODE_AudioFX,
	CODE_AudioMix,
	CODE_AudioSource,
	CODE_AudioSwitch,
	CODE_Background,
	CODE_Background2D,
	CODE_Billboard,
	CODE_Bitmap,
	CODE_Box,
	CODE_Circle,
	CODE_Collision,
	CODE_Color,
	CODE_ColorInterpolator,
	CODE_CompositeTexture2D,
	CODE_CompositeTexture3D,
	CODE_Conditional,
	CODE_Cone,
	CODE_Coordinate,
	CODE_Coordinate2D,
	CODE_CoordinateInterpolator,
	CODE_CoordinateInterpolator2D,
	CODE_Curve2D,
	CODE_Cylinder,
	CODE_CylinderSensor,
	CODE_DirectionalLight,
	CODE_DiscSensor,
	CODE_ElevationGrid,
	CODE_Expression,
	CODE_Extrusion,
	CODE_Face,
	CODE_FaceDefMesh,
	CODE_FaceDefTables,
	CODE_FaceDefTransform,
	CODE_FAP,
	CODE_FDP,
	CODE_FIT,
	CODE_Fog,
	CODE_FontStyle,
	CODE_Form,
	CODE_Group,
	CODE_ImageTexture,
	CODE_IndexedFaceSet,
	CODE_IndexedFaceSet2D,
	CODE_IndexedLineSet,
	CODE_IndexedLineSet2D,
	CODE_Inline,
	CODE_LOD,
	CODE_Layer2D,
	CODE_Layer3D,
	CODE_Layout,
	CODE_LineProperties,
	CODE_ListeningPoint,
	CODE_Material,
	CODE_Material2D,
	CODE_MovieTexture,
	CODE_NavigationInfo,
	CODE_Normal,
	CODE_NormalInterpolator,
	CODE_OrderedGroup,
	CODE_OrientationInterpolator,
	CODE_PixelTexture,
	CODE_PlaneSensor,
	CODE_PlaneSensor2D,
	CODE_PointLight,
	CODE_PointSet,
	CODE_PointSet2D,
	CODE_PositionInterpolator,
	CODE_PositionInterpolator2D,
	CODE_ProximitySensor2D,
	CODE_ProximitySensor,
	CODE_QuantizationParameter,
	CODE_Rectangle,
	CODE_ScalarInterpolator,
	CODE_Script,
	CODE_Shape,
	CODE_Sound,
	CODE_Sound2D,
	CODE_Sphere,
	CODE_SphereSensor,
	CODE_SpotLight,
	CODE_Switch,
	CODE_TermCap,
	CODE_Text,
	CODE_TextureCoordinate,
	CODE_TextureTransform,
	CODE_TimeSensor,
	CODE_TouchSensor,
	CODE_Transform,
	CODE_Transform2D,
	CODE_Valuator,
	CODE_Viewpoint,
	CODE_VisibilitySensor,
	CODE_Viseme,
	CODE_WorldInfo,

  // Riitta 99/05 nodes for Adv Audio
#ifdef ADV_AUDIO
	CODE_AcousticScene,
	CODE_AcousticMaterial,
	CODE_DirectiveSound,
#endif

	// -------[ Body Animation Part Added ]-------
	// By :	* Tolga Capin
	//      * Fabrice Vergnenegre
	// On : 09/25/1999
	CODE_Body,
	CODE_BAP,
	CODE_BDP,
	CODE_BodyDefTable,
	CODE_BodySegmentConnectionHint,
	// -------[ End Of Added Part ]-------

};

#endif                                 // _NodeCode_h sentry.

/* End of automatically generated file */
