/***********************************************************************
    This software module  was  originally  developed by Zvi  Lifshitz
    (Triton R&D Ltd.) and  Mikael Bourges-Sevenier (France Telecom CNET)
    in the course of development of the MPEG-4 Systems (ISO/IEC 14496-1)
    standard.  This software module is an implementation of a part of
    one or more MPEG-4 Systems (ISO/IEC 14496-1) tools  as  specified
    by  the  MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC gives
    users of the MPEG-4 Systems (ISO/IEC 14496-1)  free  license  to
    this software module or modifications thereof for use in hardware
    or software products claiming conformance to the  MPEG-4  Systems
    (ISO/IEC 14496-1). Those intending to use this software module in
    hardware or software  products  are  advised  that  its  use  may
    infringe   existing  patents.  The  original  developer  of  this
    software module and his/her company, the subsequent  editors  and
    their  companies,  and  ISO/IEC have no liability for use of this
    software module or modifications thereof  in  an  implementation.
    Copyright  is not released for non MPEG-4 Systems (ISO/IEC 14496-
    1) conforming  products.  Triton R&D Ltd. and France  Telecom  CNET
    retain  full  right to use the code for their own purpose, assign
    or donate the code to a third party and to inhibit third  parties
    from  using  the  code  for  non MPEG-4 Systems (ISO/IEC 14496-1)
    conforming products. This copyright notice must  be  included  in
    all copies or derivative works. Copyright  1997.
************************************************************************/

/**************************************************************************
 * Project Im1Player
 * INTERNATIONAL STANDARD ORGANIZATION
 * ISO/IEC JTC1/SC29/WG11
 * 
 * SUBSYSTEM: BIFS Encoder/Decoder
 * FILE:      NodeTables.cpp
 * AUTHOR:    Mikael Bourges-Sevenier (France Telecom CNET/DIH/HDM)
 * OVERVIEW:  BIFS macros for node objects.
 * 
 * Comment:   Automatically generated on Wed Nov 18 18:14:15 CET 1998
 *            at France Telecom CCETT, Rennes, FRANCE
 *            by parsing the MPEG-4 templates.wrl file.
 *            Contact: mikael.bourgessevenier@cnet.francetelecom.fr
 * 
 **************************************************************************/

#include "defs.h"
#include "Im1defs.h"
#include "Nodes.h"
#include "CrNodes.h"

/* Here are 31 node data types. */
/* SF2DNode: 30 nodes */
const int SF2DNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background2D :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	OrderedGroup :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound2D :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	WorldInfo :: nodeCode,

	// -------[ Body Animation Part Added ]-------
	// By :	* Tolga Capin
	//      * Fabrice Vergnenegre
	// On : 09/25/1999
	Body :: nodeCode
	// -------[ End Of Added Part ]-------

};

/* SF3DNode: 48 nodes */
const int SF3DNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Collision :: nodeCode,
	ColorInterpolator :: nodeCode,
	Conditional :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	Face :: nodeCode,
	Fog :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	ListeningPoint :: nodeCode,
	NavigationInfo :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	WorldInfo :: nodeCode,
#ifdef ADV_AUDIO
	AcousticScene :: nodeCode,  // riitta: addition 041999
	DirectiveSound :: nodeCode,	// riitta: addition 041999
#endif

	// -------[ Body Animation Part Added ]-------
	// By :	* Tolga Capin
	//      * Fabrice Vergnenegre
	// On : 09/25/1999
	Body :: nodeCode
	// -------[ End Of Added Part ]-------

};

/* SFAppearanceNode: 1 node */
const int SFAppearanceNode :: m_nodeTable[]={
	Appearance :: nodeCode
};

/* SFAudioNode: 7 nodes */
const int SFAudioNode :: m_nodeTable[]={
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode
};

/* SFBackground2DNode: 1 node */
const int SFBackground2DNode :: m_nodeTable[]={
	Background2D :: nodeCode
};

/* SFBackground3DNode: 1 node */
const int SFBackground3DNode :: m_nodeTable[]={
	Background :: nodeCode
};

/* SFColorNode: 1 node */
const int SFColorNode :: m_nodeTable[]={
	Color :: nodeCode
};

/* SFCoordinate2DNode: 1 node */
const int SFCoordinate2DNode :: m_nodeTable[]={
	Coordinate2D :: nodeCode
};

/* SFCoordinateNode: 1 node */
const int SFCoordinateNode :: m_nodeTable[]={
	Coordinate :: nodeCode
};

/* SFExpressionNode: 1 node */
const int SFExpressionNode :: m_nodeTable[]={
	Expression :: nodeCode
};

/* SFFAPNode: 1 node */
const int SFFAPNode :: m_nodeTable[]={
	FAP :: nodeCode
};

/* SFFDPNode: 1 node */
const int SFFDPNode :: m_nodeTable[]={
	FDP :: nodeCode
};

/* SFFITNode: 1 node */
const int SFFITNode :: m_nodeTable[]={
	FIT :: nodeCode
};

/* SFFaceDefMeshNode: 1 node */
const int SFFaceDefMeshNode :: m_nodeTable[]={
	FaceDefMesh :: nodeCode
};

/* SFFaceDefTablesNode: 1 node */
const int SFFaceDefTablesNode :: m_nodeTable[]={
	FaceDefTables :: nodeCode
};

/* SFFaceDefTransformNode: 1 node */
const int SFFaceDefTransformNode :: m_nodeTable[]={
	FaceDefTransform :: nodeCode
};

/* SFFogNode: 1 node */
const int SFFogNode :: m_nodeTable[]={
	Fog :: nodeCode
};

/* SFFontStyleNode: 1 node */
const int SFFontStyleNode :: m_nodeTable[]={
	FontStyle :: nodeCode
};

/* SFGeometryNode: 18 nodes */
const int SFGeometryNode :: m_nodeTable[]={
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Cone :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	ElevationGrid :: nodeCode,
	Extrusion :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	Rectangle :: nodeCode,
	Sphere :: nodeCode,
	Text :: nodeCode
};

/* SFLinePropertiesNode: 1 node */
const int SFLinePropertiesNode :: m_nodeTable[]={
	LineProperties :: nodeCode
};

/* SFMaterialNode: 2 nodes */
const int SFMaterialNode :: m_nodeTable[]={
	Material :: nodeCode,
	Material2D :: nodeCode,
#ifdef ADV_AUDIO
	AcousticMaterial :: nodeCode
#endif
};

/* SFNavigationInfoNode: 1 node */
const int SFNavigationInfoNode :: m_nodeTable[]={
	NavigationInfo :: nodeCode
};

/* SFNormalNode: 1 node */
const int SFNormalNode :: m_nodeTable[]={
	Normal :: nodeCode
};

/* SFStreamingNode: 5 nodes */
const int SFStreamingNode :: m_nodeTable[]={
	AnimationStream :: nodeCode,
	AudioClip :: nodeCode,
	AudioSource :: nodeCode,
	Inline :: nodeCode,
	MovieTexture :: nodeCode
};

/* SFTextureCoordinateNode: 1 node */
const int SFTextureCoordinateNode :: m_nodeTable[]={
	TextureCoordinate :: nodeCode
};

/* SFTextureNode: 5 nodes */
const int SFTextureNode :: m_nodeTable[]={
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	ImageTexture :: nodeCode,
	MovieTexture :: nodeCode,
	PixelTexture :: nodeCode
};

/* SFTextureTransformNode: 1 node */
const int SFTextureTransformNode :: m_nodeTable[]={
	TextureTransform :: nodeCode
};

/* SFTopNode: 3 nodes */
const int SFTopNode :: m_nodeTable[]={
	Group :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	OrderedGroup :: nodeCode
};

/* SFViewpointNode: 1 node */
const int SFViewpointNode :: m_nodeTable[]={
	Viewpoint :: nodeCode
};

/* SFVisemeNode: 1 node */
const int SFVisemeNode :: m_nodeTable[]={
	Viseme :: nodeCode
};

/* SFWorldNode: 100 nodes */
const int SFWorldNode :: m_nodeTable[]={
	Anchor :: nodeCode,
	AnimationStream :: nodeCode,
	Appearance :: nodeCode,
	AudioBuffer :: nodeCode,
	AudioClip :: nodeCode,
	AudioDelay :: nodeCode,
	AudioFX :: nodeCode,
	AudioMix :: nodeCode,
	AudioSource :: nodeCode,
	AudioSwitch :: nodeCode,
	Background :: nodeCode,
	Background2D :: nodeCode,
	Billboard :: nodeCode,
	Bitmap :: nodeCode,
	Box :: nodeCode,
	Circle :: nodeCode,
	Collision :: nodeCode,
	Color :: nodeCode,
	ColorInterpolator :: nodeCode,
	CompositeTexture2D :: nodeCode,
	CompositeTexture3D :: nodeCode,
	Conditional :: nodeCode,
	Cone :: nodeCode,
	Coordinate :: nodeCode,
	Coordinate2D :: nodeCode,
	CoordinateInterpolator :: nodeCode,
	CoordinateInterpolator2D :: nodeCode,
	Curve2D :: nodeCode,
	Cylinder :: nodeCode,
	CylinderSensor :: nodeCode,
	DirectionalLight :: nodeCode,
	DiscSensor :: nodeCode,
	ElevationGrid :: nodeCode,
	Expression :: nodeCode,
	Extrusion :: nodeCode,
	Face :: nodeCode,
	FaceDefMesh :: nodeCode,
	FaceDefTables :: nodeCode,
	FaceDefTransform :: nodeCode,
	FAP :: nodeCode,
	FDP :: nodeCode,
	FIT :: nodeCode,
	Fog :: nodeCode,
	FontStyle :: nodeCode,
	Form :: nodeCode,
	Group :: nodeCode,
	ImageTexture :: nodeCode,
	IndexedFaceSet :: nodeCode,
	IndexedFaceSet2D :: nodeCode,
	IndexedLineSet :: nodeCode,
	IndexedLineSet2D :: nodeCode,
	Inline :: nodeCode,
	LOD :: nodeCode,
	Layer2D :: nodeCode,
	Layer3D :: nodeCode,
	Layout :: nodeCode,
	LineProperties :: nodeCode,
	ListeningPoint :: nodeCode,
	Material :: nodeCode,
	Material2D :: nodeCode,
	MovieTexture :: nodeCode,
	NavigationInfo :: nodeCode,
	Normal :: nodeCode,
	NormalInterpolator :: nodeCode,
	OrderedGroup :: nodeCode,
	OrientationInterpolator :: nodeCode,
	PixelTexture :: nodeCode,
	PlaneSensor :: nodeCode,
	PlaneSensor2D :: nodeCode,
	PointLight :: nodeCode,
	PointSet :: nodeCode,
	PointSet2D :: nodeCode,
	PositionInterpolator :: nodeCode,
	PositionInterpolator2D :: nodeCode,
	ProximitySensor2D :: nodeCode,
	ProximitySensor :: nodeCode,
	QuantizationParameter :: nodeCode,
	Rectangle :: nodeCode,
	ScalarInterpolator :: nodeCode,
	Script :: nodeCode,
	Shape :: nodeCode,
	Sound :: nodeCode,
	Sound2D :: nodeCode,
	Sphere :: nodeCode,
	SphereSensor :: nodeCode,
	SpotLight :: nodeCode,
	Switch :: nodeCode,
	TermCap :: nodeCode,
	Text :: nodeCode,
	TextureCoordinate :: nodeCode,
	TextureTransform :: nodeCode,
	TimeSensor :: nodeCode,
	TouchSensor :: nodeCode,
	Transform :: nodeCode,
	Transform2D :: nodeCode,
	Valuator :: nodeCode,
	Viewpoint :: nodeCode,
	VisibilitySensor :: nodeCode,
	Viseme :: nodeCode,
	WorldInfo :: nodeCode,
#ifdef ADV_AUDIO
	AcousticMaterial :: nodeCode, // these 3 nodes added 
	AcousticScene :: nodeCode, // riitta 080399
	DirectiveSound :: nodeCode,
#endif

	// -------[ Body Animation Part Added ]-------
	// By :	* Tolga Capin
	//      * Fabrice Vergnenegre
	// On : 09/25/1999
	Body :: nodeCode,
	BAP :: nodeCode,
	BDP :: nodeCode,
	BodyDefTable :: nodeCode,
	BodySegmentConnectionHint :: nodeCode
	// -------[ End Of Added Part ]-------
};

// -------[ Body Animation Part Added ]-------
// By :	* Tolga Capin
//      * Fabrice Vergnenegre
// On : 09/25/1999
const int SFBAPNode :: m_nodeTable[]={
	BAP :: nodeCode
};

const int SFBDPNode :: m_nodeTable[]={
	BDP :: nodeCode
};

const int SFBodyDefTableNode :: m_nodeTable[]={
	BodyDefTable :: nodeCode
};
// -------[ End Of Added Part ]-------


template <NodeType type> int SFNodeType<type> :: GetNodeTableSize () const
{
	return sizeof ( m_nodeTable ) / sizeof (int);
}

/*-----------------------------------------------------------------
Make sure each necessary SFxxxNode class is instantiated.
(This code is never called, it is here to make sure the linker gets
everything intantiated).
-----------------------------------------------------------------*/
void IntantiateTemplateInstances () {
	SF2DNode sf2dnode;
	SF3DNode sf3dnode;
	SFAppearanceNode sfappearancenode;
	SFAudioNode sfaudionode;
	SFBackground2DNode sfbackground2dnode;
	SFBackground3DNode sfbackground3dnode;
	SFColorNode sfcolornode;
	SFCoordinate2DNode sfcoordinate2dnode;
	SFCoordinateNode sfcoordinatenode;
	SFExpressionNode sfexpressionnode;
	SFFAPNode sffapnode;
	SFFDPNode sffdpnode;
	SFFITNode sffitnode;
	SFFaceDefMeshNode sffacedefmeshnode;
	SFFaceDefTablesNode sffacedeftablesnode;
	SFFaceDefTransformNode sffacedeftransformnode;
	SFFogNode sffognode;
	SFFontStyleNode sffontstylenode;
	SFGeometryNode sfgeometrynode;
	SFLinePropertiesNode sflinepropertiesnode;
	SFMaterialNode sfmaterialnode;
	SFNavigationInfoNode sfnavigationinfonode;
	SFNormalNode sfnormalnode;
	SFStreamingNode sfstreamingnode;
	SFTextureCoordinateNode sftexturecoordinatenode;
	SFTextureNode sftexturenode;
	SFTextureTransformNode sftexturetransformnode;
	SFTopNode sftopnode;
	SFViewpointNode sfviewpointnode;
	SFVisemeNode sfvisemenode;
	SFWorldNode sfworldnode;

	// -------[ Body Animation Part Added ]-------
	// By :	* Tolga Capin
	//      * Fabrice Vergnenegre
	// On : 09/25/1999
	SFBAPNode sfbapnode;
	SFBDPNode sfbdpnode;
	SFBodyDefTableNode sfbodydeftablenode;
	// -------[ End Of Added Part ]-------

}

/* End of automatically generated file */
