#ifndef __BAPPROXY_H__
#define __BAPPROXY_H__

// THIS WILL BE REMOVED WHEN STREAM PROBLEMS RESOLVED
//#define BAP_STREAM_IS_A_FILE

// Includes
#include <stdio.h>

#include "Nodes.h"
#include "fbadecoder/sim.h"
#include "Stream.h"
#include "opengl/base/MediaObjectProxy.h"
#include "opengl/base/VisualRenderer.h"
#include "mpeg4body.h"

class BAPProxy : public MediaObjectProxy {
// Attributes -----------------------------------------
private:
	BOOL firstUpdatePassed;		// first Update = open Stream
	Mpeg4Body * body;			// the body used for output
	Transform ** pointerTable;  // conversion table (VRML Joint -> TransformNode)

	FILE * bapFile;

// Constructor ----------------------------------------
public:
	BAPProxy(BAP * poBap);

// Accessers and Modifiers ----------------------------
public:

	// BAP casting accesser
	inline BAP * GetBAP() { 
		return (BAP *) GetMediaObject(); 
	}

	// BAPValues Accesser and Modifier
	inline int GetBAPValue(int iField) { 
		return GetBAP()->BAPValues[iField]; 
	}

	inline void SetBAPValue(int iField, int iValue) { 
		GetBAP()->BAPValues[iField] = iValue; 
	}

	// BAPMask Accesser and Modifier
	inline BOOL GetBAPMask(int iField) { 
		return GetBAP()->BAPMask[iField];
	}

	inline void SetBAPMask(int iField, BOOL bValue) {
		GetBAP()->BAPMask[iField] = bValue;
	}

	// Body Accesser
	inline Mpeg4Body * GetMpeg4Body() const {
		return body;
	}

	void ApplyBAPValues();

	// Accesser to the conversion Table
	inline Transform ** GetPointerTable() const {
		return pointerTable;
	}

	// Modifier of the conversion Table
	inline void SetPointerTable(Transform ** t) {
		pointerTable=t;
	}

	// Modifier of the conversion Table
	inline void SetPointerTableValue(int pos, Transform * t) {
		pointerTable[pos]=t;
	}

// Public methods -------------------------------------
public:

	// Update, called by BodyProxy::Update()
	BOOL Update(VisualRenderer* pRenderer, DWORD dwTime);

	// Render description overloaded
	void RenderDescription(	OpenGLVisualRenderer* pRenderer, 
							DWORD dwTime);

	// Inits the table of pointer to the transform Nodes
	void InitializePointerTable();

	// Constructs the table from the IM1 Hierarchy
	void ConstructPointerTable(MFNodeType<SF3DNode> & node);

	void Start() {
#ifndef BIFSENC
		m_bActive = TRUE;
		GetBAP()->OpenStream();
#endif
		body = new Mpeg4Body;
	}

	void Stop() {
#ifndef BIFSENC
	    m_bActive = FALSE;
	    GetBAP()->CloseStream();
#endif
		delete body;
	}

	// For debug purpose - nice print of the baps
	void PrettyPrintBAPs();
	//void OpenStream();
	//void CloseStream();
	//BOOL ReadBAPS();
};

#endif //__BAPPROXY_H__