/*************************************************************************

This software module developed by 

        Tolga K. Capin (capin@lig.di.epfl.ch), EPFL DI-LIG
	Joaquim Esmerado (jle@lig.di.epfl.ch), EPFL DI-LIG
        Kayvon Pirestani (kayvon@cs.cmu.edu),  EPFL DI-LIG

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-4 Video. Those 
intending to use this software module in hardware or software products are advised 
that its use may infringe existing patents. The original developer of this software 
module and his/her company, the subsequent editors and their companies, and ISO/IEC 
have no liability for use of this software module or modifications thereof in an 
implementation. Copyright is not released for non MPEG-4 Video conforming 
products. EPFL-LIG retains full right to use the code for his/her own 
purpose, assign or donate the code to a third party and to inhibit third parties from 
using the code for non <MPEG standard> conforming products. This copyright notice 
must be included in all copies or derivative works. Copyright (c) 1997.
 
Module Name:    fba_object_plane.c

Abstract:       Code face/body animation frame

Update:         April-1997
                July-1997
                August-1997
                Nov-1997 

Remarks:        see RCS log at end of encode.c
*************************************************************************/
/* 
 *  $Id: common.c,v 1.17 1998/08/26 08:43:59 jle Exp $
 * 
 *     Common functions
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include "common.h"

char *_kscanf_pos = NULL;


void err_exit(LOG_PARAMS, const char *format, ...)
{
  char message[LOG_BUFSIZE];
  va_list ap;
  if(!DEBUG) return;
  
  va_start(ap, format);
  vsprintf(message, format, ap);
  va_end(ap);
  
  if(USE_FNAME) fprintf(output, "%s: %s", fname, message);
  else fprintf(output, "%s", message);

  fflush(output);
  exit(-1);
}


void LOG(LOG_PARAMS, const char *format, ...)
{
  char message[LOG_BUFSIZE];
  va_list ap;
  if(!DEBUG) return;
  
  va_start(ap, format);
  vsprintf(message, format, ap);
  va_end(ap);
  
  if(USE_FNAME) fprintf(output, "%s: %s", fname, message);
  else fprintf(output, "%s", message);

  fflush(output);
}


void kscanf(char *string, const char *format, void *arg)
{
  if((_kscanf_pos < string) || (_kscanf_pos >= string+strlen(string))) {
    _kscanf_pos = string;
  }

  while(isspace(*_kscanf_pos))
    _kscanf_pos++;

  sscanf(_kscanf_pos, format, arg);

  _kscanf_pos = strpbrk(_kscanf_pos, " \t");
}
