#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "util.h"

int nfrm;
int fap_mask[NFAP], cut_mask[NFAP];

main(int argc, char **argv) {

  int i,j,k, n, tmpi;
  int nframe;
  int frameRate;
  char basename[100];
  float version, tmpf,tmpff, *mse, *psnr;
  FILE *fap_fp, *rfap_fp, *mask_fp;

  if(argc!=4) {
    fprintf(stderr, "Usage: %s original_fap cut_mask out_fap \n", argv[0]);
    exit(1);
  }

  if ((fap_fp = fopen(argv[1], "r")) == NULL){
    printf("file %s can not be open\n", argv[1]);
    exit(1);
  }
  if ((mask_fp = fopen(argv[2], "r")) == NULL){
    printf("file %s can not be open\n", argv[2]);
    exit(1);
  }
  if ((rfap_fp = fopen(argv[3], "wb")) == NULL){
    printf("file %s can not be open\n", argv[3]);
    exit(1);
  }
  for (i=0; i<NFAP; i++)
    fscanf(mask_fp, "%d", &cut_mask[i]);
  fclose(mask_fp);
 
  /* Read Header Information from original faps file */
  nextValidLine(fap_fp);
  fscanf(fap_fp, "%f", &version);
  fscanf(fap_fp, "%s", basename);
  fscanf(fap_fp, "%d", &frameRate);
  fscanf(fap_fp, "%d", &nframe);
  nfrm = nframe;
  fprintf(rfap_fp, "%3.1f ", version);
  fprintf(rfap_fp, "cut ");
  fprintf(rfap_fp, "%d ", frameRate);
  fprintf(rfap_fp, "%d ", nframe);

  
  if (version < 1.5) {
    for(i=0; i<NGROUP; i++) {
      int mask;
      fscanf(fap_fp, "%d", &mask);
      fprintf(rfap_fp, "%d ", mask);
    }
  }
  fprintf(rfap_fp, "\n");
  
  for (i=0; i<NFAP; i++) {
    int mask;
    fscanf(fap_fp, "%d", &mask);
    fap_mask[i] = mask;
  }
 
  for (i=0; i<NFAP; i++)
    fprintf(rfap_fp, "%d ", fap_mask[i]*cut_mask[i]);
  fprintf(rfap_fp, "\n");
  
  for(n=0; n<nfrm; n++) {
    fscanf(fap_fp, "%d", &tmpi); /* frame_number */
    fprintf(rfap_fp, "%d ", tmpi);

    for(i=0; i<NFAP; i++) {
      if (fap_mask[i]) {
	fscanf(fap_fp, "%d", &tmpi);
	if (cut_mask[i])
	  fprintf(rfap_fp, "%d ", tmpi);
      }
    }
    fprintf(rfap_fp, "\n");
    
    if (version >1.5 && n<nfrm-1) {
      for (i=0; i<NFAP; i++) {
	int mask;
	fscanf(fap_fp, "%d", &mask);
	fap_mask[i] = mask;
      }
      
      for (i=0; i<NFAP; i++)
	fprintf(rfap_fp, "%d ", fap_mask[i]*cut_mask[i]);
      fprintf(rfap_fp, "\n");
    }
  }
  fclose(fap_fp);
  fclose(rfap_fp);
}




