/*****************************************************************************
* anim.h : global parameters/function prototypes of ISTFAPanim.c & ISTanim_file.c
*
* Gabriel Antunes Abrantes
* Instituto Superior Tecnico
* October 1997
* 
*
****************************************************************************/


#ifndef _ANIM_H_
#define _ANIM_H_

#include <stdio.h>
  
#define ON  1
#define OFF 0

#define X 0 
#define Y 1
#define Z 2

#define V1     0
#define V2     1
#define V3     2
#define COLOUR 3


#define NO_FAPS 68
#define NO_VERTX 1704
#define NO_POINTS 1040

#define POLYGON 1
#define GRID    0

#define PI 3.14159 

#define sqr(x) pow(x,2)

extern float  irisd;
extern float  es;
extern float  ens;
extern float  mns;
extern float  mw;
extern float  au;

extern float  eyelid_radius_left;
extern float  eyelid_radius_right;
extern float  points_orig[NO_POINTS][3]; 
extern float  pts[NO_POINTS][3]; 
extern int    vertx[NO_VERTX][4] ;
extern float  norms[NO_POINTS][3];
extern float  faps[NO_FAPS+1];
extern int    fap_mask[NO_FAPS+1];
extern int	  fap_expr[6];
extern int	  fap_vis[4];

extern float  *expressions_out[384][384];
extern float  *visemes_out[15][15][64];
extern float  vis_table[15][NO_FAPS+1];

extern int	  ISTexpressions[7][NO_FAPS+1];


extern float  fps;
extern long   sequence_start;

extern int    no_frame_display;

extern int    model;
extern int    texture;

void Expression();
void Visemes();

void FAP_Interpolation();

void FrameAnimation();

void GetFapUnits();
int  GetVertex();
int  GetPoints();
void GetExpressions();

void FreeExpressionVisemesTable();
void ResetExpressionVisemesTable();

int  Pass(FILE *);
int  PassToNumber(FILE *);
int  GetInt(FILE *);
void KillLine(FILE *);
int  ReadFapHeader(char *);
int  ReadFapFrame();
void AnimateOneFrame(int);
void ObtainNormal(float *, float *, float *, float *);
void NormalizeVector(float *);
void ObtainVertsNormals();

int  PlaySequence();
int  PlayRealTime();

void RewindSequence();
void CloseOpenFiles();

int  Show1Frame();
int  ShowNeutralFace();

int  ReadWord(FILE *,char *);
int  PassBlank(FILE *); 
void TestforTrash(FILE *);

#endif
