/*****************************************************************************
* decoder.h : global parameters/function prototypes of ISTdecoder.c
*
* Gabriel Antunes Abrantes
* Instituto Superior Tecnico
* October 1997
* 
*
****************************************************************************/


#ifndef _DECODER_H_
#define _DECODER_H_

#define ALL_FRAMES    1
#define REAL_SEQUENCE 2

#include "codec.h"

extern int fapx[NO_FAPS+1];
extern int fapx_mask[NO_FAPS+1];
extern int GroupMaskLimits[11];
extern int end;

extern int **dc_table,**ac_table,**run_table;	

int  ReadWord(FILE *,char *);
int  PassBlank(FILE *);
int  OpenStreamFile(char *);
void RewindBitStream();
int  Test_Decoder_Conditions();

int GetBits(int ,FILE *);
int GetBit(FILE *); 
void NextStartCode(FILE *);

int  Decode_Face_Object(int);

void IntMatrixDealoc(int **,int);
int  CheckHuffmanTables();
void ReadHuffmanTables();

void Artithmetic_DeCoder(int);
void DCT_DeCoder(int);

int Check_Face_Paramset_Mask(int);
void  DeCode_Frame_Rate(float *,FILE *);
void  DeCode_Time_Code(FILE *);
int   DeCode_Skip_Frames(int *,FILE *);

int DisplayDecodedFrame(int);

extern FILE *fp_stream;
extern int mask_type[GROUP_MASK_SIZE];
extern int GroupMaskLimits[GROUP_MASK_SIZE+1];

extern int zerocount;
extern int bitsin;

int quantize(int,int);

int  bit_out_psc_layer(FILE *);
int  decoder_reset(FILE *);
int  aa_decode(int cumul_freq[ ],FILE *);
void update(int ,int ,int *,int *, int **, int **); 
void update_expression(int , int ,int **, int **,int);
void update_viseme(int , int ,int **, int **,int);
void init_arith(int *,int *,int **, int *,int *, int **q, int **,int **, int **,int **,
				int **, int **,int **,int mask[69],int);
void AdjustBits(FILE *);
void ResetIntra(int *,int);
int  DeCode_New_Minmax(int,int,int,int,int *,int *,int *,int *,int *,int *,int *,int *,FILE *);
int  DeCode_IFap(int *,int *,int *,int **,int *, int *,int **, int **,int **,int **,
				 int **, int **,int **,int **,int,FILE *);
int  DeCode_PFap(int *,int *,int *,int **,int *, int *,int **, int **,int **,int **,
				 int **, int **,int **,int **,int,FILE *);



float **FloatMatrixAllocation(int ,int );
void  MatrixDealoc(float **,int );
int   **IntMatrixAllocation(int ,int );
void  IntMatrixDealoc(int **,int );
void  MakeIDCTMatrix(float **);
void  ResetDCTIntra(float **,int **,float *,int );
void  DeCode_ISegment(int *, float **, int	**,int	**,float *,float *,float **, int **,
					  int **,FILE *);
void  DeCode_PSegment(int *,float **,int	**,int	**,float *,float *,float **,int **,
					  int **,int **,FILE *);
int   ShowAllDCTFrames(float **,int **,int **,int *,int);


#endif
