/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* Peter van Beek (Sharp Labs of America)                             */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* Sharp Labs of America retains full right to use the code for       */
/* their own purposes, assign or donate the code to a third party and */
/* to inhibit third parties from using the code for non MPEG-4 Visual */
/* (ISO/IEC 14496-2) conforming products.                             */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1997-1999                                            */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME         conformance.h
   AUTHOR       Peter van Beek, Fri Apr  2 14:05:04 1999
   DESCRIPTION  Definitions for conformance bitstream generation
   SYNOPSIS     #include "conformance.h"
   NOTE         Used only for generating bitstreams for conformance tests!
   UPDATES      
**********************************************************************-*/

#ifndef CONFORMANCE_DEF_INCL
#define CONFORMANCE_DEF_INCL


// Schedules containing various parameter settings

const int scheduleLength = 31;

const int isTimeSchedule[] = 
	{1,0,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
const int isSkipSchedule[] = 
	{0,0,0,1,1,0,0,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
const int isRateSchedule[] = 
	{0,0,1,0,1,0,1,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

const int tHoursSchedule[] =
	{0,0,0,1,3,12,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
const int tMinutesSchedule[] =
	{0,0,0,4,25,47,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
const int tSecondsSchedule[] =
	{0,0,11,34,43,6,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

const int fSkipSchedule[] = 
	{0,0,0,7,43,0,0,2,19,0,0,15,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

const int frBaseSchedule[] = 
	{10,10,10,10,10,10,10,10,10,10,10,10,10,0,1,0,1,1,1,0,12,0,12,12,12,0,255,0,255,255,255};
const int frFracSchedule[] = 
	{0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,1,7,0,7,0,7,7,15,0,15,0,15,15};
const int frOffsetSchedule[] = 
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,1,1,0,1,0,0,1,1,0,1};



#endif // CONFORMANCE_DEF_INCL
