/**********************************************************************/
/*                                                                    */
/* This software module was originally developed by                   */
/*                                                                    */
/* A. Tanju Erdem (Eastman Kodak Company)                             */
/* Candemir Toklu (University of Rochester)                           */
/* Peter van Beek (University of Rochester)                           */
/*                                                                    */
/* in the course of development of MPEG-4 Visual (ISO/IEC 14496-2).   */
/* This software module is an implementation of a part of one or      */
/* more MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by the     */
/* MPEG-4 Visual (ISO/IEC 14496-2). ISO/IEC gives users of MPEG-4     */
/* Visual (ISO/IEC 14496-2) free license to this software module or   */
/* modifications thereof for use in hardware or software products     */
/* claiming conformance to MPEG-4 Visual (ISO/IEC 14496-2). Those     */
/* intending to use this software module in hardware or software      */
/* products are advised that its use may infringe existing patents.   */
/* The original developer of this software module and his/her         */
/* company, the subsequent editors and their companies, and ISO/IEC   */
/* have no liability for use of this software module or modifications */ 
/* thereof in an implementation. Copyright is not released for non    */
/* MPEG-4 Visual (ISO/IEC 14496-2) conforming products.               */
/* Eastman Kodak Company and the University of Rochester retain full  */
/* right to use the code for their own purposes, assign or donate the */
/* code to a third party and to inhibit third parties from using the  */
/* code for non MPEG-4 Visual (ISO/IEC 14496-2) conforming products.  */
/* This copyright notice must be included in all copies or derivative */
/* works.                                                             */
/*                                                                    */
/* Copyright (c) 1994-1998                                            */
/*                                                                    */
/**********************************************************************/

/*+*********************************************************************
   NAME         triRefClass.cpp
   AUTHOR       Peter van Beek - University of Rochester.
   DATE         Fri Aug  7 11:47:33 1998
   DESCRIPTION  Member functions for Tri2dRef class are defined in this
                file.
   SYNOPSIS     Include files: 
                #include "general.h"
                #include "triRefClass.h"
                #include "polyClass.h"
*********************************************************************-*/

#include "general.h"
#include "triRefClass.h"
#include "polyClass.h"


//------------------------------------------------------------------------

// Constructor
Tri2dRef::Tri2dRef()
{
	for (int i = 0; i < 3; i++) {
		corner[i] = NULL;
		neighbor[i] = NULL;
		nedge[i] = -1;
	}
	next = prev = NULL;
	mark = 0;
}

// Destructor
Tri2dRef::~Tri2dRef()
{
	next = prev = NULL;
}

// Return a copy of the triangle
Tri2d Tri2dRef::triangle()
{
	Tri2d p;
	for (int i = 0; i < 3; i++) {
		if (corner[i] == NULL) {
			cout << "Tri2dRef::triangle: invalid triangle..." << endl;
			return p;
		}
		p[i] = corner[i]->getPoint();
	}
	return p;	
}

// end of file
