#ifndef CODEC_HH
#define CODEC_HH

typedef unsigned char byte;
typedef unsigned short ushort;
typedef signed short sshort;

#include <stdio.h>
#include <stdlib.h>

#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))

#define sc 0x000001
#define fba_sequence_start_code (sc<<8) + 0x01
#define fba_sequence_end_code (sc<<8) + 0x02
#define fba_segment_start_code (sc<<8) + 0x03

#define NFAPS 68
#define NGROUPS 10
#define CURRENT_FAP_VERSION 2.0

#define NFBFS 20
#define CURRENT_FBF_VERSION 1.2

#define FBFQUANT {1, 1, 1, 1, 1, 1, 2, 2, 1, 2,  2, 1, 1, 1, 2,  2, 2, 2, 4, 4, 4, 4, 4, 4, 1, 1}
#define MATRIX "/home/icg/ahlberg/mpeg4/matlab/fbf2fap.mat"


#undef FBFQUANT
#define FBFQUANT {1, 1, 1, 1, 1, 1, 2, 2, 1, 2,  2, 1, 1, 1, 2,  2, 2, 2, 4, 4, 4, 4, 4, 4}
#undef MATRIX
#define MATRIX "/home/icg/ahlberg/mpeg4/matlab/fbf2fap23.mat"

#undef FBFQUANT
#define FBFQUANT {1, 1, 1, 1, 1, 1, 2, 2, 1, 2,  2, 1, 2,  2, 2, 4, 4,  4, 4, 4}
#undef MATRIX
#define MATRIX "/home/icg/ahlberg/mpeg4/matlab/fbf2fap20.mat"

#define BITS_PER_HUFF_SYMBOL 50
#define STREAMSIZE 50000

#define QP 0.125
#define DCT_QP 2
#define QUANTBITS 5

#define HUFFTABLE_FBF "src/huffman/tables/fbf512.table"
#define HUFFTABLE_AC "src/huffman/tables/ac512.table"
#define HUFFTABLE_DC "src/huffman/tables/dc512.table"
#define HUFFTABLE_RL "src/huffman/tables/rl16.table"
#define FBF_MIN -2.0
#define FBF_MAX 2.0

#define PREDORDER 1
#define PREDICTOR {1.0} //{1.3, -0.3}

#define DCT_BLOCKSIZE 16

#define CODINGBITS 2
#define CODING_NONE 0
#define CODING_PRED 1
#define CODING_DCT 2

#endif
