// =====================================================
//
// File:   cut.cc
// Uses:   FAPs, Mask
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-13
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================

#include <iostream.h>
#include "sequence/faps.hh"
#include "sequence/mask.hh"

#define ARG_MASKFILE 1
#define ARG_INFILE 2
#define ARG_OUTFILE 3
#define ARGS 4
#define ARGSTRING " maskfile infile outfile\n"
#define HELPSTRING " reads a FAPmask (maskfile), applies this on the\ninput FAPs (infile) and saves the resulting FAPs (outfile).\n"

// =====================================================


void main(int argc, char *argv[]) {

  FAPs faps;
  Mask mask;

  if(argc != ARGS) {
    cerr << "Usage: " << argv[0] << ARGSTRING;
    cerr << argv[0] << HELPSTRING;
    exit(0);
  }

  mask.resize(NFAPS);
  mask.read_ascii(argv[ARG_MASKFILE]);
  faps.read_ascii(argv[ARG_INFILE]);
  faps.remove_params(mask);
  faps.write_ascii(argv[ARG_OUTFILE]);

};
