// =====================================================
//
// File:   dct.hh
// Class:  DCT
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-12
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#ifndef DCT_HH
#define DCT_HH

#include <math.h>


// =====================================================

class DCT {

private:

  float *dct_matrix;
  int size;

public:

  DCT(int);
  ~DCT(void) {delete dct_matrix;}

  void encode(float*, int, float*);
  void encode(float*, int);
  void inline encode(float* in, float* out) {encode(in, 1, out);}
  void inline encode(float* in) {encode(in, 1);} 

  void decode(float*, int, float*);
  void decode(float*, int);
  void inline decode(float* in, float* out) {decode(in, 1, out);}
  void inline decode(float* in) {decode(in, 1);} 

};

#endif
