// =====================================================
//
// File:   ip.cc
// Uses:   FAPs, FIT
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-13
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================

#include <iostream.h>
#include "fit/fit.hh"
#include "sequence/faps.hh"

#define ARG_INFILE 1
#define ARG_OUTFILE 2
#define ARGS 3
#define ARGSTRING " infile outfile\n"
#define HELPSTRING " reads a FIT from stdin, applies this on the\ninput FAPs (infile) and saves the resulting FAPs (outfile).\n"

// =====================================================


void main(int argc, char *argv[]) {

  FAPs faps;
  FIT fit;

  if(argc != ARGS) {
    cerr << "Usage: " << argv[0] << ARGSTRING;
    cerr << argv[0] << HELPSTRING;
    exit(0);
  }

  cin >> fit;
  faps.read_ascii(argv[ARG_INFILE]);
  fit.interpolate(faps).write_ascii(argv[ARG_OUTFILE]);

};
