// =====================================================
//
// File:   faps.hh
// Class:  FAPs
// Uses:   Sequence
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#ifndef FAPS_HH
#define FAPS_HH

#include "../sequence/sequence.hh"


// =====================================================


class FAPs : public Sequence {

public:

  // Constructors

  FAPs(void);
  FAPs(int);
  FAPs(int, Mask&);
  FAPs(Mask&, FileInfo&);

  // Primitives

  inline Mask& getFAPmask(void) {return mask;}
  inline Mask& setFAPmask(Mask& src) {return mask.copy(src);}

  inline int usedFAPs(void) {return mask.sum();}

  float psnr(FAPs&);

  // Input & output

  int read_ascii(char*);
  int read_ascii(FILE*);
  int write_ascii(char*);
  int write_ascii(FILE*);

};

#endif



