// =====================================================
//
// File:   fileinfo.cc
// Class:  FileInfo
// Uses:   -
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-12
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#include "fileinfo.hh"


// ============================================
//
// copy
//
// ============================================

FileInfo& FileInfo::
copy(FileInfo& src) {
  char *s, *d;
  version = src.version;
  framerate = src.framerate;
  nframes = src.nframes;
  s = src.basename; d = basename;
  while(*d++=*s++);
  return *this;
}

FileInfo& FileInfo::
copy(float newver, char* newname, int newrate, int newnfrm) {
  char *s, *d;
  version = newver;
  s = newname; d = basename;
  while(*d++=*s++);
  framerate = newrate;
  nframes = newnfrm;
}
  

// ============================================
//
// read_ascii
//
// ============================================

void FileInfo::read_ascii(FILE *fp) {
  fscanf(fp,"%f",&version);
  fscanf(fp,"%s",basename);
  fscanf(fp,"%d",&framerate);
  fscanf(fp,"%d",&nframes);
}


// ============================================
//
// write_ascii
//
// ============================================

void FileInfo::
write_ascii(FILE *fp) {
  fprintf(fp,"%1.1f %s %d %d\n",version,basename,framerate,nframes);
}
