// =====================================================
//
// File:   mask.cc
// Class:  Mask
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-12
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#include "mask.hh"


// =====================================================
//
// copy
//
// =====================================================

Mask& Mask::
copy(Mask& src) {
  resize(src.size());
  for(int i=0;i<size();i++) set(i,src.bit(i));
  return *this;
}


// =====================================================
//
// read_ascii
//
// =====================================================

int Mask::
read_ascii(char *filename) {
  FILE *fp;
  if((fp = fopen(filename, "r")) == 0) {
    fprintf(stderr, "File %s cannot be opened!\n", filename);
    return(0);
  }
  read_ascii(fp);
  fclose(fp);
}

// =====================================================

int Mask::
read_ascii(FILE *fp) {
  int tmpi;
  _sum = 0;
  for(int i = 0; i < _size; i++) {
    fscanf(fp, "%d", &tmpi);
    if(_data[i] = (char)tmpi) _sum++;
  }
}


// =====================================================
//
// write_ascii
//
// =====================================================

int Mask::
write_ascii(char *filename) {
  FILE *fp;
  if((fp = fopen(filename, "w")) == 0) {
    printf("File %s cannot be opened!\n", filename);
    return(0);
  }
  write_ascii(fp);
  fclose(fp);
  return(1);
}

// =====================================================

int Mask::
write_ascii(FILE *fp) {
  for(int i = 0; i < _size; i++)
    fprintf(fp, "%d ", _data[i]);
  fprintf(fp, "\n");
}


// =====================================================
//
// calcsum
//
// =====================================================

int Mask::
calcsum(void) {
  _sum = 0;
  for(int i = 0; i < _size; i++)
    if(_data[i]) _sum++;
  return _sum;
}
