#ifndef BITSTREAM_HH
#define BITSTREAM_HH

#include <stdio.h>
#include <stdlib.h>

#include "util.hh"

class Bitstream {

public:
  int nbytes;
  int byte_cnt;
  int bit_cnt;
  BYTE data[STREAMSIZE];

  BYTE inline nextbit(void) {
    BYTE tmpb;
    tmpb = (data[byte_cnt] >> (7-bit_cnt)) & 1;
    bit_cnt++;
    if(bit_cnt == 8) {bit_cnt = 0; byte_cnt++;}
    return(tmpb);
  }

  BYTE inline nextbits(int bits) {
    BYTE tmpb = 0;
    while(bits--) {
      tmpb = (tmpb<<1) + nextbit();
    }
    return(tmpb);
  }

  BYTE inline nextbyte() {
    return(nextbits(8));
  }

  unsigned short inline nextushort() {
    unsigned short tmps = (unsigned short)nextbyte();
    return((tmps<<8) + nextbyte());
  }    

  signed short inline nextsshort() {
    signed short tmps = (unsigned short)nextbyte();
    return((tmps<<8) + nextbyte());
  }    

  int inline nextint() {
    int tmpi = (int)nextsshort();
    return((tmpi<<16) + (int)nextsshort());
  }

  int inline nextint_lookforward() {
    int tmp_bit_cnt, tmp_byte_cnt, tmpi;
    tmp_bit_cnt = bit_cnt;
    tmp_byte_cnt = byte_cnt;
    bytealign();
    tmpi = nextint();
    byte_cnt = tmp_byte_cnt;
    bit_cnt = tmp_bit_cnt;
    return tmpi;
  }
      
  void inline bytealign(void) {
    if(bit_cnt != 0) {
      bit_cnt = 0; byte_cnt++;
    }
  }

  void read(char *filename);
};

#endif
