// =====================================================
//
// File:   ibstream.hh
// Class:  ibstream
// Uses:   -
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-13
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#ifndef IBSTREAM_HH
#define IBSTREAM_HH

#include <stdio.h>
#include <stdlib.h>

#include "../codec.hh"


// =====================================================


class ibstream {

public:

  // Attributes

  int nbytes;
  int byte_cnt;
  int bit_cnt;
  byte data[STREAMSIZE];

  // Constructor

  ibstream(void) {nbytes=0; byte_cnt=0; bit_cnt=0;}
  ibstream(FILE* fp) {load(fp);}

  // Primitives

  byte nextbit(void);
  byte nextbits(int);
  byte inline nextbyte(void) {return(nextbits(8));}
  ushort nextushort(void);
  sshort nextsshort(void);
  int inline nextint(void);
  int nextint_lookforward();

  void bytealign(void);

  // Load buffer

  void load(FILE*);

};

#endif
