// =====================================================
//
// File:   obstream.hh
// Class:  obstream
// Uses:   -
// 
// Author: Jrgen Ahlberg <ahlberg@isy.liu.se>
//         Dept. of Electrical Engineering
//         Linkping University
//         SE-581 83 Linkping, SWEDEN
// Date:   1998-01-13
//
// This program is distributed in the hope that it will
// be useful, but WITHOUT ANY WARRANTY.
//
// =====================================================


#ifndef OBSTREAM_HH
#define OBSTREAM_HH

#include <stdio.h>
#include <stdlib.h>

#include "../codec.hh"


// =====================================================


class obstream {

public:

  int byte_cnt;
  int bit_cnt;
  byte data[STREAMSIZE];

  // Constructor & init

  obstream(void) {byte_cnt = 0; bit_cnt = 0;}
  void inline init(void) {byte_cnt = 0; bit_cnt = 0;}

  // Primitives

  void nextbit(byte);
  void nextbits(int i, byte b) {while(i--) nextbit(b&(1<<i));}
  void inline nextbyte(byte b) {nextbits(8, b);}
  void inline nextshort(short s) {nextbyte(byte(s>>8)); nextbyte(byte(s));}    
  void inline nextint(int i) {nextshort(ushort(i>>16)); nextshort(ushort(i));}

  void bytealign(void);

  // Save buffer

  void save(FILE*);

};

#endif
