
/*************************************************************************

This software module was originally developed by 
	Wei Wu (weiwu@stallion.risc.rockwell.com),  Rockwell Science Center 
        Tolga K. Capin (capin@lig.di.epfl.ch), EPFL-LIG,
        Joaquim Esmerado (jle@lig.di.epfl.ch), EPFL-LIG.

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-4 Video. Those 
intending to use this software module in hardware or software products are advised 
that its use may infringe existing patents. The original developer of this software 
module and his/her company, the subsequent editors and their companies, and ISO/IEC 
have no liability for use of this software module or modifications thereof in an 
implementation. Copyright is not released for non MPEG-4 Video conforming 
products. Rockwell Science Center and EPFL-LIG retain full right to use the code
for his/her own  purpose, assign or donate the code to a third party and to inhibit
third parties from  using the code for non <MPEG standard> conforming products. This
copyright notice must be included in all copies or derivative works. Copyright (c) 1997.

Module Name:	quant.c

Abstract:	Quantization and Dequantization

Update:		April-1997

Remarks:

*************************************************************************/

#include "sim.h"

int
quant(int fap, int qstep) {

  int level;
  int qfap;

  if(qstep) {
  	level = (abs(fap)<=qstep/2)?0:(abs(fap)+qstep/2)/qstep;
  	qfap = sign(fap) * level;
  	return qfap;
  } else { /* 0 stepsize means no quantization */
	return fap;
  }

}

int 
dequant(int qfap, int qstep) {


  if(qstep) {
  	return qfap*qstep;
  } else {
	return qfap;
  }
}
