/*************************************************************************

This software module was originally developed by 

	Ming-Chieh Lee (mingcl@microsoft.com), Microsoft Corporation
	Wei-ge Chen (wchen@microsoft.com), Microsoft Corporation
	Bruce Lin (blin@microsoft.com), Microsoft Corporation
	Chuang Gu (chuanggu@microsoft.com), Microsoft Corporation
	Simon Winder (swinder@microsoft.com), Microsoft Corporation

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video tools 
as specified by the MPEG-4 Video. 
ISO/IEC gives users of the MPEG-4 Video free license to this software module or modifications 
thereof for use in hardware or software products claiming conformance to the MPEG-4 Video. 
Those intending to use this software module in hardware or software products are advised that its use may infringe existing patents. 
The original developer of this software module and his/her company, 
the subsequent editors and their companies, 
and ISO/IEC have no liability for use of this software module or modifications thereof in an implementation. 
Copyright is not released for non MPEG-4 Video conforming products. 
Microsoft retains full right to use the code for his/her own purpose, 
assign or donate the code to a third party and to inhibit third parties from using the code for non <MPEG standard> conforming products. 
This copyright notice must be included in all copies or derivative works. 

Copyright (c) 1996, 1997.


Module Name:

	wvtchannel.hpp

Abstract:

	general parameter holding class

Revision History:

*************************************************************************/

#ifndef __WVTCHANNEL_HPP_ 
#define __WVTCHANNEL_HPP_

typedef struct {
	Int iACQuant;
	Int iBitBudget;
} WvtSNRParams;

typedef struct {
	Int iSNRLevels;
	WvtSNRParams *pSNRList;
} WvtSpatialParams;

Class CWvtCoderChannel
{
public:
	CWvtCoderChannel();
	~CWvtCoderChannel();

	void createSpatialSet(Int);
	void createSNRSet(Int,Int);

	void setDCQuant(Int iDCQuant) { m_iDCQuant=iDCQuant; }
	void setSNRParams(Int,Int,Int,Int);
	void setSave(Int,Int);

	Int getDCQuant() { return m_iDCQuant; }
	Int getSpatialSave() { return m_iSpatialSave; }
	Int getSNRSave() { return m_iSNRSave; }
	Int getSpatialLevels() { return m_iSpatialLevels; }
	Int getSNRLevels(Int i) { return m_pSpatialList[i].iSNRLevels; }
	Int getSNRACQuant(Int i,Int j) 
		{ return m_pSpatialList[i].pSNRList[j].iACQuant; }
	Int getSNRBitBudget(Int i,Int j)
		{ return m_pSpatialList[i].pSNRList[j].iBitBudget; }
	Bool checkSave(Int,Int);

private:
	Int m_iDCQuant;
	Int m_iSpatialSave;
	Int m_iSNRSave;
	Int m_iSpatialLevels;
	Int m_iNumQuants;
	WvtSpatialParams *m_pSpatialList;
};

#endif // __WVTCHANNEL_HPP_