/*************************************************************************

This software module was originally developed by 

	Ming-Chieh Lee (mingcl@microsoft.com), Microsoft Corporation
	Wei-ge Chen (wchen@microsoft.com), Microsoft Corporation
	Bruce Lin (blin@microsoft.com), Microsoft Corporation
	Chuang Gu (chuanggu@microsoft.com), Microsoft Corporation
	Simon Winder (swinder@microsoft.com), Microsoft Corporation

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video tools 
as specified by the MPEG-4 Video. 
ISO/IEC gives users of the MPEG-4 Video free license to this software module or modifications 
thereof for use in hardware or software products claiming conformance to the MPEG-4 Video. 
Those intending to use this software module in hardware or software products are advised that its use may infringe existing patents. 
The original developer of this software module and his/her company, 
the subsequent editors and their companies, 
and ISO/IEC have no liability for use of this software module or modifications thereof in an implementation. 
Copyright is not released for non MPEG-4 Video conforming products. 
Microsoft retains full right to use the code for his/her own purpose, 
assign or donate the code to a third party and to inhibit third parties from using the code for non <MPEG standard> conforming products. 
This copyright notice must be included in all copies or derivative works. 

Copyright (c) 1996, 1997.


Module Name:

	wvtfilter.hpp
	
Abstract:

	filtering unit

Revision History:

*************************************************************************/

#ifndef __WVTFILTER_
#define __WVTFILTER_

Class CWvtFilterUnit
{
public:
	CWvtFilterUnit(FilterType);
	~CWvtFilterUnit();

	void forwardTransform(CFloatImage *,CWvtDecompTree *);
	void inverseTransform(CWvtDecompTree *,CFloatImage *);

private:
	void filterUpByRow(CFloatImage *,CFloatImage *,WvtFilter *);
	void filterUpByCol(CFloatImage *,CFloatImage *,WvtFilter *);
	void filterDownByRow(CFloatImage *,CFloatImage *,WvtFilter *);
	void filterDownByCol(CFloatImage *,CFloatImage *,WvtFilter *);
	void setDaube_9_3();
	void setDaube_9_7();

	WvtFilter *m_pwfHighPassAna;
	WvtFilter *m_pwfLowPassAna;
	WvtFilter *m_pwfHighPassSyn;
	WvtFilter *m_pwfLowPassSyn;
};

#endif __WVTFILTER_

