/*************************************************************************

This software module was originally developed by 

	Ming-Chieh Lee (mingcl@microsoft.com), Microsoft Corporation
	Wei-ge Chen (wchen@microsoft.com), Microsoft Corporation
	Bruce Lin (blin@microsoft.com), Microsoft Corporation
	Chuang Gu (chuanggu@microsoft.com), Microsoft Corporation
	Simon Winder (swinder@microsoft.com), Microsoft Corporation

in the course of development of the MPEG-4 Video (ISO/IEC 14496-2). 
This software module is an implementation of a part of one or more MPEG-4 Video tools 
as specified by the MPEG-4 Video. 
ISO/IEC gives users of the MPEG-4 Video free license to this software module or modifications 
thereof for use in hardware or software products claiming conformance to the MPEG-4 Video. 
Those intending to use this software module in hardware or software products are advised that its use may infringe existing patents. 
The original developer of this software module and his/her company, 
the subsequent editors and their companies, 
and ISO/IEC have no liability for use of this software module or modifications thereof in an implementation. 
Copyright is not released for non MPEG-4 Video conforming products. 
Microsoft retains full right to use the code for his/her own purpose, 
assign or donate the code to a third party and to inhibit third parties from using the code for non <MPEG standard> conforming products. 
This copyright notice must be included in all copies or derivative works. 

Copyright (c) 1996, 1997.


Module Name:

	wvtstream.hpp

Abstract:
	
	bitstream class for bi-level quant

Revision History:

*************************************************************************/

#ifndef __WVTSTREAM_HPP_
#define __WVTSTREAM_HPP_

typedef struct WvtSNRStreamTag {
	CWvtArithCoder *pacCodedAC;
	Int iQuant;
	struct WvtSNRStreamTag *next;
} WvtSNRStream;

typedef struct {
	Int iSNRLevels;
	WvtSNRStream *pSNRStream;
} WvtSpatialStream;

Class CWvtCodedStream
{
public:
	CWvtCodedStream();
	~CWvtCodedStream();

	void setSpatialLevels(Int);
	void attachACStream(Int,CWvtArithCoder *,Int iQ=0);
	void attachDCStream(CWvtArithCoder *pacCodedDC) { m_pacCodedDC=pacCodedDC; }
	void setQuant(Int iQuant) { m_iQuant=iQuant; }

	Int getSpatialLevels() { return m_iSpatialLevels; }
	Int getSNRLevels(Int iSpatialLevel)
		{ return m_pSpatialStream[iSpatialLevel].iSNRLevels; }
	Int getQuant() { return m_iQuant; }
	CWvtArithCoder *getDCStream() { return m_pacCodedDC; }
	CWvtArithCoder *getACStream(Int,Int);
	Int getACQuant(Int,Int);

private:
	Int m_iQuant;
	CWvtArithCoder *m_pacCodedDC;
	Int m_iSpatialLevels;
	WvtSpatialStream *m_pSpatialStream;
};

#endif // __WVTSTREAM_HPP_
