/******************************************************************************

This software module was originally developed by
        Wei Wu (weiwu@stallion.risc.rockwell.com),  Rockwell Science Center
in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in
hardware or software products claiming conformance to the MPEG-4 Video. Those
intending to use this software module in hardware or software products are advised
that its use may infringe existing patents. The original developer of this software
module and his/her company, the subsequent editors and their companies, and ISO/IEC
have no liability for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Video conforming
products. Rockwell Science Center retains full right to use the code for his/her own
purpose, assign or donate the code to a third party and to inhibit third parties from
using the code for non <MPEG standard> conforming products. This copyright notice
must be included in all copies or derivative works. Copyright (c) 1997.

******************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include "vd_grid.h"

CGrid::~CGrid() 
{
  int i, nXCells1=nXCells+1;

  delete [] mx;
  delete [] my;
  for(int i=0; i<nXCells1; i++) {
  	delete [] mz[i];
  }
  delete [] mz;
  delete [] tx;
  delete [] tx;
}

CGrid::CGrid(const char* gridFileName)
{
  int i, j;
  int nXCells1, nYCells1;

  ifstream gridf(gridFileName, ios::in);

  gridf >> nXCells >> nYCells;

  nXCells1 = nXCells+1;
  nYCells1 = nYCells+1;

  mx = new float [nXCells1];
  my = new float [nYCells1];
  mz = new float* [nXCells1];
  for(i=0; i<nXCells1; i++) {
	mz[i] = new float [nYCells1];
  }
  tx = new float [nXCells1];
  ty = new float [nYCells1];

  for(i=0; i<nXCells1; i++) {
	for(j=0; j<nYCells1; j++) {
		gridf >> mx[i] >> my[j] >> mz[i][j];
		gridf >> tx[i] >> ty[j];
	}
  }

  gridf.close();
}

vector
CGrid::getVertex(int iy, int ix)
{
  float x, y, z;
  vector retvert;

  x = getmx(ix);
  y = getmy(iy);
  z = getmz(iy,ix);
  retvert = vector (x, y, z);

  return retvert;
}
