/******************************************************************************

This software module was originally developed by
        Wei Wu (weiwu@stallion.risc.rockwell.com),  Rockwell Science Center
in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in
hardware or software products claiming conformance to the MPEG-4 Video. Those
intending to use this software module in hardware or software products are advised
that its use may infringe existing patents. The original developer of this software
module and his/her company, the subsequent editors and their companies, and ISO/IEC
have no liability for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Video conforming
products. Rockwell Science Center retains full right to use the code for his/her own
purpose, assign or donate the code to a third party and to inhibit third parties from
using the code for non <MPEG standard> conforming products. This copyright notice
must be included in all copies or derivative works. Copyright (c) 1997.

******************************************************************************/

#ifndef __vd_grid_
#define __vd_grid_

#include "vd_vector.h"

class CGrid {
public:
	CGrid(const char *);
	~CGrid();
	int getXCells() { return nXCells;}
	int getYCells() { return nYCells;}
	float getmx(int ix) { return mx[ix];}
	float getmy(int iy) { return my[iy];}
	float getmz(int iy, int ix) { return mz[ix][iy];}
	float gettx(int ix) { return tx[ix];}
	float getty(int iy) { return ty[iy];}
	vector getVertex(int iy, int ix);
private:
	int nXCells, nYCells;
	float *mx, *my, **mz;
	float *tx, *ty;
};
#endif
