/******************************************************************************

This software module was originally developed by
        Stefan HORBELT (horbelt@desun1.epfl.ch) LTS-EPFL
        Frederic JORDAN (jordan@ltssg3.epfl.ch) LTS-EPFL
        Wei Wu (weiwu@stallion.risc.rockwell.com),  Rockwell Science Center
in the course of development of the MPEG-4 Video (ISO/IEC 14496-2).
This software module is an implementation of a part of one or more MPEG-4 Video
tools as specified by the MPEG-4 Video. ISO/IEC gives users of the MPEG-4 Video
free license to this software module or modifications thereof for use in
hardware or software products claiming conformance to the MPEG-4 Video. Those
intending to use this software module in hardware or software products are advised
that its use may infringe existing patents. The original developer of this software
module and his/her company, the subsequent editors and their companies, and ISO/IEC
have no liability for use of this software module or modifications thereof in animplementation. Copyright is not released for non MPEG-4 Video conforming
products. LTS-EPFL and Rockwell Science Center retains full right to use the
code for his/her own
purpose, assign or donate the code to a third party and to inhibit third parties from
using the code for non <MPEG standard> conforming products. This copyright notice
must be included in all copies or derivative works. Copyright (c) 1997.

******************************************************************************/

#include "vd_vector.h"

#ifndef	PROJECTOR
#define PROJECTOR

class projector
{

protected:
	vector		vpos;	
	vector		vdir;
	double		alpha;
    	double		dist;
	double		beta;

private:
	vector	vec(vector v0, vector v1);
	c_type	scal_prod (vector v0, vector v1);
	vector	vect_prod (vector v0, vector v1);
	c_type	norm (vector v0);
		
public:
	projector		(vector p, vector d);
	void	triangle	(vector v0, vector v1, vector v2);
	void	triangle	(vector v0, vector v1, vector v2, vector center);
	void	quad		(vector v0, vector v1, vector v2, vector v3);
	void	quad		(vector v0, vector v1, vector v2, vector v3,  int pers);
	void	persp_quad	(vector v0, vector v1, vector v2, vector v3);
	double	clip_angle	(vector c);
        int     in_fov          (vector c0, vector c1, vector c2, vector c3,
				 double fov,  double w_over_h,  vector vup);
        double  plane_angle     (vector p,  vector c);
	double	alpha_val();
	double	dist_val();
	double	beta_val();
	double  cal_dist(vector v0, vector v1, vector v2, vector v3);
		


};



#endif
